﻿<%@ Page Language="C#" AutoEventWireup="true" Inherits="Attach" MasterPageFile="~/UserMasterPage.master" CodeBehind="Attach.aspx.cs" meta:resourcekey="PageResource1" %>

<%@ Import Namespace="enzigma.sforce.webapp.code" %>
<%@ Register Assembly="enzigma.controls" Namespace="enzigma.web.controls" TagPrefix="cc1" %>

<asp:Content ID="AttachPage" ContentPlaceHolderID="PageContent" runat="server">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="../css/vendor/slds/assets/styles/salesforce-lightning-design-system.min.css" rel="stylesheet" />
    <script src="../scripts/common.js" type="text/javascript" charset="utf-8"></script>
    <asp:ScriptManager ID="ScriptManager" runat="server">
        <Services>
            <asp:ServiceReference InlineScript="false" Path="~/WebServices/FTPAttachments.asmx" />
        </Services>
    </asp:ScriptManager>

    <style>
        .set-color {
            color: white;
        }

        .setErrorClass {
            color: red;
        }
    </style>
    <input type="hidden" id="hdnServerProfile" runat="server" />
    <input type="hidden" id="hdnUploadID" runat="server" />
    <asp:HiddenField ID="ParentFileName" runat="server"></asp:HiddenField>
    <div class="slds-scope">
        <%-- <div class="slds-brand-band slds-brand-band_cover slds-brand-band_medium" style="background-repeat: repeat-x; background-image: url('../css/vendor/slds/assets/images/themes/oneSalesforce/banner-brand-default.png'), linear-gradient(to top, rgb(152, 180, 212),rgb(72, 126, 176));">--%>
        <div class="slds-p-around_small">
            <div class="slds-page-header">
                <div class="slds-grid">
                    <div class="slds-col slds-has-flexi-truncate">
                        <div class="slds-media slds-no-space slds-grow">
                            <div class="slds-media__figure">
                                <span class="slds-icon_container slds-icon-standard-opportunity" title="Attachment">
                                    <svg class="slds-icon slds-page-header__icon slds-p-around--xx-small" aria-hidden="true">
                                        <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#attach" />
                                    </svg>
                                </span>
                            </div>
                            <div runat="server" id="tdTitle" style="display: none;" class="slds-media__body">
                                <nav>
                                    <ol class="slds-breadcrumb slds-line-height_reset">
                                        <ul class="slds-breadcrumb__item">
                                            <%--<span>Attach File</span>--%>
                                              <asp:Label ID="AttachFileLabel" runat="server" Text="Attach File" meta:resourcekey="AttachFileLabel"></asp:Label>
                                        </ul>
                                    </ol>
                                </nav>
                                <b>
                                <asp:Label runat="server" CssClass="slds-page-header__title slds-m-right_small slds-align-middle slds-truncate" title=""  meta:resourcekey="AddFileToServer" Text="Add an attachment to server"></asp:Label></b>
                            </div>

                            <div runat="server" id="UpdateAttachment" style="display: none;" class="slds-media__body">
                                <nav>
                                    <ol class="slds-breadcrumb slds-line-height_reset">
                                        <ul class="slds-breadcrumb__item">
                                            <span>Update Attachment</span>
                                        </ul>
                                    </ol>
                                </nav>
                                <h1 class="slds-page-header__title slds-m-right_small slds-align-middle slds-truncate" title="">Update an attachment to server</h1>
                            </div>
                        </div>
                    </div>
                    <div class="slds-col slds-no-flex slds-grid slds-align-top">
                    </div>
                </div>
                
                <div class="slds-grid slds-page-header__detail-row">
                    <div class="slds-grid slds-wrap slds-p-around--small">
                        <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                            <asp:Label ID="Instruction" runat="server"
                    Text="Select a file you want to upload using &quot;Browse&quot; button, once file is uploaded successfully close this window and refresh the parent window. Newly created attachment will appear in the FTP Attachments related list."
                    meta:resourcekey="InstructionForFileAttach"></asp:Label>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="slds-p-horizontal_small slds-p-bottom--small">
            <div class="slds-card">
                <div class="slds-media__body"></div>
                <div class="slds-card__body slds-card__body--inner">
                    <div class="errorMessage">
                        <div id="tableLogin">

                            <!-- pannel -->
                            <div class="slds-grid slds-wrap slds-p-top_small">
                                <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                                    <asp:Panel ID="panelMessage" runat="server" Height="50px" HorizontalAlign="Center" Visible="False" meta:resourcekey="panelMessageResource1">
                                        The file
                                            <%=buttonAttachment.ClientID%> you are trying to attach is already attached to this record. Do you want to update existing attachment?
                                                <br />
                                        <cc1:ImageButton ID="btnYes" runat="server" OnClick="btnYes_Click" Text="Yes" Width="40px" meta:resourcekey="btnYesResource1" />
                                        <cc1:ImageButton ID="btnNo" runat="server" OnClick="btnNo_Click" Text="No" Width="40px" meta:resourcekey="btnNoResource1" />
                                        <br />
                                    </asp:Panel>
                                </div>
                            </div>
                            <div class="slds-grid slds-wrap">
                                <asp:Panel ID="panelDefault" runat="server" Width="100%" meta:resourcekey="panelDefaultResource1">
                                    <div id="tableMain">
                                        <div class="slds-p-around--small">
                                            <div class="slds-box">
                                                <div class="slds-grid slds-wrap">
                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-4 slds-large-size_1-of-4">
                                                        <div class="slds-media">
                                                            <div class="slds-media__figure">
                                                                <span class="slds-icon_container" style="background-color: #b19f7e;" title="Profile Server and Comment">
                                                                    <svg class="slds-icon slds-page-header__icon slds-p-around--xx-small" aria-hidden="true">
                                                                        <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#comments" />
                                                                    </svg>
                                                                </span>
                                                                <span>
                                                                    <b>
                                                                        <asp:Label ID="Label4" runat="server" CssClass="slds-text-heading--small" Text="Profile and Comment" meta:resourcekey="ChatBox"></asp:Label></b>
                                                                </span>
                                                            </div>
                                                        </div>
                                                    </div>

                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2 slds-align_absolute-center">
                                                        <div class="demo-only slds-scrollable--x" runat="server" id="toastWarnID" style="height: 4rem; display: none;">
                                                            <div class="slds-notify_container slds-is-relative">
                                                                <div class="slds-notify slds-notify_toast slds-theme_alert-texture slds-theme_warning" role="alert">
                                                                    <span class="slds-assistive-text">warning</span>
                                                                    <span class="slds-icon_container slds-icon-utility-warning slds-m-right_small slds-no-flex slds-align-top" title="Warning">
                                                                        <svg class="slds-icon slds-icon_small" aria-hidden="true">

                                                                            <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#warning" />
                                                                        </svg>
                                                                    </span>
                                                                    <div class="slds-notify__content">
                                                                        <h2 class="slds-text-body_regular">
                                                                            <asp:Label ID="lbWarnMesaage" runat="server"></asp:Label></h2>
                                                                    </div>
                                                                    <%--<button class="slds-button slds-button_icon slds-notify__close slds-button_icon-inverse" title="Close" onclick="return hideToast('warnning')">
                                                                        <svg class="slds-button__icon slds-button__icon_large" aria-hidden="true">

                                                                            <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#close" />
                                                                        </svg>
                                                                        <span class="slds-assistive-text">Close</span>
                                                                    </button>--%>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-4 slds-large-size_1-of-4"></div>
                                                </div>
                                                <div class="slds-grid slds-wrap">
                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-4 slds-large-size_1-of-4"></div>
                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2 slds-align-center slds-scrollable--x">
                                                        <div runat="server" id="toast" style="width:10px; display: none;">
                                                            <div class="demo-only">
                                                                <div class="slds-notify_container slds-is-relative">
                                                                    <div class="slds-notify slds-notify_toast slds-theme_error" role="alert">
                                                                        <span class="slds-assistive-text">error</span>
                                                                        <span class="slds-icon_container slds-icon-utility-info slds-m-right_small slds-no-flex slds-align-top" title="Description of icon when needed">
                                                                            <svg class="slds-icon slds-icon_small" aria-hidden="true">
                                                                                <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#error" />
                                                                            </svg>
                                                                        </span>
                                                                        <div class="slds-notify__content">
                                                                            <h2 class="slds-text-body_regular ">
                                                                                <span>
                                                                                    <asp:Label ID="lbError" runat="server" meta:resourcekey="lbErrorResource1"></asp:Label></span>
                                                                                <span>
                                                                                    <asp:Label ID="errorMessage" runat="server" Text=""></asp:Label>
                                                                                </span>
                                                                                <p>
                                                                                    <asp:CustomValidator ID="CustomValidator2" runat="server" CssClass="slds-text-color_inverse" ClientValidationFunction="CheckIfExists" ControlToValidate="fileUpload" Display="Dynamic" ErrorMessage="File name already exists." meta:resourcekey="custCheckIfExistsResource1"></asp:CustomValidator>
                                                                                </p>
                                                                                <p>
                                                                                    <asp:CustomValidator ID="custFileNameChkIfAllowed" runat="server" ClientValidationFunction="CheckIfCharactersAllowed" ControlToValidate="fileUpload" Display="Dynamic" CssClass="slds-text-color_inverse" ErrorMessage="Invalid characters found in the file name. Only characters allowed in the file name are " meta:resourcekey="custFileNameChkIfAllowedResource1"></asp:CustomValidator>
                                                                                </p>
                                                                                <p>
                                                                                    <asp:CustomValidator ID="custChkIfAllowed" runat="server" ClientValidationFunction="CheckIfAllowed" ControlToValidate="fileUpload" Display="Dynamic" CssClass="slds-text-color_inverse" ErrorMessage="Attachment with this extension is not allowed to upload." meta:resourcekey="custChkIfAllowedResource1"></asp:CustomValidator>
                                                                                </p>
                                                                            </h2>
                                                                        </div>
                                                                        <button class="slds-button slds-button_icon slds-notify__close slds-button_icon-inverse" title="Close" onclick="return hideToast('error')">
                                                                            <svg class="slds-button__icon slds-button__icon_large" aria-hidden="true">
                                                                                <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#close" />
                                                                            </svg>
                                                                            <span class="slds-assistive-text">Close</span>
                                                                        </button>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-4 slds-large-size_1-of-4"></div>
                                                </div>

                                                <div class="slds-grid slds-wrap">
                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-4 slds-large-size_1-of-4"></div>
                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2 slds-align_absolute-center slds-scrollable--x">
                                                        <div id="toastSuccess" style="display: none;">
                                                            <div class="demo-only">
                                                                <div class="slds-notify_container slds-is-relative">
                                                                    <div class="slds-notify slds-notify_toast slds-theme_success" role="alert">
                                                                        <span class="slds-assistive-text">success</span>
                                                                        <span class="slds-icon_container slds-icon-utility-info slds-m-right_small slds-no-flex slds-align-top" title="Description of icon when needed">
                                                                            <svg class="slds-icon slds-icon_small" aria-hidden="true">
                                                                                <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#success" />
                                                                            </svg>
                                                                        </span>
                                                                        <div class="slds-notify__content">
                                                                            <span>
                                                                                <asp:Label ID="successMessage" runat="server" Text=""></asp:Label></span>
                                                                        </div>
                                                                        <button class="slds-button slds-button_icon slds-notify__close slds-button_icon-inverse" title="Close" onclick="return hideToast('success')">
                                                                            <svg class="slds-button__icon slds-button__icon_large" aria-hidden="true">
                                                                                <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#close" />
                                                                            </svg>
                                                                            <span class="slds-assistive-text">Close</span>
                                                                        </button>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-4 slds-large-size_1-of-4"></div>
                                                </div>

                                                <div class="slds-grid slds-wrap slds-p-top_small">

                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2">
                                                        <div runat="server" id="rowServerProfiles" visible="False" class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2 slds-p-right_xx-large">
                                                            <div class="slds-form-element">
                                                                <span class="slds-form-element__label">
                                                                    <asp:RequiredFieldValidator CssClass="slds-text-color_error" ID="RequiredFieldValidator3" runat="server" ControlToValidate="cmbServerProfiles" Display="Dynamic" ErrorMessage="*">
                                                                    </asp:RequiredFieldValidator>
                                                                    <asp:Label ID="ServerProfile" runat="server" Text="Server Profile" meta:resourcekey="ServerProfileResource1"></asp:Label></span>
                                                                <div class="slds-form-element__control">
                                                                    <asp:DropDownList ID="cmbServerProfiles" runat="server" CssClass="slds-select" OnSelectedIndexChanged="cmbServerProfiles_SelectedIndexChanged" AutoPostBack="false"></asp:DropDownList>
                                                                    <asp:CustomValidator ID="CustomValidator5" runat="server" ClientValidationFunction="GetServerProfile" ControlToValidate="cmbServerProfiles" ErrorMessage="Specified server profile not found"></asp:CustomValidator>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div runat="server" id="rowSelectedProfile" visible="False" class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2 slds-p-right_xx-large">
                                                           <div class="slds-form-element">
                                                                <span class="slds-form-element__label">
                                                                    <asp:Label ID="SelectedProfile" runat="server" Text="Selected Profile" meta:resourcekey="SelectedProfile"></asp:Label></span>
                                                                <div class="slds-form-element__control">
                                                                    <asp:Label ID="lbSelectedProfile" runat="server" meta:resourcekey="SelectedProfileName" Text="Default"></asp:Label>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>



                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2 slds-p-right_xx-large">
                                                        <div class="slds-form-element">
                                                            <span class="slds-form-element__label">
                                                                <asp:Label ID="Label5" runat="server" SkinID="Label" Text="Comment" meta:resourcekey="Label1Resource1"></asp:Label></span>
                                                            <div class="slds-form-element__control">
                                                                <asp:TextBox CssClass="slds-textarea" ID="edComment" runat="server" TextMode="MultiLine" MaxLength="255" meta:resourcekey="edCommentResource1"></asp:TextBox>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>


                                                <div class="slds-grid slds-wrap slds-p-top_small">

                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2 slds-p-top_medium slds-p-right_xx-large">
                                                        <div class="demo-only">
                                                            <div class="slds-form-element">
                                                                <span class="slds-form-element__label" id="file-selector-primary-label"></span>
                                                                <%--  <asp:Label ID="Label6" runat="server" SkinID="Label" Text="Upload file" meta:resourcekey="lbFileResource1"></asp:Label></span>--%>
                                                                <div class="slds-file-selector slds-file-selector_files">
                                                                    <asp:FileUpload ID="fileUpload" runat="server" size="" meta:resourcekey="fileUploadResource1" CssClass="slds-file-selector__input slds-assistive-text" aria-labelledby="file-selector-primary-label file-selector-secondary-label" />
                                                                    <label class="slds-file-selector__body" for="<%=fileUpload.ClientID%>" id="file-selector-secondary-label" meta:resourcekey="lbFileResource1">
                                                                        <span class="slds-file-selector__button slds-button slds-button_neutral">
                                                                            <svg class="slds-button__icon slds-button__icon_left" aria-hidden="true">
                                                                                <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#upload" />
                                                                            </svg>Upload File</span>
                                                                    </label>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="slds-grid slds-wrap">
                                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_2-of- slds-large-size_1-of-2">
                                                                <span>
                                                                    <asp:Label ID="lbMaxSize" runat="server" meta:resourcekey="lbMaxSizeResource1" CssClass="slds-form-element__label" ForeColor="red"></asp:Label></span>
                                                            </div>
                                                        </div>
                                                        <div class="slds-grid slds-wrap slds-p-top_x-small">
                                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1 slds-p-right_xx-large">
                                                                <span id="fileName" class="slds-file-selector__text"></span>
                                                            </div>
                                                        </div>
                                                    </div>

                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2">
                                                        <div id="ProgressBarHide" style="display: none">
                                                            <div class="slds-grid slds-wrap slds-p-top_small">
                                                                <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1 slds-p-top_medium">
                                                                    <cc1:ProgressBar ID="uploadAppProgress" CssClass="ProgressBar slds-progress-bar slds-progress-bar_large" runat="server" Width="100%" DefaultVisible="True" ProgressBarClass="ProgressBarValue" ProgressBarStatusClass="ProgressBarStatus" ProgressBarTextClass="ProgressBarText slds-text-body_small slds-p-top--x-small" StatusLabelText="<%$Resources:ProgressStatus, StatusLabelText %>" ValueLabelText="<%$Resources:ProgressStatus, ValueLabelText %>" TextLabel="<%$Resources:ProgressStatus, TextLabel %>" />
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>

                                                </div>



                                                <div class="slds-grid slds-wrap ">
                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-4 slds-large-size_1-of-4">
                                                        <asp:CheckBox ID="chkIsPublic" runat="server" Text="Is Public?" Visible="False"
                                                            meta:resourcekey="chkIsPublicResource1" />
                                                    </div>
                                                </div>

                                                <div id="divDebug"></div>
                                                <div class="slds-grid slds-wrap slds-p-top_x-small">
                                                    <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1 slds-p-right_xx-large">
                                                        <span class="slds-clearfix slds-float_right">
                                                            <asp:Button ID="buttonAttachment" runat="server" Text="Attach" OnClick="btnAttach_Click" OnClientClick="OnAttach();" CausesValidation="False" meta:resourcekey="btnAttachResource1" CssClass="slds-button slds-button_brand" />
                                                            <asp:button ID="btnCancel" runat="server" text="Done" OnClientClick="OnCancel(); return false;" CssClass="slds-button slds-button_brand slds-clearfix slds-float_right" meta:resourcekey="btnDone"/>
                                                            <!--<button id="rgstr_btn" type="button" class="slds-button slds-button_brand slds-clearfix slds-float_right" onclick="OnCancel()">Done</button> --></span>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <asp:HiddenField ID="hdnOrgID" runat="server" />
                                </asp:Panel>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
         </div>
    </div>
    <script type="text/javascript">  
        /*Toaster changes*/
        $(document).ready(function(){
           <%-- ;
            $('link[href="<%=enzigma.sforce.webapp.code.Global.WebRoot%>css/vendor/bootstrap/bootstrap.min.css"]').remove();--%>
           
            $('link[href="../App_Themes/Default/common.css"]').remove();
            $('#bodyHeight').css('height','100%');
           
            $("#PageContent_fileUpload").change(function(){
                handleFile(this);
            });

            if($('#PageContent_tdTitle').html() ==  "Update Attachment"){
                $('#PageContent_UpdateAttachment').css('display', 'inline-block');
                $('#PageContent_tdTitle').css('display', 'none');
                $('#updatePageHeader').css('display', 'inline-block');
            }
            else{
                $('#PageContent_tdTitle').css('display', 'inline-block');
                $('#PageContent_UpdateAttachment').css('display', 'none');
                $('#updatePageHeader').css('display', 'none');
            }
        });
        var isError=false;
        function hideToast(hideAction) {
            if(hideAction=='warnning'){
                $('#PageContent_toastWarnID').css('display', 'none');
            }   
            else if(hideAction=='error')
            {
                $('#PageContent_toast').css('display', 'none');
                $("#PageContent_fileUpload").val('');
                document.getElementById('fileName').innerHTML="";
                document.getElementById("ProgressBarHide").style.display = "none";
                document.getElementById('PageContent_edComment').value="";
            }
            else{ 
                $('#toastSuccess').css('display', 'none');
                $("#PageContent_fileUpload").val('');
                document.getElementById('fileName').innerHTML="";
                document.getElementById("ProgressBarHide").style.display = "none";
                document.getElementById('PageContent_edComment').value="";
                document.getElementById('PageContent_errorMessage').value="";
            }
            return false;
        }
        
        function OnCancel() {
            var experienceView = 'https://'+ new URLSearchParams(window.location.search).get('SFUrl').split('/')[2] +'/'+new URLSearchParams(window.location.search).get('FieldValue');
            window.open(experienceView, '_self');         
        }

        var filenameforsize="";

        function handleFile(file) {

            isError = false;

            filenameforsize=file;
            document.getElementById('fileName').innerHTML="";
            if(document.getElementById("fileName").innerHTML==""){
                $('#PageContent_toast').css('display', 'none');
            }
          
            if(file.files[file.files.length - 1 ]!=undefined)
                document.getElementById("fileName").innerHTML = file.files[file.files.length - 1 ].name;

            
            var maxFileSizecontent=document.getElementById('PageContent_lbMaxSize').innerHTML;
            var sizeUnit=maxFileSizecontent.match(/MB|GB/);
            var maxFileSize = maxFileSizecontent.match(/[+-]?\d+(?:\.\d+)?/g);
            var filesize=file.files[0].size/(1024*1024);
           
            if(sizeUnit!=null){
                if(sizeUnit[0]=="GB")
                {
                    maxFileSize=maxFileSize*1024;
                }
            }

            if(maxFileSize!=null){
                if(filesize>maxFileSize)
                {
                    document.getElementById('PageContent_errorMessage').innerHTML='File size exceeds allowable limits';
                    $('#PageContent_toast').css('display', 'block');
                    isError=true;
                    return false;
                }}
            var parnetFileName=document.getElementById('<%=ParentFileName.ClientID%>').value;
            var parnetfilepathextension=parnetFileName.split('.').pop();
            var selectedFileName=file.files[0].name;
            var selectedFileNameextension=selectedFileName.split('.').pop();
            if(parnetFileName!="")
            {
                if(parnetfilepathextension!=selectedFileNameextension)
                {
                    document.getElementById('PageContent_errorMessage').innerHTML='Extension of the file you are trying to upload does not match with the attachment. You can upload only same type of document as attachment.';
                    $('#PageContent_toast').css('display', 'block');
                    isError=true;
                    return false;
                }
            }

            document.getElementById("PageContent_uploadAppProgress_Main").style.display = "block"; 
            document.getElementById('PageContent_uploadAppProgress').style.backgroundColor="rgb(221,219,218)";
            document.getElementById('PageContent_uploadAppProgress_Text').innerHTML="0%";
            document.getElementById('PageContent_uploadAppProgress_Status').innerHTML="";
            
        }
       

        function OnAttach()
        {  

            if( Page_ClientValidate() )
            {
                document.getElementById("ProgressBarHide").style.display = "block"; 
                document.getElementById("ProgressBarHide").style.display = "block";    document.getElementById("ProgressBarHide").style.display = "block";  
                document.getElementById("PageContent_uploadAppProgress_Main").style.display = "block";
                var form = document.getElementById('<%=this.Form.ClientID%>');
                if( form )
                {
                    
                    g_bIsUploading = true;
                    form.target = 'frameUpload';
                    g_bDisplayError = true;
                    var iFound = form.action.indexOf('&UploadID=');
                    if( iFound >= 0 )
                    {
                        var iEnd = form.action.indexOf('&', iFound + 1);
                        if( iEnd < 0 )
                            iEnd = form.action.length;
                        var strParam = form.action.substr(iFound, iEnd - iFound);
                        form.action = form.action.replace(strParam, '&UploadID=' + GetUploadID());
                    }
                    else
                        form.action += '&UploadID=' + GetUploadID();

                    //document.getElementById('rowError').style.visibility = 'hidden';
                    document.body.style.cursor = 'wait';
                    var iInterval = 1000 * <%=Global.ProgressIndicatorInterval%>;
                    if( iInterval <= 0 )
                        iInterval = 2000;
				    
                    
                    g_intervalProgress = window.setInterval('RetreiveProgress()', iInterval);
                    window.setTimeout("document.getElementById('<%=buttonAttachment.ClientID%>').disabled = true;", 100);
				
                    var lbCustomValidator2 = document.getElementById('PageContent_CustomValidator2');
                    var lbcustFileNameChkIfAllowed = document.getElementById('PageContent_custFileNameChkIfAllowed');

                    if(lbCustomValidator2.style.display != 'none' || lbcustFileNameChkIfAllowed.style.display != 'none')
                        $('#PageContent_toast').css('display', 'inline-block');
                    return;
                }
            }
            else
            {
                if( window.event )
                    window.event.cancelBubble = true;
            }
           
            return false;
        }
        var g_bDisplayError = false;
        function OnIFrameLoaded()
        {   
          
            if( g_bDisplayError )
            {
                g_bDisplayError = false;
                RetreiveProgress();
                var frameUpload = document.getElementById('frameUpload');
                var lbError = document.getElementById('<%=lbError.ClientID%>');
                lbError.innerHTML = frameUpload.contentWindow.document.body.innerHTML;
                if(lbError.innerHTML != '')
                {
                    if(document.getElementById('server_version'))
                    {
                        var error = document.getElementById('server_version').innerHTML;
                        if(error != '' && error == '<p>Internet Information Services 7.5</p>')
                            lbError.innerHTML = 'You have exceeded the Max File Size Limit. ASP.Net supports a Maximum File Size upto 2GB.';
                    }
                }
                //document.getElementById('rowError').style.visibility = 'visible';
                OnUploadCompleted();
            }
        }
	
        function OnUploadCompleted()
        {   
         
            window.clearInterval(g_intervalProgress);
            var strOrgID = document.getElementById('<%=hdnOrgID.ClientID%>').value;
            service.GetUploadInfoID(strOrgID, OnSetUploadID);
            g_bIsUploading = false;
            document.body.style.cursor = 'default';
           <%-- document.getElementById('<%=this.Form.ClientID%>').reset();--%>
        }
        window.resizeTo(1000,730);
        window.moveTo(window.screen.width/2 - 350, window.screen.height/2 - 300);

        function OnSetUploadID(result)
        {
            document.getElementById('<%=hdnUploadID.ClientID%>').value = result;
        }
	
        function GetUploadID()
        {
            return document.getElementById('<%=hdnUploadID.ClientID%>').value;
        }
	
        var service = new enzigma.sforce.webapp.webservices.InternalFTPAttachmentsService();
        var strOrgID = document.getElementById('<%=hdnOrgID.ClientID%>').value;
        service.GetUploadInfoID(strOrgID, OnSetUploadID);
        function UpdateProgress(result, eventArgs)
        {   
            if(result.Progress > 0)
                $('.ProgressBarValue').css("background-color", "#5eb4ff"); 
            var divDebug = document.getElementById('divDebug');		
            if( <%=uploadAppProgress.ClientID%>_obj )
            {
                <%=uploadAppProgress.ClientID%>_obj.UpdateProgress(result.Progress, result.ProgressStatus);
                <%=uploadAppProgress.ClientID%>_obj.EnsureVisible();
            }
		
            if( result.HasCompleted || result.HasError || result.IsCached )
            {   
                OnUploadCompleted();
                var isSet=false;
             
                  if(result.ProgressStatus){
                        isSet=true;
                   }
                let str = result.ProgressStatus;
                if (str.includes("[FIELD_CUSTOM_VALIDATION_EXCEPTION]")) {
                    isSet = false;
                }

                // if(result.ProgressStatus =="文件附加成功")                                                  //   language changes 
                if(isSet)
                {
                   
                    $('#<%= successMessage.ClientID %>').text(result.ProgressStatus);
                    document.getElementById('PageContent_lbError').innerHTML="";
                    $('#toastSuccess').css('display', 'inline-block');
                    setTimeout(function(){hideToast('success') }, 10000);
                    $('#PageContent_toast').css('display', 'none');
                   
                    document.getElementById("ProgressBarHide").style.display = "none";
                    isSet=false;
                }
                else if(result.ProgressStatus == "Determining Server Profile"){
                    if(document.getElementById('PageContent_lbError').innerHTML!="")
                    {
                        document.getElementById('PageContent_errorMessage').innerHTML="";
                      
                        $('#toastSuccess').css('display', 'none');
                        $('#PageContent_toast').css('display', 'inline-block');
                    }
                    else{
                        $('#<%= errorMessage.ClientID %>').text("Extension of the file you are trying to upload does not match with the attachment");
                        $('#toastSuccess').css('display', 'none');
                        $('#PageContent_toast').css('display', 'inline-block');
                    }
                }
                else{
                    $('#<%= errorMessage.ClientID %>').text(result.ProgressStatus);
                    $('#<%= lbError.ClientID %>').css('display', 'none');
                    $('#toastSuccess').css('display', 'none');
                    document.getElementById("ProgressBarHide").style.display = "none";
                    $('#PageContent_toast').css('display', 'inline-block');
                }     
        }
    }
	
    function OnError(error)
    {
        var lbError = document.getElementById('<%=lbError.ClientID%>');
        lbError.innerHTML = error.get_message();
    }
	
    function RetreiveProgress()
    {
       
        service.UploadProgress( GetUploadID(), UpdateProgress, OnError);
    }
	
    var g_fileValidator = false;
    var g_serverProfileValidator = false;
    var g_bError = false;
    function UpdateFileValidator(result)
    {  
       
        if( !g_bIsUploading && !g_bError && !isError)
        {
          
            g_fileValidator.isvalid = !result;
            ValidatorUpdateDisplay(g_fileValidator);
          
            document.getElementById('<%=buttonAttachment.ClientID%>').disabled = result;			
            g_bError = result;
            var lbCustomValidator2 = document.getElementById('PageContent_CustomValidator2');
            if(lbCustomValidator2.style.display != 'none'){
                isError = true;
                document.getElementById('PageContent_errorMessage').innerHTML='';
                $('#PageContent_toast').css('display', 'inline-block');

            }
            else {
                isError = false;
            }
        }
        
    }
		
   
    function OnServerProfileReteived(result)
    {
        
        
        if( result )
        {
            var lbMaxSize = document.getElementById('<%=lbMaxSize.ClientID%>');
            
            lbMaxSize.innerHTML = result;
            
            var maxFileSizecontent=document.getElementById('PageContent_lbMaxSize').innerHTML;
            var sizeUnit=maxFileSizecontent.match(/MB|GB/);
            var maxFileSize = maxFileSizecontent.match(/[+-]?\d+(?:\.\d+)?/g);

            if(filenameforsize!=""){
                var filesize=filenameforsize.files[0].size/(1024*1024);
            
                if(sizeUnit[0]=="GB")
                {
                    maxFileSize=maxFileSize*1024;
                }
            
                if(filesize>maxFileSize)
                {
                    document.getElementById('PageContent_errorMessage').innerHTML='File size exceeds allowable limits';
                    $('#PageContent_toast').css('display', 'block');
                    isError=true;
                    return false;
                }

            }
        }
        else
        {
            g_serverProfileValidator.isvalid = false;
            ValidatorUpdateDisplay(g_serverProfileValidator); 
        }
    }
	
    function CheckIfExists(val, args)
    {  
        g_fileValidator = val;
        service.CheckIfFileExists(document.location.search, args.Value, UpdateFileValidator, OnError);
        if( <%=uploadAppProgress.ClientID%>_obj )
            <%=uploadAppProgress.ClientID%>_obj.Hide();
    }
	
    function OnErrorChk(error)
    {	   
    }
    var g_Validator = false;
    function UpdateValidator(result)
    { 
       
        if( !g_bIsUploading && !isError)
        {
            g_Validator.isvalid = !result;
         
            ValidatorUpdateDisplay(g_Validator);
        
            document.getElementById('<%=buttonAttachment.ClientID%>').disabled = result;
            g_bError = result;
            var lbcustFileNameChkIfAllowed = document.getElementById('PageContent_custFileNameChkIfAllowed');
            var lblCheckIfAllowed = document.getElementById('PageContent_custChkIfAllowed');
    
            if(lbcustFileNameChkIfAllowed.style.display != 'none' || result)
            {
                document.getElementById('PageContent_errorMessage').innerHTML='';
                lbcustFileNameChkIfAllowed.style.display='inline-block';
                lblCheckIfAllowed.style.display='none';
              
                isError = true;
                $('#PageContent_toast').css('display', 'inline-block');
            }
            else {
                isError = false;
                
            }
        }
    }

    function UpdateValidatorExe(result)
    {
        if( !g_bIsUploading && !isError)
        {
            g_Validator.isvalid = !result;
           
            ValidatorUpdateDisplay(g_Validator);
            document.getElementById('<%=buttonAttachment.ClientID%>').disabled = result;
            g_bError = result;
            var lblCheckIfAllowed=document.getElementById('PageContent_custChkIfAllowed');
            if(lblCheckIfAllowed.style.display != 'none')
            {
                isError = true;
                document.getElementById('PageContent_errorMessage').innerHTML='';
                $('#PageContent_toast').css('display', 'inline-block');
            }
            else{
                isError = false;
            }
        }
    }
	
     function CheckIfAllowed(val, args) {
        g_Validator = val;
        var strOrgID = document.getElementById('<%=hdnOrgID.ClientID%>').value;
        var fileSettings = {};
        fileSettings.Characters = '<%=fileSettings.Characters%>';
        fileSettings.CharacterAllowDeny = '<%=fileSettings.CharacterAllowDeny%>';
        fileSettings.Extensions = '<%=fileSettings.Extensions%>';
        fileSettings.ExtensionAccess = '<%=fileSettings.ExtensionAccess%>';
        fileSettings.IsDuplicateFileNameAllowed = '<%=fileSettings.IsDuplicateFileNameAllowed%>';
        service.CheckIfExtensionAllowed(strOrgID,args.Value,fileSettings,UpdateValidatorExe,OnErrorChk);
        if( <%=uploadAppProgress.ClientID%>_obj )
            <%=uploadAppProgress.ClientID%>_obj.Hide();
    }
	
    function CheckIfCharactersAllowed(val, args)
    {
        g_Validator = val;
        var strOrgID = document.getElementById('<%=hdnOrgID.ClientID%>').value;
        var fileSettings = {};
        fileSettings.Characters = '<%=fileSettings.Characters%>';
        fileSettings.CharacterAllowDeny = '<%=fileSettings.CharacterAllowDeny%>';
        fileSettings.Extensions = '<%=fileSettings.Extensions%>';
        fileSettings.ExtensionAccess = '<%=fileSettings.ExtensionAccess%>';
        fileSettings.IsDuplicateFileNameAllowed = '<%=fileSettings.IsDuplicateFileNameAllowed%>';
        service.CheckIfFileNameAllowed(strOrgID,args.Value,fileSettings,UpdateValidator,OnErrorChk);
        if( <%=uploadAppProgress.ClientID%>_obj )
            <%=uploadAppProgress.ClientID%>_obj.Hide();
    }

    function GetServerProfile(val, args)
    {
        var strUploadID = document.getElementById('<%=hdnUploadID.ClientID%>').value;
        g_serverProfileValidator = val;
        if( args.Value )
            service.GetServerProfileMaxSize( strUploadID, args.Value, OnServerProfileReteived);
    }	 
	
    function ClearAllIntervals()
    {
        window.clearInterval(g_intervalProgress);
    }
    var g_intervalProgress = false;
    var g_bIsUploading = false;
    document.getElementById('<%=buttonAttachment.ClientID%>').disabled = true;
        RegisterWindowEventHandler('unload', ClearAllIntervals);
        $('.ProgressBarValue').css("background-color", "#dddbda"); 

    </script>
    <iframe name="frameUpload" id="frameUpload" style="border: none" width="0" height="0" onload="OnIFrameLoaded()"></iframe>
</asp:Content>
