<%@ Page Language="C#" AutoEventWireup="true"
    Inherits="EmailSalesforceUserSetup" MasterPageFile="~/MasterPage.master" CodeBehind="EmailSalesforceUserSetup.aspx.cs" %>

<%@ Register Assembly="enzigma.controls" Namespace="enzigma.controls.web" TagPrefix="cc2" %>

<%@ Register Assembly="enzigma.controls" Namespace="enzigma.web.controls" TagPrefix="cc1" %>
<%@ Register Assembly="System.Web.Extensions" Namespace="System.Web.UI" TagPrefix="asp" %>
<asp:Content ID="Content1" ContentPlaceHolderID="PageContent" runat="server">
    <style>
        .padding-grid{
            padding-right: 157px;
        } 
    </style>
    <script src="../../scripts/jquery-3.6.0.min.js"></script>

    <script type="text/javascript">
        $(document).ready(function () {
            $('link[href="../../App_Themes/Default/common.css"]').remove();
        });

        function hideToast() {
            $('#PageContent_toast').css('display', 'none');
            $('#PageContent_toastError').css('display', 'none');
            document.getElementById('<%=lbSfUserError.ClientID%>').value = "";
            document.getElementById('<%=lblError.ClientID%>').value = "";
            return false;
        }
    </script>

    <asp:ScriptManager ID="ScriptManager" runat="server">
    </asp:ScriptManager>
    <div class="slds-scope">
        <div class="slds-p-around_small">
            <div class="slds-page-header">
                <div class="slds-grid">
                    <div class="slds-col slds-has-flexi-truncate">
                        <div class="slds-media slds-no-space slds-grow">
                            <div class="slds-media__figure">
                                <span class="slds-icon_container slds-icon-standard-opportunity" title="Salesforce Email Setup">
                                    <svg class="slds-icon slds-page-header__icon slds-p-around--xx-small" aria-hidden="true">
                                             <use xlink:href="../../css/vendor/slds/assets/icons/Utility-sprite/svg/symbols.svg#settings" class="slds-p-around_small"></use>
                                        </svg>
                                </span>
                            </div>
                            <div class="slds-media__body">
                                <nav>
                                        <ol class="slds-breadcrumb slds-line-height_reset">
                                            <ul class="slds-breadcrumb__item">
                                                <span>Salesforce Email Setup</span>
                                            </ul>
                                        </ol>
                                    </nav>
                                <h1 class="slds-page-header__title slds-m-right_small slds-align-middle slds-truncate" title="">Salesforce user for Send Email feature of FTP Attachments Pro</h1>
                            </div>
                        </div>
                    </div>
                    <div class="slds-col slds-no-flex slds-grid slds-align-top">
                    </div>
                </div>
                <div class="slds-grid slds-page-header__detail-row">
                    <div class="slds-grid slds-wrap slds-p-around--small">
                        <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                            <p>
                                Please enter a valid Salesforce User credentials who has rights to view all the
								FTP Attachments in the Salesforce account of yours.
                            </p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="slds-p-horizontal_small slds-p-bottom--small">
            <div class="slds-card">
                <div class="slds-media__body"></div>
                <div class="slds-card__body slds-card__body--inner slds-p-top--small">
                    <div class="slds-box">
                        <div class="slds-media slds-p-bottom--small">
                            <div class="slds-media__figure">
                                <h2 class="slds-text-heading--small">
                                    <span class="slds-text-heading_small slds-text-color--default">
                                        <b>Salesforce Email Setup</b></span>
                                </h2>
                            </div>

                        </div>
                        <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1 slds-align_absolute-center">
                            <div runat="server" id="toast" class="slds-scrollable" style="display: none;">
                                <div class="demo-only">
                                    <div class="slds-notify_container slds-is-relative">
                                        <div class="slds-notify slds-notify_toast slds-theme_success" role="alert">
                                            <span class="slds-assistive-text">success</span>
                                            <span class="slds-icon_container slds-icon-utility-info slds-m-right_small slds-no-flex slds-align-top" title="Description of icon when needed">
                                                <svg class="slds-icon slds-icon_small" aria-hidden="true">
                                                               <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#success" />
                                                           </svg>
                                            </span>
                                            <div class="slds-notify__content">
                                                 <h2 class="slds-text-body_regular">
                                                <asp:Label ID="lbSfUserError" runat="server" Width="100%"></asp:Label></h2>
                                            </div>
                                            <button class="slds-button slds-button_icon slds-notify__close slds-button_icon-inverse" title="Close" id="btnClose" onclick="return hideToast()">
                                                <svg class="slds-button__icon slds-button__icon_large" aria-hidden="true">
                                                                <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#close" />
                                                </svg>
                                                <span class="slds-assistive-text">Close</span>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div id="toastError" class="slds-scrollable" style="display: none;" runat="server">
                                <div class="demo-only">
                                    <div class="slds-notify_container slds-is-relative">
                                        <div class="slds-notify slds-notify_toast slds-theme_error" role="alert">
                                            <span class="slds-assistive-text">error</span>
                                            <span class="slds-icon_container slds-icon-utility-info slds-m-right_small slds-no-flex slds-align-top" title="Description of icon when needed">
                                                <svg class="slds-icon slds-icon_small" aria-hidden="true">
                                                                               <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#error" />
                                                </svg>
                                            </span>
                                            <div class="slds-notify__content">
                                                 <h2 class="slds-text-body_regular">
                                                <asp:Label ID="lblError" runat="server" ></asp:Label></h2>
                                            </div>
                                            <button class="slds-button slds-button_icon slds-notify__close slds-button_icon-inverse" title="Close" id="btnClose" onclick="return hideToast()">
                                                <svg class="slds-button__icon slds-button__icon_large" aria-hidden="true">
                                                     <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#close" />
                                                 </svg>
                                                <span class="slds-assistive-text">Close</span>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                        </div>


                        <div class="slds-p-top_small slds-col  slds-small-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_6-of-12 background-body-color--default">
                            <asp:DetailsView ID="detailsViewSalesforce" runat="server" BackColor="White" DataSourceID="odsSalesforce"
                                BorderWidth="1px" BorderStyle="None" BorderColor="#999999" OnItemUpdating="detailsViewSalesforce_ItemUpdating"
                                GridLines="None" CellPadding="0" AutoGenerateRows="False"  Height="50px">
                                <fields>
												<asp:TemplateField SortExpression="Salesforce User Login:" HeaderText="Salesforce User Login:" ItemStyle-CssClass="slds-p-vertical_xx-small">
													<EditItemTemplate>
														<asp:TextBox ID="edSalesforceUserLogin" runat="server" Text='<%# Bind("Login") %>' cssclass="slds-input" font-bold="false"></asp:TextBox>
                                                        <asp:RequiredFieldValidator ID="reqSalesforceUserLogin" runat="server" ControlToValidate="edSalesforceUserLogin" ErrorMessage="Field cant be empty" Display="Dynamic"  CssClass="slds-text-body_regular slds-text-color--error"  Font-Bold="false"></asp:RequiredFieldValidator>
													</EditItemTemplate>
													<InsertItemTemplate>
														<asp:TextBox ID="edSalesforceUserLogin" runat="server" Text='<%# Bind("Login") %>'></asp:TextBox>
														<asp:RequiredFieldValidator ID="reqSalesforceUserLogin" runat="server" ControlToValidate="edSalesforceUserLogin"
															ErrorMessage="Field cant be empty" Display="Dynamic"  CssClass="slds-text-body_regular slds-text-color--error"  Font-Bold="false"></asp:RequiredFieldValidator>
													</InsertItemTemplate>
													<HeaderStyle Wrap="False"></HeaderStyle>
													<ItemTemplate>
														<asp:Label ID="lbSalesforceUserLogin" runat="server" Text='<%# Bind("Login") %>' CssClass="slds-form-element__label" font-bold="false"></asp:Label>
													</ItemTemplate>
													<HeaderTemplate>
														<asp:Label ID="lblLoginHeader" runat="server" Text="Salesforce User Login" CssClass="slds-form-element__label" Font-Bold="false"></asp:Label>
														     <div class="slds-float--right">
                                                        <cc2:help id="Help1" runat="server" helpmessageid="Resources.Help.SalesforceLogin"></cc2:help></div>
													</HeaderTemplate>
												</asp:TemplateField>

												<asp:TemplateField SortExpression="Password" HeaderText="Password:" ItemStyle-CssClass="slds-p-vertical_xx-small">
													<EditItemTemplate>
														<asp:TextBox ID="edPassword" runat="server" Text='<%# Bind("Password") %>' TextMode="Password" CssClass="slds-input slds-m-top--medium" font-bold="false"></asp:TextBox>
														<asp:RequiredFieldValidator ID="reqPassword" runat="server" ControlToValidate="edPassword"
															ErrorMessage="Field cant be empty" Display="Dynamic"  CssClass="slds-text-body_regular slds-text-color--error"  Font-Bold="false"></asp:RequiredFieldValidator>
													</EditItemTemplate>
													<InsertItemTemplate>
														<asp:TextBox ID="edPassword" runat="server" Text='<%# Bind("Password") %>' TextMode="Password" font-bold="false"></asp:TextBox>
														<asp:RequiredFieldValidator ID="reqPassword" runat="server" ControlToValidate="edPassword"
															ErrorMessage="Field cant be empty" Display="Dynamic"  CssClass="slds-text-body_regular slds-text-color--error"  Font-Bold="false"></asp:RequiredFieldValidator>
													</InsertItemTemplate>
													<HeaderStyle Wrap="False"></HeaderStyle>
													<ItemTemplate>
														<asp:Label ID="lbPassword" runat="server" Text="********"></asp:Label>
													</ItemTemplate>
													<HeaderTemplate>
														<asp:Label ID="lblPassword" runat="server" Text="Password" CssClass="slds-form-element__label" Font-Bold="false"></asp:Label>
													     <div class="slds-float--right">
                                                        	<cc2:help id="Help2" runat="server" helpmessageid="Resources.Help.SalesforcePassword"></cc2:help></div>
													</HeaderTemplate>
												</asp:TemplateField>
												<asp:TemplateField ItemStyle-CssClass="slds-p-vertical_xx-small">
													<EditItemTemplate>
                                                          <div class="slds-m-top_medium">
                                                                      <asp:Button ID="btnUpdate" runat="server" Text="Update" SkinID="DefaultButton" CommandName="Update" CssClass="slds-button slds-button--brand slds-m-top_medium"></asp:Button>	

                                                                       <asp:Button ID="btnCancel" runat="server" Text="Cancel" SkinID="DefaultButton" CommandName="Cancel" OnClick="btnCancel_Click" CssClass="slds-button slds-button_neutral slds-m-top_medium" CausesValidation="False"></asp:Button>
																	
																</div>
										                            <asp:UpdateProgress ID="UpdatePanelSetting" runat="server"  DisplayAfter="200">
											                            <ProgressTemplate>
												                             <div class="demo-only">
                                                                                            <div class="slds-spinner_container">
                                                                                                                                   <div role="status" class="slds-spinner slds-spinner_medium slds-spinner_brand">
                                                                                                                                       <span class="slds-assistive-text">Loading</span>
                                                                                                                                       <div class="slds-spinner__dot-a"></div>
                                                                                                                                       <div class="slds-spinner__dot-b"></div>
                                                                                                                    </div>
                                                                                                             </div>
                                                                                                      </div>
											                            </ProgressTemplate>
										                            </asp:UpdateProgress>
									                            
													</EditItemTemplate>
													<ItemTemplate>
																 
                                                                     <asp:Button ID="btnEdit" runat="server" Text="Edit" SkinID="DefaultButton" CommandName="Edit" OnClick="btnEdit_Click" CausesValidation="False" CssClass="slds-button slds-button_neutral"></asp:Button>
																	
													</ItemTemplate>
												</asp:TemplateField>
											</fields>
                                <fieldheaderstyle></fieldheaderstyle>
                            </asp:DetailsView>
                            </contenttemplate>
                </asp:UpdatePanel>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <asp:HiddenField ID="hdnID" runat="server" />
    <asp:ObjectDataSource ID="odsSalesforce" runat="server" TypeName="enzigma.sforce.webapp.code.business.EmailSettings"
        SelectMethod="GetSalesforceUserProfile">
        <selectparameters>
						<asp:QueryStringParameter Type="String" Name="strID" QueryStringField="ID"></asp:QueryStringParameter>
					</selectparameters>
    </asp:ObjectDataSource>

</asp:Content>
