﻿var app = angular.module('UIEngine', ['deForm', 'deEngine']);

app.factory('$UIEngine', ['$deForm', '$engine', '$compile', '$rootScope', function ($deForm, $engine, $compile, $rootScope) {
    var $PlatformUIEngine = {
        removeDialogTemplate: function (dialogId, dialogTemplate, currentScope) {

            $('#' + dialogId).fadeOut(300);
            $('.modal-backdrop').fadeOut(300);
            setTimeout(function () {
                dialogTemplate.remove();
                $('.modal-backdrop').remove();
            }, 500)
            $('body').removeClass('modal-open');
            $('body').removeAttr('style');
            currentScope.$destroy();
        },
        previewLayout: function (layout, record) {
            $('#preview-layout-id').remove();
            //$('#preview-layout-id').on('hidden.bs.modal', function () {
            //    $(this).find('form')[0].reset();                
            //});
            var previewDialog = '';
            var previewScope = $rootScope.$new();
            previewScope.$on('fetchRecords', function (event, keyword, field, onsuccess, onerror) {
                var records = [];
                $engine.fetchRecordsWithCount(keyword, field.ReferenceObjectName, field.searchLimit, field.thresholdLimit, field.criteria, function (error) {
                    if (error.success) {
                        records = error.data.Data;
                        onsuccess({ totalCount: error.data.TotalRecords, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });
                    }
                });
            }, function (error) { onerror('Could not reach the server'); });
            previewScope.component = {
                layout: layout,
                record: record,
                height: (screen.availHeight),
                removeTemplate: function () {
                    $UIEngine.removeDialogTemplate('preview-layout-id', previewDialog, previewScope);
                }
            };
            previewDialog = '<div id="preview-layout-id" class="modal fade" tabindex="-1" role="dialog">\
										<div class="modal-backdrop fade in"></div>\
										<div class="modal-dialog" style="z-index: 0;width: 80%">\
											<div class="modal-content">\
												<div class="modal-header">\
													<button type="button" class="close" ng-click="component.removeTemplate()"><h4 aria-hidden="true"><i class="fa fa-times-circle"></i></span></h4></button>\
													<h4 class="modal-title">Create </h4>\
												</div>\
												<div class="extended-modal-body container-fluid" style="overflow:visible;">\
													<div class="padd-top" de-layout="component.layout" ng-model="component.record" edit-mode="\'edit\'" display-mode="\'edit\'"  ></div>\
													<div class="padd-top"></div>\
												</div>\
											</div>\
										</div>';

            $UIEngine.dialogScope = previewScope;
            previewDialog = $compile(previewDialog)(previewScope);
            $('body').append(previewDialog);
            $('#preview-layout-id').modal('show');
        },
        create: function (record, parentRecord, callback) {
            $UIEngine.callback = callback;
            function getActions() {
                var buttons = [{
                    type: 'primary',
                    label: 'Create',
                    mode: "edit",
                    action: function (record, error, success) {
                        if (record.Name) {
                            record.Name.trim();
                            record.Name = record.Name.replace(/\s/g, '_');
                        }
                        if ((record.ObjType == "ObjectDef") || (record.ObjType == "FieldDef")) {
                            if (record.Name.indexOf("__c") == -1)
                                record.Name = record.Name + "__c";
                        }
                        if (record.ObjType == "PermissionGroup") {
                            $engine.savePermissionGroup(record, true, function (error) {
                                if (error.success) {
                                    $UIEngine.callback(error.success, "Record Created Successfully");
                                }
                                else {
                                    if (error.data.Code == 'PermissionDeniedOnObject')
                                        error.data.ErrorMessage = 'You do not have ' + error.data.ErrorMessage + ' Permission, please contact system admin.'
                                    $UIEngine.callback(error.success, error.data.ErrorMessage);
                                }
                                $UIEngine.dialogScope.component.removeTemplate();
                            });
                        }
                        else {
                            delete record.loggedInUser;
                            delete record.erorrMessage;
                            delete record.mailformat;
                            delete record.showdetails;
                            $engine.create(record, true, function (data) {
                                if (data.success) {
                                    $UIEngine.callback(data.success, "Record Created Successfully");
                                }
                                else {
                                    if (data.data.Code == 'PermissionDeniedOnObject')
                                        data.data.ErrorMessage = 'You do not have ' + data.data.ErrorMessage + ' Permission , please contact system admin.'

                                    $UIEngine.callback(data.success, data.data.ErrorMessage);
                                }
                                $UIEngine.dialogScope.component.removeTemplate();
                            });
                        }
                    }
                }, {
                    type: 'default',
                    label: 'Cancel',
                    mode: "edit",
                    allowoninvalid: true,
                    action: function (record, error, success) {
                        $UIEngine.dialogScope.component.removeTemplate();
                    }
                }];
                return buttons;

            }

            if (parentRecord.$$childTail.options.object == "User") {
                $engine.getLayout('Layout', 'CreateUser_Layout', function (error) {
                    if (error.success) {
                        var options = (error.data.Data.layout.Layout) ? JSON.parse(error.data.Data.layout.Layout) : {};
                        options.buttons = getActions();
                        error.data.Data.record = { ObjType: "User" };
                        if (parentRecord.relatedlist) {
                            if (parentRecord.relatedlist.options.referenceField.indexOf("PRO__") != -1) {
                                parentRecord.relatedlist.options.referenceField = parentRecord.relatedlist.options.referenceField.slice(5, parentRecord.relatedlist.options.referenceField.length);
                            }
                            error.data.Data.record[parentRecord.relatedlist.options.referenceField] = {
                                Id: $rootScope.relatedListRecordName.Id,
                                Name: $rootScope.relatedListRecordName.Name,
                            }
                        }
                        error.data.Data.record.loggedInUser = $rootScope.loggedInUser.Instance.Id;
                        error.data.Data.record.mailformat = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
                        error.data.Data.record.erorrMessage = "Same username already exists";
                        $UIEngine.previewLayout(options, error.data.Data.record);
                        return "Create click";
                    }
                    else {
                        utills.showError((error.data.Data) ? error.data.Data[0].ErrorMessage : error.data.ErrorMessage, (error.data.Data) ? error.data.Data[0].Code : error.data.Code);
                    }
                });
            }
            else {
                $engine.getRecordLayout(parentRecord.$$childTail.options.object, (record.Id == undefined) ? '' : record.Id, function (error) {
                    if (error.success) {
                        if (parentRecord.$$childTail.options.object == "PermissionGroup") {
                            var field = {
                                label: 'Select Existing Permission Group',
                                name: 'PermissionGroup',
                                type: 'lookup',
                                required: true,
                                nameField: 'PermissionGroup.Name',
                                criteria: "",
                                searchLimit: 10,
                                thresholdLimit: 70,
                                ReferenceObjectName: "PermissionGroup"
                            }
                        }
                        var options = JSON.parse(error.data.Data.layout.Layout);
                        //FieldDef field creation.
                        //Temp Code to restrict user from creating few fields on object(like formula, rollup etc)   
                        if (parentRecord.$$childTail.options.object == "FieldDef") {
                            error.data.Data.record.ObjectName = { Name: parentRecord.$parent.strObject }
                            error.data.Data.record.DisplayAs = "";
                            if (options.sections[0].fields[0].name == "DisplayAs" && options.sections[0].fields[0].values.length == 35) {
                                var displayAsField = ["Encrypted", "Blob", "ComboBox", "FormulaBoolean", "FormulaDate", "FormulaNumeric", "FormulaText", "FormulaDateTime", "ServerCondition", "ClientCondition", "RollupNumeric", "RollupDate", "RollupDateTime", "Icon"];
                                var tempDisplayAsPicklist = options.sections[0].fields[0].values;
                                for (var index = 0; index < tempDisplayAsPicklist.length; index++) {
                                    if (displayAsField.indexOf(tempDisplayAsPicklist[index].value) != -1) {
                                        tempDisplayAsPicklist.splice(index, 1);
                                        index--;
                                    }
                                }
                                options.sections[0].fields[0].values = tempDisplayAsPicklist;
                            }
                        }


                        if (parentRecord.$$childTail.options.object == "PermissionGroup")
                            options.sections[0].fields.push(field);
                        options.buttons = getActions();
                        if (parentRecord.relatedlist) {
                            if (parentRecord.relatedlist.options.referenceField.indexOf("PRO__") != -1) {
                                parentRecord.relatedlist.options.referenceField = parentRecord.relatedlist.options.referenceField.slice(5, parentRecord.relatedlist.options.referenceField.length)
                            }
                            error.data.Data.record[parentRecord.relatedlist.options.referenceField] = {
                                Id: $rootScope.relatedListRecord.Id,
                                Name: $rootScope.relatedListRecord.Name,
                            }
                        }
                        $UIEngine.previewLayout(options, error.data.Data.record);
                        return "Create click";
                    }
                    else {
                        if (error.data.Code == 'PermissionDeniedOnField')
                            error.data.ErrorMessage = 'You do not have ' + error.data.ErrorMessage + ' Permission , please contact system admin.'
                        $UIEngine.callback(error.success, error.data.ErrorMessage);
                    }
                });
            }

        },
        edit: function (record, parentRecord, callback) {
            $UIEngine.callback = callback;
            $engine.getRecordLayout(parentRecord.$$childTail.options.object, (record.Id == undefined) ? '' : record.Id, function (error) {
                if (error.success) {
                    var options = JSON.parse(error.data.Data.layout.Layout);
                    if ((record.ObjType == "ObjectDef") || (record.ObjType == "FieldDef")) {
                        if (record.Name.indexOf("__c") != -1) {
                            error.data.Data.record.Name = (record.Name.slice(5, record.Name.length)).slice(0, record.Name.length - 8);
                        }
                    }
                    options.buttons = [{
                        type: 'primary',
                        label: 'Save',
                        mode: "edit",
                        action: function (record, error, success, erroObj) {
                            if (record.Name) {
                                record.Name.trim();
                                if (record.ObjType != "User")
                                    record.Name = record.Name.replace(/\s/g, '_');
                            }
                            if ((record.ObjType == "ObjectDef") || (record.ObjType == "FieldDef")) {
                                if (record.Name.indexOf("__c") == -1)
                                    record.Name = "PRO__" + record.Name + "__c";
                            }
                            if (Object.keys(erroObj).length > 0) {
                                var errorString = '';
                                for (var key in erroObj) {
                                    errorString = key + ' : ' + erroObj[key].errorMsg;
                                }
                                error(errorString);
                            }
                            else {
                                $engine.upsert(record, true, function (data) {
                                    if (data.success)
                                        $UIEngine.callback(data.success, "Record Updated Successfully");
                                    else {
                                        if (data.data.Code == 'PermissionDeniedOnField')
                                            data.data.ErrorMessage = data.data.ErrorMessage;
                                        if (data.data.Code == 'PermissionDeniedOnObject')
                                            data.data.ErrorMessage = 'You do not have ' + data.data.ErrorMessage + ' Permission , please contact system admin.';
                                        $UIEngine.callback(data.success, data.data.ErrorMessage);
                                    }

                                    $UIEngine.dialogScope.component.removeTemplate();
                                });
                            }
                        }
                    }, {
                        type: 'default',
                        label: 'Cancel',
                        mode: "edit",
                        allowoninvalid: true,
                        action: function (record, error, success) {
                            $('#preview-layout-id').modal('hide');
                        }
                    }];
                    $UIEngine.previewLayout(options, error.data.Data.record);
                }
                else {
                    if (error.data.Code == 'PermissionDeniedOnField')
                        error.data.ErrorMessage = 'You do not have ' + error.data.ErrorMessage + ' Permission , please contact system admin.'
                    $UIEngine.callback(error.success, error.data.ErrorMessage);
                }
            });
        },
        delete: function (records, parentRecord, callback) {
            $UIEngine.callback = callback;
            var confirmMsg = "Are you sure you want to delete following records?";
            if (records.length == undefined)
                confirmMsg = 'Are you sure you want to delete this record "' + records.Name + '" ?';
            for (i = 0; i < records.length; i++)
                confirmMsg = confirmMsg + "\n" + records[i].Name;
            if (parentRecord.$$childTail.options.object == "FieldDef") {
                if (records.length == undefined)
                    records.ObjectName = { Name: parentRecord.$parent.strObject }
                else {
                    for (i = 0; i < records.length; i++)
                        records[i].ObjectName = { Name: parentRecord.$parent.strObject }
                }
            }
            var del = confirm(confirmMsg);
            if (del) {
                $engine.delete(angular.copy(records), true, function (data) {
                    if (data.success) {
                        $UIEngine.callback(data.success, "Record Deleted Successfully");
                    }
                    else {
                        if (data.data.Code == 'PermissionDeniedOnField' || data.data.Code == 'PermissionDeniedOnObject')
                            data.data.ErrorMessage = 'You do not have ' + data.data.ErrorMessage;
                        $UIEngine.callback(data.success, data.data.ErrorMessage);
                    }

                });
            }


        },
    };
    var $CellaUIEngine = {
        removeDialogTemplate: function (dialogId, dialogTemplate, currentScope) {

            $('#' + dialogId).fadeOut(300);
            $('.modal-backdrop').fadeOut(300);
            setTimeout(function () {
                dialogTemplate.remove();
                $('.modal-backdrop').remove();
            }, 500)
            $('body').removeClass('modal-open');
            $('body').removeAttr('style');
            currentScope.$destroy();
        },
        previewLayout: function (layout, record) {
            $('#preview-layout-id').remove();
            //$('#preview-layout-id').on('hidden.bs.modal', function () {
            //    $(this).find('form')[0].reset();                
            //});
            var previewDialog = '';
            var previewScope = $rootScope.$new();
            previewScope.$on('fetchRecords', function (event, keyword, field, onsuccess, onerror) {
                var records = [];
                $engine.fetchRecordsWithCount(keyword, field.ReferenceObjectName, field.searchLimit, field.thresholdLimit, field.criteria, function (error) {
                    if (error.success) {
                        records = error.data.Data;
                        onsuccess({ totalCount: error.data.TotalRecords, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });
                    }
                });
            }, function (error) { onerror('Could not reach the server'); });
            previewScope.component = {
                layout: layout,
                record: record,
                height: (screen.availHeight),
                removeTemplate: function () {
                    $UIEngine.removeDialogTemplate('preview-layout-id', previewDialog, previewScope);
                }
            };
            previewDialog = '<div id="preview-layout-id" class="modal fade" tabindex="-1" role="dialog">\
										<div class="modal-dialog" style="z-index: 0;width: 80%">\
											<div class="modal-content">\
												<div class="modal-header">\
													<button type="button" class="close" ng-click="component.removeTemplate()"><h4 aria-hidden="true"><i class="fa fa-times-circle"></i></span></h4></button>\
													<h4 class="modal-title">Create </h4>\
												</div>\
												<div class="extended-modal-body container-fluid" style="overflow:visible;">\
													<div class="padd-top" de-layout="component.layout" ng-model="component.record" edit-mode="\'edit\'" display-mode="\'edit\'"  ></div>\
													<div class="padd-top"></div>\
												</div>\
											</div>\
										</div>';

            $UIEngine.dialogScope = previewScope;
            previewDialog = $compile(previewDialog)(previewScope);
            $('body').append(previewDialog);
            $('#preview-layout-id').modal('show');
        },
        //added extra parameter conditionObject for account object 
        create: function (record, parentRecord, callback, conditionObject) {
            $UIEngine.callback = callback;
            function getActions() {
                var buttons = [{
                    type: 'primary',
                    label: 'Create',
                    mode: "edit",
                    action: function (record, error, success) {
                        if (record.Name) {
                            record.Name.trim();
                            record.Name = record.Name.replace(/\s/g, '_');
                        }
                        else {
                            debugger;
                            if (record.obj_type == 'invoice')
                                record.generated_by = $engine.getCookie('uid');
                            else if (record.obj_type == 'user')
                                record.user_type = "External";
                            $engine.create(record, true, function (data) {
                                if (data.success) {
                                    $UIEngine.callback(data.success, " Record Created Successfully");
                                    $UIEngine.dialogScope.component.removeTemplate();
                                }
                                else {
                                    $UIEngine.callback(data.success, data.errormessage);
                                }
                                //$UIEngine.dialogScope.component.removeTemplate();
                            });
                        }
                    }
                }, {
                    type: 'default',
                    label: 'Cancel',
                    mode: "edit",
                    allowoninvalid: true,
                    action: function (record, error, success) {
                        $UIEngine.dialogScope.component.removeTemplate();
                    }
                }];
                return buttons;
            }
            $engine.getRecordLayout(parentRecord.$$childTail.options.object, (record.Id == undefined) ? '' : record.Id, function (error) {
                if (error.success) {
                    var options = JSON.parse(error.data.layout.layout);
                    options.buttons = getActions();
                    if (parentRecord.relatedlist) {
                        error.data.record[parentRecord.relatedlist.options.reference_name] = {
                            id: $rootScope.relatedListRecord.id,
                            name: $rootScope.relatedListRecord.name,
                        }
                    }
                    if (parentRecord.$$childTail.options.object == 'account') {
                        var index = options.sections[0].fields.findIndex(x => x.name == "business_type_code");
                        if (index > 0)
                            options.sections[0].fields[index].criteria = conditionObject ? conditionObject.criteria : "";
                    }
                    //this condition is for removing the reference field of relatedObjectName from detailview layout of relatedlist
                    if (parentRecord.relatedlist) {
                       var index = options.sections[0].fields.findIndex(x => x.name == parentRecord.relatedlist.options.relatedObjectName);
                        delete options.sections[0].fields[index];
                    }
                    options.relatedlists = [];
                    $UIEngine.previewLayout(options, error.data.record);
                    return "Create click";
                }
                else {
                    //if (error.data.Code == 'PermissionDeniedOnField')
                       // error.data.ErrorMessage = 'You do not have ' + error.data.ErrorMessage + ' Permission , please contact system admin.'
                    $UIEngine.callback(error.success, error.errormessage);
                }
            });
        },
        edit: function (record, parentRecord, callback) {
            $UIEngine.callback = callback;
            $engine.getRecordLayout(parentRecord.$$childTail.options.object, (record.id == undefined) ? '' : record.id, function (error) {
                if (error.success) {
                    var options = JSON.parse(error.data.layout.layout);
                    options.buttons = [{
                        type: 'primary',
                        label: 'Save',
                        mode: "edit",
                        action: function (record, error, success, erroObj) {
                            if (Object.keys(erroObj).length > 0) {
                                var errorString = '';
                                for (var key in erroObj) {
                                    errorString = key + ' : ' + erroObj[key].errorMsg;
                                }
                                error(errorString);
                            }
                            else {
                                debugger
                                $engine.upsert(record, true, function (data) {
                                    if (data.success)
                                        $UIEngine.callback(data.success, "Record Updated Successfully");
                                    else {
                                        debugger
                                        $UIEngine.callback(data.success, data.errormessage);
                                    }
                                    $UIEngine.dialogScope.component.removeTemplate();
                                });
                            }
                        }
                    }, {
                        type: 'default',
                        label: 'Cancel',
                        mode: "edit",
                        allowoninvalid: true,
                        action: function (record, error, success) {
                            $('#preview-layout-id').modal('hide');
                        }
                    }];
                    //this condition is for removing the reference field of relatedObjectName from detailview layout of relatedlist
                    if (parentRecord.relatedlist) {
                        index = options.sections[0].fields.findIndex(x => x.name == parentRecord.relatedlist.options.relatedObjectName);
                        delete options.sections[0].fields[index];
                    }
                    options.relatedlists = [];
                    $UIEngine.previewLayout(options, error.data.record);
                }
                else {
                    $UIEngine.callback(error.success, error.errormessage);
                }
            });
        },
        delete: function (records, parentRecord, callback) {
            $UIEngine.callback = callback;
            var confirmMsg = "Are you sure you want to delete following records?";
            if (records.length == undefined)
                confirmMsg = 'Are you sure you want to delete this record "' + records.name + '" ?';
            for (i = 0; i < records.length; i++)
                confirmMsg = confirmMsg + "\n" + records[i].name;
            var del = confirm(confirmMsg);
            if (del) {
                $engine.delete(angular.copy(records), true, function (data) {
                    if (data.success) {
                        $UIEngine.callback(data.success, data.data.deleted +" Record Deleted Successfully");
                    }
                    else {
                        $UIEngine.callback(data.success, data.errormessage);
                    }
                });
            }
        },
    };

    if (window.platform = 'cella') {
        $UIEngine = $CellaUIEngine;
    }
    else
        $UIEngine = $PlatformUIEngine;

    return $UIEngine
}]);