angular.module('deActions', ['deServices', 'ng-sortable', 'deForm'])
	.factory('$deActions', ['$filter', '$rootScope', '$compile', function ($filter, $rootScope, $compile) {
	    var $deActions = {
	        removeDialogTemplate: function (dialogId, dialogTemplate, currentScope) {
	            $('#' + dialogId).fadeOut(300);
	            $('.modal-backdrop').fadeOut(300);
	            setTimeout(function () {
	                dialogTemplate.remove();
	                $('.modal-backdrop').remove();
	            }, 500)
	            $('body').removeClass('modal-open');
	            $('body').removeAttr('style');
	            currentScope.$destroy();
	        },
	        actionWizard: function (button, callback) {
	            var actionPopup = '';
	            actionPopupScope = $rootScope.$new();
	            actionPopupScope.component = { component: angular.copy(button) };
	            actionPopupScope.component.label = angular.copy(button.label);
	            actionPopupScope.component.saveCallback = function (component) {
	                callback(component, function () {
	                    actionPopupScope.component.removeTemplate();
	                });
	            }
	            actionPopupScope.component.removeTemplate = function () {
	                $deActions.removeDialogTemplate('action-wizard-id', actionPopup, actionPopupScope);
	            }
	            actionPopup = '<div id="action-wizard-id" class="modal fade" tabindex="-1" role="dialog">\
									<div class="modal-backdrop fade in" style="height: 100%; width: 100%;"></div>\
									<div class="modal-dialog" style="z-index: 9999;width: 75%;">\
										<div class="modal-content">\
											<div class="modal-header">\
												<button type="button" class="close" ng-click="component.removeTemplate()"><h4 aria-hidden="true"><i class="fa fa-times-circle"></i></span></h4></button>\
												<h4 class="modal-title">Edit Button: {{component.label}}</h4>\
											</div>\
											<div class="modal-body container-fluid container-border">\
												<div button-action="component.component" oncancel="component.removeTemplate()" onsave="component.saveCallback(newComponent)"></div>\
											</div>\
										</div>\
									</div>'
	            actionPopup = $compile(actionPopup)(actionPopupScope);
	            $('body').append(actionPopup);
	            $('#action-wizard-id').modal('show');
	        },

	    }
	    return $deActions;
	}])
	.directive('deActionBar', ['$de', function ($de) {
	    return {
	        restrict: 'A',
	        template: '<div ng-include="templateUrl" class="de-actions" ></div>',
	        scope: {                
	            actions: '=deActionBar',
	            record: '=?',
	            onaction: '&',
	            displayAs: '=display',
	            editMode: '=',
                actionType:'=actionType'
	            //mode: '=',
	            //size: '=',
	            //deForm: '=form',
	        },
	        controller: ['$scope', '$attrs', '$element', '$de', '$deActions', '$deForm', '$sce', '$interpolate', '$timeout', '$compile', '$templateCache', function ($scope, $attrs, $element, $de, $deActions, $deForm, $sce, $interpolate, $timeout, $compile, $templateCache) {
	            $scope.$de = $de;
	            $scope.$de.initUIControl($element, $scope, $attrs);
	            $scope.groups = {};
	            $scope.$compile = $compile;

	            $scope.init = function () {
	                var formName = $element.parents('form').attr('name');
	                if (formName && $scope.$parent[formName]) {
	                    $scope.deForm = $scope[formName] = $scope.$parent[formName];
	                }
	            }

	            setTimeout($scope.init, 200);
	            $scope.customlabel = function (action,rec) {
	                if (!action.id)
	                    action.id = $de.getUniqueId();
	                var templateUrl = 'label_' + action.id + '.htm';
	                if (!action.labeltemplated) {
	                    $templateCache.put(templateUrl, action.customlabel);
	                    action.labeltemplated = true;
	                }
	                return templateUrl;
	            }

	            $scope.customicon = function (action) {
	                if (!action.id)
	                    action.id = $de.getUniqueId();
	                var templateUrl = 'icon-' + action.id + '.htm';
	                if (!action.icontemplated) {
	                    $templateCache.put(templateUrl, action.customicon);
	                    action.icontemplated = true;
	                }
	                return templateUrl;
	            }

	            $scope.changecolor = function ($event) {
	            }

	            $scope.action = { actions:$scope.actions };
	            $scope.initTree = function (action) {
	                //if (action.actions && action.actions.length) {
	                //    angular.forEach(action.actions, function (child) {
	                //        child.parent = angular.copy(action);
	                //        $scope.initTree(child);
	                //    })
	                //}
	            }
	            $scope.initTree($scope.action);

	            $scope.toggleChildMenu = function ($event) {
	                $event.preventDefault();
	                $event.stopPropagation();
	                $($event.currentTarget).closest('li').toggleClass('open');
	            }

	            $scope.takeAction = function ($event, action) {
	                if ($scope.isDisabled(action)) {
	                    //As the action is disabled do not propagate the event
	                    if ($event) {
	                        $event.preventDefault();
	                        $event.stopPropagation();
	                    }
	                }
	                else {
	                    if (action.group) {
	                        angular.forEach($scope.actions, function (item) { if (item.group === action.group) { item.active = false; } })
	                        $scope.groups[action.group] = action.action;
	                        action.active = true;
	                    }
	                    $scope.onaction({ action: action, $event: $event });
	                }
	            }

	            $scope.isDisabled = function (action) {
	                return (action.disabled || (action.disableOnInvalidForm && $scope.deForm && $scope.deForm.$invalid));
	            }

	            $scope.icon = function (action) {
	                if (action.icon) {
	                    if (typeof action.icon === 'string')
	                        return action.icon;
	                    else if (typeof action.icon === 'function') {
	                        return action.icon(action);
	                    }
	                }
	            }

	            $scope.removeAction = function ($event, action, actions) {
	                $event.preventDefault();
	                $event.stopPropagation();
	                if (actions != undefined)
	                    $de.remove(actions, action);
	                else
	                    $de.remove(action.parent.actions, action);
	            }

	            $scope.editAction = function ($event, action, actions) {
	                $event.preventDefault();
	                $event.stopPropagation();
	                $scope.saveEditAction = function (record, closeCallback) {
	                    record.customFunction = record.action;
	                    angular.forEach(actions, function (value, key) {
	                        if (value.id == record.id)
	                            actions[key] = record;
	                    })
	                    if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                    closeCallback();
	                }
	                
	                $deActions.actionWizard(action, $scope.saveEditAction);
	            }
	            $scope.defaultButton = {
	                name:'Button',
	                label: 'Button',
	                action: '',
	                type: 'primary',
	                onclick: $scope.takeAction,
	                isStandardAction: true,
	            }
	           
	            $scope.addChildAction = function ($event, action) {
	                if ($scope.actionType=='singleRecord'){
	                    $scope.defaultButton.action = "function (record, parentRecord, callback) { }";
	                    $scope.defaultButton.singleRecordAction = true;
	                    $scope.defaultButton.actionType = "tableSignleRecordActions";
	                }
	                else {
	                    $scope.defaultButton.action = "function(selectedRecords,parentRecord,callback){}";
	                    $scope.defaultButton.singleRecordAction = false;
	                    $scope.defaultButton.actionType = "tableMultiRecordActions";
	                }
	                $event.preventDefault();
	                $event.stopPropagation();
	                $scope.saveButtonAction = function (button, closeCallback) {
	                    if (!action.actions) action.actions = [];
	                    var stopExecution = false;
	                    if (/^[a-zA-Z0-9_]*[^_]$/.test(button.name)) {
	                        for (var i = 0; i < action.actions.length; ++i) {
	                            if (action.actions[i].name == button.name && action.actions[i].id != button.id) {
	                                stopExecution = true;
	                                break;
	                            }
	                        }
	                        if (stopExecution) {
	                            $de.showError('Duplicate button name not allowed.Button ' + button.name + ' already exist.', 'Error', '');
	                            return;
	                        }
	                    } else {
	                        $de.showError('The name can only contain underscores and alphanumeric characters. It must begin with a letter and be unique, and must not include spaces, end with an underscore, or contain two consecutive underscores.','Error','');
	                        return;
	                    }
	                   
	                    if (button.id == undefined)
	                        button.id = $de.getUniqueId();

	                    button.customFunction = button.action;
	                    action.actions.push(button);
	                    $scope.actions = action.actions;
	                    if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                    closeCallback();
	                }
	                $deActions.actionWizard($scope.defaultButton, $scope.saveButtonAction);
	            }

	            var displayAs = ($scope.displayAs) ? $scope.displayAs.toLowerCase() : '';
	            var templateName = 'actions-bar';
	            switch (displayAs) {
	                case 'dropdown-btn': templateName = 'dropdown-btn'; break;
	                case 'toolbar': templateName = 'toolbar'; break;
	            }

	            var size = ($scope.size) ? $scope.size.toLowerCase() : '';
	            $scope.btn_grp_size = (displayAs == 'toolbar' || displayAs == 'dropdown-btn') ? 'btn-group-xs' : 'btn-group-sm';
	            switch (size) {
	                case 'xs': $scope.btn_grp_size = 'btn-group-xs'; break;
	                case 'sm': $scope.btn_grp_size = 'btn-group-sm'; break;
	                case 'lg': $scope.btn_grp_size = 'btn-group-lg'; break;
	            }

	            $scope.templateUrl = $de.templatesFolder + templateName + ($scope.designMode ? '-design.htm' : '.htm');
	            $scope.templateDropdownUrl = $de.templatesFolder + 'dropdown' + ($scope.designMode ? '-design.htm' : '.htm');
	        }]
	    }
	}])
