﻿window.platform = window.platform || "platform";


var module = angular.module('deEngine', ['deServices', window.platform]);
module.factory('$engine', ['$de', window.platform, function ($de, $apiPlatform) {
	var thisValue = {};
    var defaultOption = {
        showProcessing: false,
        hideProcessing: false,
        showError: false,
        showSuccess: false,
	};
	var showProcessing = function (options) {
		options = angular.merge({}, defaultOption, options);
		//if (options.showProcessing)
		//	$de.showProgress();
	};
	var hideProcessing = function (options) {
		options = angular.merge({}, defaultOption, options);
		//if (options.hideProcessing)
		//	$de.hideProgress();
	};
	var showSuccess = function (options) {
		options = angular.merge({}, defaultOption, options);
		//if (options.showSuccess)
		//	$de.showSuccess("Success");
	}
	var showError = function (options, errorMessage) {
		options = angular.merge({}, defaultOption, options);
		//if (options.showError)
		//	$de.showError(errorMessage);
	};
	var success = function (result, successFn, errorFn, options) {
		//hideProcessing(options);
		showSuccess(options);
		if (successFn)
			successFn(result);
	}
	var error = function (result, successFn, errorFn, options) {
		//hideProcessing(options);
		showError(options, result.errorMessage);
		if (errorFn)
			errorFn(result);
	};
	return {
		invoke: function () {
			//showProcessing(options);
			var action = arguments[0];
			Array.prototype.shift.apply(arguments);
			var onsuccess = arguments[arguments.length - 3];
			var onerror = arguments[arguments.length - 2];
			var options = arguments[arguments.length - 1];
			arguments[arguments.length - 3] = function (result) {
				success(result, onsuccess, onerror, options)
			};

			arguments[arguments.length - 2] = function (result) {
				error(result, onsuccess, onerror, options)
			};
			//Array.prototype.pop.apply(arguments);
			$apiPlatform[action].apply(this, arguments);
		},
		login: function (event, formId, successFn, errorFn, options) {
			this.invoke('login', event, formId, successFn, errorFn, options);
		},
		get: function (url, successFn, errorFn, options) {
			this.invoke('get', url, successFn, errorFn, options);
		},
		post: function (url, data, successFn, errorFn, options) {
			this.invoke('post', url, data, successFn, errorFn, options);
		},
		delete: function (record,bAllOrNone,successFn, errorFn, options) {
		    this.invoke('delete', record,bAllOrNone,successFn, errorFn, options);
		},
		erase: function (record, successFn, errorFn, options) {
			this.invoke('erase', record, successFn, errorFn, options);
		},
		create: function (records, bAllOrNone, successFn, errorFn, options) {
			this.invoke('create', records, bAllOrNone, successFn, errorFn, options);
		},
		update: function (records, bAllOrNone, successFn, errorFn, options) {
			this.invoke('update', records, bAllOrNone, successFn, errorFn, options);
		},
		upsert: function (records, bAllOrNone, successFn, errorFn, options) {
			this.invoke('upsert', records, bAllOrNone, successFn, errorFn, options);
		},
		getField: function (strObjectName, strFieldName, successFn, errorFn, options) {
			this.invoke('getField', strObjectName, strFieldName, successFn, errorFn, options);
		},
		getFields: function (strObjectName, successFn, errorFn, options) {
			this.invoke('getFields', strObjectName, successFn, errorFn, options);
		},
		getObject: function (strObjectName, successFn, errorFn, options) {
			this.invoke('getObject', strObjectName, successFn, errorFn, options);
		},
		query: function (strQuery, successFn, errorFn, options) {
			this.invoke('query', strQuery, successFn, errorFn, options);
		},
		getRecordLayout: function (strObjectName, strId, successFn, errorFn, options) {
			this.invoke('getRecordLayout', strObjectName, strId, successFn, errorFn, options);
		},
		getLayout: function (strObjectName, strIdOrName, successFn, errorFn, options) {
		    this.invoke('getLayout', strObjectName, strIdOrName, successFn, errorFn, options);
		},
		getListViewLayout: function (strObjectName, strIdOrName, strmode, successFn, errorFn, options) {
		    this.invoke('getListViewLayout', strObjectName, strIdOrName,strmode,successFn, errorFn, options);
		},
		getDetailedViewLayout: function (strObjectName, strIdOrName, strmode,recordId, successFn, errorFn, options) {
		    this.invoke('getDetailViewLayout', strObjectName, strIdOrName, strmode,recordId, successFn, errorFn, options);
		},
		queryPage: function (object, queryFields, criteria, sortOrder, keyword, offset, size, successFn, errorFn, options) {
			this.invoke('queryPage', object, queryFields, criteria, sortOrder, keyword, offset, size, successFn, errorFn, options);
		},
        fetchRecordsWithCount: function (keyword, field, criteria, successFn, errorFn, options) {
            this.invoke('fetchRecordsWithCount', keyword, field.ReferenceObjectName, field.searchLimit, field.thresholdLimit, criteria, successFn, errorFn, field);
		},
		getParseFields: function (strObjectName, successFn, errorFn, options) {
		    this.invoke('getParseFields', strObjectName, successFn, errorFn, options);
		},
		savePermissionGroup: function (records, bAllOrNone, successFn, errorFn, options) {
		    this.invoke('savePermissionGroup', records,bAllOrNone, successFn, errorFn, options);
		},
		shareRecords: function (records, successFn, errorFn) {
		    this.invoke('shareRecords', records, successFn, successFn, errorFn);
		},
		getIdentityUser: function (strUserName, successFn) {
		    this.get(Engine.PlatformPath + '/api/v1/system?action=getidentityuser&username=' + strUserName, function (error) {
		        successFn(error);
		    }, { hideSuccess: true });
        },
       getCookie : function (name) {
            var value = "; " + document.cookie;
            var parts = value.split("; " + name + "=");
            if (parts.length == 2) return parts.pop().split(";").shift();
        },
		getRecords : function (options, onsuccess, onerror) {
		    if (options) {
		        options.offset = options.pageSize;
		        if (options.currentPage < 1)
		            options.cToken = "";

		        calculateOrderBy = function (strOrderBy) {
		            var orderBy = [];
		            if (strOrderBy) {
		                var orderByFields = strOrderBy.split(',');
		                angular.forEach(orderByFields, function (orderByField) {
		                    var orderByParts = orderByField.split(' ');
		                    if (orderByParts[1] && orderByParts[1] == 'desc') {
		                        orderBy.push('-' + orderByParts[0]);
		                    }
		                    else
		                        orderBy.push(orderByParts[0]);
		                })
		            }
		            return orderBy;
		        }
		        successCallback = function (result) {
		            var orderBy =calculateOrderBy(options.orderBy);
		            options.currentPage = parseInt(options.currentPage);
		            options.pageSize = parseInt(options.pageSize);
		            options.totalCount = result.data.totalCount;
		            options.cToken = result.data.cToken;
		            var fieldDefs = [];

		            delete options.fieldDefs.ObjType;
		            angular.forEach(options.fieldDefs, function (value, key) {
		                fieldDefs.push(angular.copy(value))
		            })

		            var filteredRecords = (orderBy.length) ? $filter('orderBy')(result.data.data, orderBy) : result.data.data;
		            var pagedRecords = (isNaN(options.pageSize) || options.pageSize <= 0) ? filteredRecords : filteredRecords;
		            var result = {
		                records: pagedRecords,
		                totalCount: options.totalCount,
		                currentPage: options.currentPage,
		                pageSize: options.pageSize,
		                fieldDefs: fieldDefs,
		                orderBy: options.orderBy,
		            };
		            onsuccess(result);

		        };
		        errorCallback = function (result) { onerror('No options specified'); }
		        this.invoke('queryPage', options.object, options.fields, options.criteria, options.orderBy, options.search, options.currentPage + 1, options.pageSize, options.offset, options.cToken,successCallback,errorCallback,options);

		    }                                    
		},
		baseUrl: $apiPlatform.platformApiUrl
	};
}])