﻿var designerExpertForm = {
    restrict: 'A',
}

angular.module('deForm', ['deServices', 'deActions', 'ui.tinymce', 'ui.ace', 'ui.bootstrap'])
	.factory('$deForm', ['$filter', '$de', '$rootScope', '$compile', function ($filter, $de, $rootScope, $compile) {
	    if (!$rootScope.temp) $rootScope.temp = {};
	    var $deForm = {
	        requiredAddon: '<span ng-if="field.required && !inline && !(field.readOnly || readonlyMode || readMode)" class="input-group-addon" ><i class="fa fa-check-circle-o"></i></span>',
	        bindField: function ($scope, $element, $attrs, defaultValue) {
	            $de.initValue($scope.record, $scope.field.name, defaultValue);
	            $de.initUIControl($element, $scope, $attrs);

	            return function (newValue) {
	                if (arguments.length) {
	                    $scope.oldRecord = angular.copy($scope.record);
	                    return $de.setValue($scope.record, $scope.field.name, newValue);

	                }
	                else
	                    return $de.getValue($scope.record, $scope.field.name);
	            }
	        },
	        inputTemplate: '<input type="{!type}"\
								ng-required="field.required"\
								ng-model="model"\
								ng-model-options="{ getterSetter: true, debounce: (inline) ? 0 : 300 }" \
								placeholder="{{field.placeholder ? field.placeholder : field.label}}"\
								maxlength="{{field.max}}"\
								class="form-control"\
								ng-change="validateField()" \
								ng-keydown="restrictPropagation($event)"\
								 ng-blur="saveEditedRecord(record)"/>\
								<span ng-if="errorManager[field.name].invalid" popover-title="Validation Failed: {{errorManager[field.name].name}}" popover-trigger="mouseenter" popover-placement="left" uib-popover="{{errorManager[field.name].errorMsg}}" class="error-span fa fa-exclamation-circle"></span>\
								<span ng-if="inline" class="overlay-label">&nbsp;{{model()}}</span>',
	        getIcons: function () {
	            return (!$deForm.icons) ? $deForm.getClasses('font-awesome', '^.(fa-.*)::before') : $deForm.icons;
	        },
	        getClasses: function (styleSheetName, pattern) {
	            var regExp = new RegExp(pattern);
	            var classList = [];
	            angular.forEach(document.styleSheets, function (styleSheet) {
	                if (styleSheet.href && styleSheet.href.indexOf(styleSheetName) >= 0) {
	                    var rules = styleSheet.rules || styleSheet.cssRules;
	                    angular.forEach(rules, function (rule) {
	                        if (rule.selectorText) {
	                            var parts = rule.selectorText.split(',');
	                            angular.forEach(parts, function (part) {
	                                var match = regExp.exec(part);
	                                if (match) {
	                                    classList.push(match[1]);
	                                }
	                            })
	                        }
	                    })
	                }
	            });
	            return classList;
	        },
	        modal: function (options) {
	            var id = $de.getUniqueId();
	            var modalScope = $rootScope.$new();
	            modalScope['temp'] = {};
	            modalScope.temp[id] = options;
	            var template = '<div id="{!id}" class="modal fade in" tabindex="-1" role="dialog" >\
								<div class="modal-dialog" style="width: 78%;">\
									<div class="modal-content">\
										<div class="modal-header">{{temp.{!id}.title}}: {{temp.{!id}.record.label}}<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button></div>\
										<div class="modal-body" de-form="temp.{!id}.fields" name="{!id}" ng-model="temp.{!id}.record" actions="temp.{!id}.actions" layout="\'de-form\'" edit-mode="\'edit\'" display-mode="\'edit\'"></div>\
									</div>\
								</div>\
							</div>';
	            template = template.replace(/{!id}/g, id);
	            $('body').append(template);
	            var contents = $('#' + id).contents();
	            $compile(contents)(modalScope);
	            $('#' + id).modal('show').on('hidden.bs.modal', function () {
	                modalScope.$destroy();
	                $('#' + id).remove();
	            });
	            return id;
	        },
	        manageLookupSettingDialog: function (field, callback) {
	            var lookupSettingTemplate = '';
	            var lookupSettingScope = $rootScope.$new();
	            lookupSettingScope.component = {
	                field: field,
	                saveDetails: function () {

	                    if (lookupSettingScope.component.field.searchLimit && lookupSettingScope.component.field.thresoldLimit)
	                        callback(lookupSettingScope.component.field, function () { lookupSettingScope.component.removeTemplate(); });
	                },
	                removeTemplate: function () {
	                    $('#lookup-settings-id').fadeOut(300);
	                    $('.modal-backdrop').fadeOut(300);
	                    setTimeout(function () {
	                        lookupSettingTemplate.remove();
	                        $('.modal-backdrop').remove();
	                    }, 500)
	                    $('body').removeClass('modal-open');
	                    $('body').removeAttr('style');
	                    lookupSettingScope.$destroy();
	                }
	            };
	            lookupSettingTemplate = '<div id="lookup-settings-id" class="modal fade" tabindex="-1" role="dialog">\
											<div class="modal-backdrop fade in" style="height: 100%; width: 100%;"></div>\
											<div class="modal-dialog" style="z-index: 9999;width:65%">\
												<div class="modal-content">\
													<div class="modal-header">\
														<button type="button" class="close" ng-click="component.removeTemplate()"><h4 aria-hidden="true"><span><i class="fa fa-times-circle"></i></span></h4></button>\
														<h4 class="modal-title">Selected Field: {{component.field.label}}</h4>\
													</div>\
													<div class="modal-body container-fluid container-border">\
														<div class="col-md-12 no-padding">\
															<div class="col-md-6">\
																<label class="label label-default">Search Limit: </label>\
																<div class="col-md-12 no-padding padd-top">\
																	<input type="number" class="form-control" ng-model="component.field.searchLimit" required="required" />\
																</div>\
															</div>\
															<div class="col-md-6 ">\
																<label class="label label-default">Thresold Limit: </label>\
																<div class="col-md-12 no-padding padd-top">\
																	<input type="number" class="form-control" ng-model="component.field.thresoldLimit" required="required" />\
																</div>\
															</div>\
														<div class="col-md-6 padd-top">\
															<label class="label label-default">Criteria: </label>\
															<div class="col-md-12 no-padding padd-top">\
																<textarea class="form-control" ng-model="component.field.criteria" />\
															</div>\
														</div>\
														<div class="col-md-12 padd-top">\
															<div class="col-md-6 no-padding text-right">\
																<button ng-disabled="!component.field.searchLimit || !component.field.thresoldLimit" type="button" class="btn btn-primary" ng-click="component.saveDetails()">Save</button>\
															</div>\
															<div class="col-md-6">\
																<button type="button" class="btn btn-default" ng-click="component.removeTemplate()">Cancel</button>\
															</div>\
														</div>\
													</div>\
												</div>\
											</div>\
										</div>\
									</div>'
	            lookupSettingTemplate = $compile(lookupSettingTemplate)(lookupSettingScope);
	            $('body').append(lookupSettingTemplate);
	            $('#lookup-settings-id').modal('show');
	        }
	    };
	    return $deForm;
	}])
	.directive('deForm', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: '<form name="{{name}}" class="{{layout}}" >\
							<div de-field="field" edit-mode="editMode" display-mode="displayMode" ng-model="record" ng-repeat="field in fields" ></div>\
							<div de-action-bar="actions" onaction="onaction($event, action)" class="action-bar"></div>\
						</form>',
	        scope: {
	            record: '=ngModel',
	            fields: '=deForm',
	            editMode: '=',
	            displayMode: '=',
	            actions: '=',
	            layout: '=',
	        },
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', 'toaster', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile, toaster) {
	            $scope.$deForm = $deForm;
	            $scope.$de = $de;
	            $de.initUIControl($element, $scope, $attrs);
	            $scope.attrs = $attrs;
	            if (!$scope.layout) $scope.layout = 'de-form';
	            $scope.name = (!$attrs.name) ? $de.getUniqueId() : $attrs.name;
	            $timeout(function () {
	                $scope.deForm = $scope[$scope.name];
	            }, 5);

	            $scope.onaction = function ($event, action) {
	                if ($scope.deForm.$valid || action.allowoninvalid) {
	                    if (action.onclick) {
	                        action.onclick($event, action, { type: 'single-record', record: $scope.record }, function (success, message) {
	                            if (!success)
	                                toaster.pop('error', 'Form', message);
	                            if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                        });
	                    }
	                }
	            }
	        }]
	    }
	}])
	.directive('deField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        link: function (scope, iElement, iAttrs) {
	            if (scope.saveMode) {
	                iElement.bind('focusout', function () {
	                    iElement.find('input').css('color', '#ff9222');
	                    iElement.find('select').css('color', '#ff9222')
	                });
	                iElement.bind('dblclick', function () {
	                    iElement.css('background-color', '#FFFFFF');
	                });
	            }
	        },
	        scope: {
	            field: '=deField',
	            record: '=ngModel',
	            editMode: '=',
	            displayMode: '=',
	            fieldindex: '=',
	            saveMode: '=?'
	        },
	        controller: ['$scope', '$attrs', '$element', '$compile', '$timeout', '$de', '$deForm', '$engine', '$interpolate', '$rootScope', function ($scope, $attrs, $element, $compile, $timeout, $de, $deForm, $engine, $interpolate, $rootScope) {
	            $scope.attrs = $attrs;
	            $scope.$de = $de;
	            $scope.record ? $scope.record : $scope.record = {};
	            $scope.oldRecord = angular.copy($scope.record);

	            var formName = $element.parents('form').attr('name');
	            if (formName && $scope.$parent[formName]) {
	                $scope.deForm = $scope[formName] = $scope.$parent[formName];//[$element.parents('form').attr('name')];
	            }

	            //Element name can not have . hence we are replacing it with 2 underscores
	            $scope.elementName = $scope.field.name.replace(/\./g, '__');
	            //For form validation classes to work it is very important we watch the form element names and update classes on de-field for our use

	            $scope.$watch('deForm.' + $scope.elementName + '.$error.required', function (newValue) {
	                if (newValue) $element.addClass('ng-invalid-required'); else $element.removeClass('ng-invalid-required');
	            });
	            if (!$scope.field.smallWidth) $scope.field.smallWidth = 12;
	            if (!$scope.field.mediumWidth) $scope.field.mediumWidth = 12;
	            if (!$scope.field.largeWidth) $scope.field.largeWidth = 12;

	            $scope.$watch('field.smallWidth', function (newValue, oldValue) {
	                var newSize = 'de-size--' + newValue + '-of-12';
	                var oldSize = 'de-size--' + oldValue + '-of-12';
	                $element.removeClass(oldSize).addClass(newSize);
	            });

	            $scope.$watch('field.mediumWidth', function (newValue, oldValue) {
	                var newSize = 'de-medium-size--' + newValue + '-of-12';
	                var oldSize = 'de-medium-size--' + oldValue + '-of-12';
	                $element.removeClass(oldSize).addClass(newSize);
	            });

	            $scope.$watch('field.largeWidth', function (newValue, oldValue) {
	                var newSize = 'de-large-size--' + newValue + '-of-12';
	                var oldSize = 'de-large-size--' + oldValue + '-of-12';
	                $element.removeClass(oldSize).addClass(newSize);
	            });

	            if ($scope.field.customCss) {
	                $scope.$watch('field.customCss', function (newValue, oldValue) {
	                    $element.removeClass(oldValue).addClass(newValue);
	                });
	            }

	            //If edit-mode or display-mode changes, we need to reinitialize control
	            $scope.$watchGroup(['editMode', 'displayMode'], function () { $de.initUIControl($element, $scope, $attrs); });

	            $scope.model = $deForm.bindField($scope, $element, $attrs);

	            $scope.$watch('field.readonly', function (newValue) {	                
	                var input = $element.find('input');
	                if ($scope.errorManager[$scope.field.name]['invalid'])
	                    setTimeout(function () {
	                        $element.find("[ng-model ='model'][type !='hidden']").removeClass('ng-valid').addClass('ng-invalid');
	                    }, 5);
	                switch ($scope.field.type) {
	                    case 'picklist': input = $element.find('select'); break;
	                    case 'lookup': input = $element.find('input,button'); break;
	                }
	                if (newValue)
	                    input.attr('readonly', '');
	                else
	                    input.removeAttr('readonly');
	            })

	            $scope.switchToEdit = function () {
	                if (!($scope.readonlyMode || $scope.field.readonly) && $scope.readEditMode) {
	                    $scope.readMode = false;
	                    setTimeout(function () {
	                        if (!$scope.readMode) {
	                            switch ($scope.field.type) {
	                                case 'richtext': break;
	                                case 'textarea': $element.find('textarea').focus(); break;
	                                case 'picklist': $element.find('select').focus(); break;
	                                case 'date':
	                                case 'datetime':
	                                    break;
	                                default: $element.find('input').focus(); break;
	                            }
	                        }
	                    }, 5)
	                }
	            }

	            $scope.switchToReadOnly = function () {
	                if (!($scope.readonlyMode || $scope.field.readonly) && $scope.readEditMode) {
	                    $scope.readMode = true;
	                    if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                }
	            }
	            $scope.$watch('editMode', function (newVal, oldVal) {
                    if ($scope.editMode && $scope.editMode == 'read-only') {
                        $scope.validationManager(false, '')
                    }
	            });

	            var serverCriteria = '';
	            $scope.errorManager = {};
	            $scope.errorManager[$scope.field.name] = {};
	            $rootScope.errorMessage = {};

	            $scope.validationManager = function (isError, errMsg) {
	                $scope.errorManager[$scope.field.name]['invalid'] = isError;
	                $scope.errorManager[$scope.field.name]['errorMsg'] = errMsg;
	                var element = $element.find("[ng-model ='model'][type !='hidden']")
	                $rootScope.errorMessage[$scope.field.name] = $scope.errorManager[$scope.field.name];
	                if (isError) {
	                    $element.addClass('ng-invalid-pattern');
	                    element.removeClass('ng-valid').addClass('ng-invalid');
	                }
	                else {
	                    delete $rootScope.errorMessage[$scope.field.name];
	                    $element.removeClass('ng-invalid-pattern');
	                    element.addClass('ng-valid').removeClass('ng-invalid');
	                }	                
	                if (!$scope.$$phase && !$scope.$root.$$phase)
	                    $scope.$apply();
	            }

	            $scope.validateCallback = function (result) {
	                if (result != undefined) {
	                    if (!result) {
	                        $scope.errorManager[$scope.field.name]['name'] = 'Server Defintion.';
	                        $scope.validationManager(true, $scope.serverMsg);
	                    }
	                    else
	                        $scope.validationManager(false, '');
	                }
	            }

	            $scope.validateField = function () {
                    //If mode is design Then no validation should be performed
	                if ($scope.editMode != 'design') {
                        //If field is not requied and it is empty Then no further validation to perform and set field.invalid==false
	                    if (!$scope.field.required && !$scope.record[$scope.field.name])
	                        $scope.validationManager(false, '');
	                        //If field is requied and it is empty Then set field.invalid==true and required message
	                    else if ($scope.field.required && !$scope.record[$scope.field.name]) {
	                        $scope.errorManager[$scope.field.name]['name'] = 'Required Field.';
	                        $scope.validationManager(true, 'Required Field.You can not leave it blank.');
	                    }
	                    //If field is number
	                    else if ($scope.field.type == 'number') {
	                        var numberPattern = new RegExp('^[0-9]{0,' + ($scope.field.precision - $scope.field.scale) + '}(\.[0-9]{1,' + $scope.field.scale + '})?$');
	                        if (!numberPattern.test($scope.record[$scope.field.name])) {
	                            $scope.errorManager[$scope.field.name]['name'] = 'Wrong number input.';
	                            $scope.validationManager(true, 'Allowed precision is ' + $scope.field.precision + ' and scale is ' + $scope.field.scale);
	                            return;
	                        } else
	                            $scope.validationManager(false, '');
	                    } else if ($scope.field.type == 'email') {
	                        var mailformat = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	                        if (!mailformat.test($scope.record[$scope.field.name])) {
	                            $scope.errorManager[$scope.field.name]['name'] = 'Email.';
	                            $scope.validationManager(true, 'Please enter valid email');
	                            return;
	                        } else
	                            $scope.validationManager(false, '');
	                    } else if ($scope.field.type == 'phone') {
	                        var phoneformat = /^(\+\d{1,3}[- ]?)?\d{10}$/;
	                        if (!phoneformat.test($scope.record[$scope.field.name])) {
	                            $scope.errorManager[$scope.field.name]['name'] = 'Phone Number.';
	                            $scope.validationManager(true, 'Please enter valid phone number');
	                            return;
	                        } else
	                            $scope.validationManager(false, '');
	                    } else  {
	                        $scope.validationManager(false, '');
	                    }

                        //If field has no error Then move to client validation
	                    if(!$scope.errorManager[$scope.field.name]['invalid']){
	                        if ($scope.field.validationCriteria) {
	                        $scope.field.validationCriteria = $scope.field.validationCriteria.replace(/'/g, '"').replace(/\n/g, " ")
	                        var objValidation = JSON.parse($scope.field.validationCriteria).criteria;
	                        if (objValidation.isEnabled) {
	                            if (objValidation.exp) {
	                                for (var iIndex = 0; iIndex < objValidation.exp.length; iIndex++) {
	                                    if (!objValidation.exp[iIndex].isdisabled) {
	                                        var pattern = new RegExp(objValidation.exp[iIndex].regex);
	                                        if (!pattern.test($scope.record[$scope.field.name])) {
	                                            $scope.errorManager[$scope.field.name]['name'] = objValidation.exp[iIndex].name;
	                                            $scope.validationManager(true, objValidation.exp[iIndex].errmsg);
	                                            break;
	                                        } else
	                                            $scope.validationManager(false, '');
	                                    }
	                                }
	                            }
	                            if (!$scope.errorManager[$scope.field.name]['invalid'] && objValidation.client) {
	                                if (!objValidation.client.isdisabled) {
	                                    $scope.executeClientCriteria(objValidation.client.def, objValidation.client.clientmsg);
	                                    if (objValidation.client.fields) {
	                                        var strClientWatchFields = $scope.setupWatchFields(objValidation.client.fields);
	                                        $scope.$watch(strClientWatchFields, function (n, o) {
	                                            if (n != o)
	                                                $scope.validateField();
	                                        })
	                                    }
	                                }
	                            }
	                            if (!$scope.errorManager[$scope.field.name]['invalid'] && objValidation.server) {
	                                if (!objValidation.server.isdisabled) {
	                                    $scope.serverMsg = objValidation.server.servermsg;
	                                    serverCriteria = 'def = ' + objValidation.server.def + '($scope.record, $scope.validateCallback)';
	                                    $scope.executeServerCriteria();
	                                    if (objValidation.server.fields) {
	                                        var strServerWatchFields = $scope.setupWatchFields(objValidation.server.fields);
	                                        $scope.$watch(strServerWatchFields, function (n, o) {
	                                            if (n != o)
	                                                $scope.validateField();
	                                        })
	                                    }
	                                }
	                            }
	                        } else
	                            $scope.validationManager(false, '');
	                    }
	                    }
	                }
	            }

	            $scope.setupWatchFields = function (fields) {
	                var arrFields = [];
	                angular.forEach(fields, function (field) {
	                    $de.add(arrFields, 'record.' + field);
	                });
	                arrFields = '[' + arrFields.toString() + ']';
	                return arrFields;
	            }

	            $scope.executeClientCriteria = function (clientDef, errMsg) {
	                try {
	                    if (!eval('def = ' + clientDef + '($scope.record)')) {
	                        $scope.errorManager[$scope.field.name]['name'] = 'Client Definition.';
	                        $scope.validationManager(true, errMsg);
	                    }
	                    else
	                        $scope.validationManager(false, '');
	                } catch (exception) { }
	            }

	            $scope.executeServerCriteria = function () {
	                try {
	                    eval(serverCriteria);
	                } catch (exception) { }
	            }

	            $scope.preview = function ($event) {
	                $event.preventDefault();
	                $event.stopPropagation();
	                $element.find('.modal').modal();
	            }

	            $scope.close = function ($event) {
	                $event.preventDefault();
	                $event.stopPropagation();
	                $element.find('.modal').modal('hide');
	            }

	            $scope.restrictPropagation = function ($event) {
	                if ($event.keyCode == 13)
	                    $event.preventDefault();
	            }

	            $scope.onfieldaction = function ($event, action) {
	                switch (action.action) {
	                    case 'fullscreen':
	                        if (action.icon == 'fa-expand') {
	                            action.icon = 'fa-compress';
	                            //var parHeight = $element.parents().height();
	                            var parWidth = $element.parents().width();
	                            var node = $element.css({ width: parWidth + 'px' });
	                            $element.append(node);

	                        } else {
	                            action.icon = 'fa-expand';
	                            var node = $element.css({ width: '25%' });
	                            $element.append(node);

	                        }
	                        break;
	                        //Previous code
	                        //case 'fullscreen': $element.toggleClass('expanded'); action.icon = (action.icon == 'fa-expand') ? 'fa-compress' : 'fa-expand'; break;
	                }
	            }

	            $scope.saveEditedRecord = function (updatedRecord) {
                //Old code
	                //if ($scope.errorManager[$scope.field.name] && !$scope.errorManager[$scope.field.name]['invalid']) {
	                //    if ($scope.saveMode != "bulk" && $scope.saveMode)
	                //        $scope.switchToReadOnly();
	                //    $scope.$emit('editRecord', updatedRecord, $scope.switchToReadOnly);
	                //}

	                if ($scope.saveMode) {
	                    //to compare old value and new value. Modified by Kunal
	                    var oldVal = angular.isObject($scope.oldRecord[$scope.field.name]) ? $scope.oldRecord[$scope.field.name].Name :
                        $scope.oldRecord[$scope.field.name];
	                    var newVal = angular.isObject(updatedRecord[$scope.field.name]) ? updatedRecord[$scope.field.name].Name : updatedRecord[$scope.field.name];
	                    //Value of auto-complete field may be undefined. assigning it to empty('')
	                    oldVal != undefined ? oldVal : oldVal = ""; newVal != undefined ? newVal : newVal = "";
	                    if (!angular.equals(oldVal, newVal)) {
	                        //alert("old value " + oldVal + "  new value " +  newVal);
	                        if ($scope.errorManager[$scope.field.name] && !$scope.errorManager[$scope.field.name]['invalid']) {
	                            if ($scope.saveMode && $scope.saveMode == "instant")
	                                $scope.switchToReadOnly();
	                            $scope.$emit('editRecord', updatedRecord, $scope.switchToReadOnly);
	                        }
	                    }
	                    else {
                              $scope.switchToReadOnly();
	                    }
	                }
	            };

	            $scope.cancelEditedRecord = function (rec, field) {
	                //$de.setValue($scope.record, field.name, $scope.oldRecord[field.name]);
	                $scope.switchToReadOnly();
	            };

	            $scope.redirectLink = function (record, field) {
	                $scope.baseUrl = $engine.baseUrl;
	                $scope.record = record;
	                var url;
	                var text = $de.getValue(record, field.name);
	                if (field.type == 'lookup')
	                    text = $de.getValue(record, field.referenceByName ? (angular.isObject(record[field.name]) ? field.nameField : field.name) : field.nameField);
	                if (!text)
	                    url = '#';
                    else
	                    url = $interpolate(field.linkdetails.url)($scope);
	                //var target = field.linkdetails['target'] ? field.linkdetails['target'] : '_self';
	                return url;
	            }


	            var control = '<div ng-if="!(readonlyMode || field.readonly || readMode)" ng-class="{\'input-group\': (!inline)}" {!field-directive} />';
	            var template = '<label ng-if="!noLabel && !inline" de-field-label="field" mode="mode" ng-keydown="restrictPropagation($event)"></label>';
	            template += '<input name="{{elementName}}" type="hidden" ng-model="model" ng-model-options="{ getterSetter: true}" ng-required="field.required"/>';
	            switch ($scope.field.type) {
	                case 'icon': template += '<div class="readonly-control" ng-if="readonlyMode || field.readonly || readMode" ng-dblclick="switchToEdit()" ><i class="{{\'fa \' + $de.getDisplayText(record, field, \'fa-ellipsis-h\')}}" /></div>'; break;
	                case 'checkbox': template += '<div read-only="true" de-checkbox-field ng-dblclick="switchToEdit()" ></div>'; break;
	                case 'code': template += '<div ng-class="{\'input-group\': (field.required || !inline)}" de-code-field ></div>'; break;
	                case 'richtext': template += '<div ng-class="{\'input-group\': (field.required || !inline)}" de-rich-text-field ></div>'; break;
	                case 'textarea': template += '<div ng-class="{\'input-group\': (field.required || !inline)}" de-text-area-field ></div>'; break;
	                default: template += '<div class="readonly-control" ng-if="readonlyMode || field.readonly || readMode" ng-dblclick="switchToEdit()" ng-class="errorManager[field.name].invalid ? \'\' : \'\'">\
											 <span ng-if="!field.linkdetails">{{$de.getDisplayText(record, field, "-")}}</span>\
                                             <a  ng-if="field.linkdetails" ng-href="{{redirectLink(record,field)}}">{{$de.getDisplayText(record, field, "-")}}</a>  \
											 <span ng-if="errorManager[field.name].invalid" popover-title="Validation Failed: {{errorManager[field.name].name}}" popover-trigger="mouseenter" popover-placement="left" uib-popover="{{errorManager[field.name].errorMsg}}" class="error-span fa fa-exclamation-circle"></span>\
										</div>'; break;
	            }

	            var directive;
	            switch ($scope.field.type) {
	                case 'lookup': directive = 'de-auto-complete-field'; break;
	                case 'currency': directive = 'de-currency-field'; break;
	                case 'date': directive = 'de-date-field'; break;
	                case 'datetime': directive = 'de-datetime-field'; break;
	                case 'password': directive = 'de-password-field'; break;
	                case 'phone': directive = 'de-phone-field'; break;
	                case 'email': directive = 'de-email-field'; break;
	                case 'picklist': directive = 'de-picklist-field'; break;
	                case 'tags': directive = 'de-tags-field'; break;
	                case 'text': directive = 'de-text-field'; break;
	                case 'number': directive = 'de-currency-field'; break;
	                case 'richtext':
	                case 'textarea':
	                case 'code':
	                case 'checkbox': control = ''; break;
	                case 'icon': directive = 'de-icon-field'; break;
	                default: control = '<div class="alert alert-danger" role="alert"><span class="glyphicon glyphicon-exclamation-sign" aria-hidden="true"></span><span class="sr-only">Error:</span>Field type [{{field.type}}] not supported.</div>'; break;
	            }

	            if (directive)
	                control = control.replace('{!field-directive}', directive);
	            template += control;

	            $element.append(template);
	            $compile($element.contents())($scope);
	        }],
	    }
	}])
	.directive('deTagsField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: '<div de-auto-complete-field /><div class="de-tag-cloud"><div class="tag" ng-repeat="tag in tags">{{tag}}\
					<button ng-click="deleteTag($event, tag)" type="button" class="close" aria-label="Close"><span aria-hidden="true">×</span></button>\
					</div></div>',
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	            if (!$scope.field.checkedLabel) $scope.field.checkedLabel = 'Yes';
                if (!$scope.field.uncheckedLabel) $scope.field.uncheckedLabel = 'No';
                var saveAs = $scope.field.save_as ? $scope.field.save_as : 'string';
                console.log($scope.field.save_as);
                $scope.tags = [];
	            $scope.$watch('record.' + $scope.field.name, function (newValue) {
	                var value = $scope.model();
                    if (value && Object.prototype.toString.call(value) != "[object Object]" )
                    {
                        if (saveAs == 'array')
                            $scope.tags = value;
                        else
                            $scope.tags = value.split(',');
                    }
                    //else
                    //    $scope.tags = [];
	            })

                $scope.onchange = function (record) {
                    //this condition is for cella .Noe you can save Other than Name field in tags
                    if (!$scope.field.reference_name.includes("__r")) {
                        if ($scope.tags.indexOf(record[$scope.field.reference_name]) < 0) {
                            $scope.tags.push(record[$scope.field.reference_name]);
                            save();
                        }
                    }
                    else if ($scope.tags.indexOf(record.Name ? record.Name : record.name) < 0) {
                            $scope.tags.push((record.Name ? record.Name : record.name));
                            save();
                            //if (saveAs == 'array')
                            //    $scope.model($scope.tags);
                            //else
                            // $scope.model($scope.tags.join(','));
                        }
                    }
                    var save = function () {
                        if (saveAs == 'array')
                            $scope.model($scope.tags);
                        else
                            $scope.model($scope.tags.join(','));
                    }
                    $scope.deleteTag = function ($event, tag) {
                        if ($scope.tags.indexOf(tag) >= 0) {
                            $de.remove($scope.tags, tag);
                            save();
                            //if (saveAs == 'array')
                            //    $scope.model($scope.tags);
                            //else
                            // $scope.model($scope.tags.join(','));
                        }
                    }

                }]
	    }
	}])
	.directive('deCheckboxField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: '<div class="de-switch" style="max-width: 140px;min-width:110px;" >\
				<input name="{{field.name}}" id="{{field.name}}" type="checkbox" ng-blur="saveEditedRecord(record)" ng-model="model" ng-disabled="field.readonlyMode || readonlyMode || readMode" \
				ng-model-options="{ getterSetter: true, debounce: 300 }" >\
				<div>\
					<div class="handle">&nbsp;</div>\
					<div class="on">{{field.checkedLabel}}</div>\
					<div class="off">{{field.uncheckedLabel}}</div>\
				</div>\
			</div>',
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	            if (!$scope.field.checkedLabel) { $scope.field.checkedLabel = 'Yes'; }
	            if (!$scope.field.uncheckedLabel) { $scope.field.uncheckedLabel = 'No'; }
	            if ($scope.record[$scope.field.name] == null || $scope.record[$scope.field.name] == undefined)
	                $scope.record[$scope.field.name] = false;
	        }]
	    }
	}])
	.directive('dePasswordField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: $deForm.requiredAddon + $deForm.inputTemplate.replace('{!type}', 'password'),
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {

	        }]
	    }
	}])
	.directive('deTextAreaField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: $deForm.requiredAddon + '<div ng-class="{\'form-control\': !inline}" >\
					<div ng-if="!inline" ><div de-action-bar="fieldActions" class="field-actions" onaction="onfieldaction($event,action)" display="\'toolbar\'"  ></div></div>\
					<textarea ng-required="field.required" \
							ng-model="model" ng-model-options="{ getterSetter: true, debounce: 300 }" \
							ng-pattern="field.pattern.expression" placeholder="{{field.label}}" maxlength="{{field.max}}" class="form-control" ng-blur="saveEditedRecord(record);validate()" ng-dblclick="switchToEdit()" />\
					</div>',
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	            $scope.$watchGroup(['field.readonlyMode', 'readonlyMode', 'readMode'], function () {
	                var editor = $element.find('textarea');
	                if ($scope.field.readonlyMode || $scope.readMode || $scope.readonlyMode) {
	                    editor.attr('readonly', '');
	                }
	                else
	                    editor.removeAttr('readonly');
	            })
	            $scope.fieldActions = [{
	                name: 'fullscreen',
	                icon: 'fa-expand',
	                action: 'fullscreen',
	            }];
	        }]
	    }
	}])
	.directive('deCodeField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: $deForm.requiredAddon + '<div ng-class="{\'form-control\': !inline}" >\
						<div ng-if="!inline"><div de-action-bar="fieldActions" class="field-actions" onaction="onfieldaction($event,action)" display="\'toolbar\'"></div></div>\
						<div class="code-cls col-md-12 no-padding" ui-ace="options" ng-dblclick="switchToEdit()" ng-model="record[field.name]" ng-model-options="{ getterSetter: true }"></div></div>',
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	            $scope.$watchGroup(['field.readonlyMode', 'readonlyMode', 'readMode'], function () {
	                var editor = $element.find('[ui-ace]');
	                if ($scope.field.readonlyMode || $scope.readMode || $scope.readonlyMode) {
	                    $scope.editor.setReadOnly(true);
	                    $element.addClass('readonly');
	                }
	                else {
	                    $scope.editor.setReadOnly(false);
	                    $element.removeClass('readonly');
	                }
	            })

	            $scope.fieldActions = [{
	                name: 'fullscreen',
	                icon: 'fa-expand',
	                action: 'fullscreen',
	            }];

	            $scope.options = {
	                useWrapMode: true,
	                mode: $scope.field.codeType,
	                showPrintMargin: false,
	                theme: 'twilight',
	                onBlur: function () {
	                    $scope.switchToReadOnly();
	                },
	                onLoad: function (editor) {
	                    $scope.editor = editor;
	                },
	                onFocus: function () {
	                    $scope.switchToEdit();
	                }
	            }
	        }]
	    }
	}])
	.directive('deRichTextField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: $deForm.requiredAddon + '<div ng-class="{\'form-control\': !inline}" >\
<div ng-if="(readonlyMode || field.readonly || readMode)" ng-bind-html="model()" class="richtext-ouput" ng-dblclick="switchToEdit()" ></div>\
<textarea ng-if="!(readonlyMode || field.readonly || readMode)" ui-tinymce="options" ng-model="model" ng-model-options="{ getterSetter: true }" ></textarea></div>',
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {

	            $scope.options = {
	                trusted: true,
	                theme: "modern",
	                plugins: [
					  "advlist autolink lists link image charmap print preview hr anchor pagebreak",
					  "searchreplace visualblocks visualchars code fullscreen",
					  "insertdatetime media nonbreaking save table contextmenu directionality",
					  "emoticons template paste textcolor colorpicker textpattern imagetools"
	                ],
	                toolbar1: "forecolor backcolor bold italic bullist numlist | outdent indent link image print preview expand",
	                setup: function (editor) {
	                    editor.on('blur', function (e) {
	                        $scope.switchToReadOnly();
	                    });
	                    editor.on('init', function (e) {
	                        $scope.editor = editor;
	                        editor.focus();
	                    });
	                    editor.addButton('expand', {
	                        icon: 'fullscreen',
	                        onclick: function () {
	                            $scope.onfieldaction(null, $scope.fieldActions[0]);
	                        }
	                    })
	                },
	                image_advtab: true,
	                menubar: false,
	                statusbar: false,
	            }

	            $scope.fieldActions = [{
	                name: 'fullscreen',
	                icon: 'fa-expand',
	                action: 'fullscreen',
	            }];
	        }]
	    }
	}])
	.directive('deTextField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: $deForm.requiredAddon + $deForm.inputTemplate.replace('{!type}', 'text'),
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	        }]
	    }
	}])
	.directive('dePhoneField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: $deForm.requiredAddon + $deForm.inputTemplate.replace('{!type}', 'phone'),
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	        }]
	    }
	}])
	.directive('deEmailField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: $deForm.requiredAddon + $deForm.inputTemplate.replace('{!type}', 'email'),
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	        }]
	    }
	}])
	.directive('deCurrencyField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: $deForm.requiredAddon + $deForm.inputTemplate.replace('{!type}', 'number'),
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	        }]
	    }
	}])
	.directive('dePicklistField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: $deForm.requiredAddon + '<select name="{{field.name}}" id="{{field.name}}" ng-required="field.required" \
			ng-model="model" ng-model-options="{ getterSetter: true, debounce: 300 }" ng-blur="saveEditedRecord(record)" \
			placeholder="{{field.label}}" class="form-control"><option ng-repeat="value in values">{{(value.value)?value.value:value}}</option></select>',
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	            if ($scope.field.controlledBy) {
	                if ($scope.record && $scope.record[$scope.field.controlledBy])
	                    $scope.values = $scope.field.values[$scope.record[$scope.field.controlledBy]];

	                $scope.$watch('record.' + $scope.field.controlledBy, function () {
	                    if ($scope.record && $scope.record[$scope.field.controlledBy])
	                        $scope.values = $scope.field.values[$scope.record[$scope.field.controlledBy]];
	                })
	                $scope.$watch('record.Country__c', function () {
	                    if ($scope.record && $scope.record["Country__c"])
	                        $scope.values = $scope.field.values[$scope.record["Country__c"]];
	                })
	            }
	            else {
	                $scope.values = $scope.field.values;
	            }
	        }]
	    }
	}])
	.directive('deIconField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: $deForm.requiredAddon + '\
			<div class="input-group"><div ng-class="{\'form-control\': !inline}" data-toggle="dropdown" ng-click="showIcons($event)"><i class="fa {{icon}}" ng-if="!(readonlyMode || field.readonly)"></i>\
			<button ng-if="!inline" ng-click="switchToReadOnly()" type="button" class="close" aria-label="Close"><span aria-hidden="true">×</span></button>\
			<button ng-if="!inline" ng-click="deleteIcon($event)" type="button" class="close" aria-label="Close"><i class="fa fa-trash"></i></button></div>\
			<i class="form-control fa {{icon}}" ng-if="readonlyMode || field.readonly" ></i>\
			<div class="dropdown-menu icon-panel"><div class="de-grid de-wrap"><input class="" type="search" ng-model="keyword"  ng-model-options="{ debounce: 300 }"></input>\
			<div class="de-col icon" ng-repeat="icon in icons|filter:keyword" ><i class="fa {{icon}}" ng-click="selectIcon($event, icon)" title="{{icon}}"></i></div>\
			</div></div></div>',
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	            if ($scope.record) {
	                $scope.$watch('record.' + $scope.field.name, function (newValue) {
	                    $scope.icon = (newValue) ? newValue : 'fa-ellipsis-h';
	                })
	            }
	            else if ($scope.field.icon) {
	                $scope.icon = $scope.field.icon;
	            }

	            $scope.showIcons = function () {
	                $scope.icons = $deForm.getIcons();
	            }

	            $scope.deleteIcon = function ($event) {
	                $event.preventDefault();
	                $event.stopPropagation();
	                $scope.model('');
	            }

	            $scope.selectIcon = function ($event, icon) {
	                $scope.model(icon);
	                $scope.switchToReadOnly();
	            }
	        }]
	    }
	}])
	.directive('deFieldLabel', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: '<div ng-if="!designMode">{{field.label}}</div>\
				<div ng-if="designMode"><input class="inline-edit" ng-model="field.label" type="text" maxlength="80" ng-model-options="{ debounce: 300 }"></div>\
				<div ng-if="designMode" class="designer-bar" de-action-bar="actions" display="\'toolbar\'" onaction="takeAction($event,action)" ></div>\
				<div ng-if="designMode" class="designer-bar">\
				<input class="width de-small" type="number" ng-model="field.smallWidth" min="1" max="12" step="1"/>\
				<input class="width de-medium" type="number" ng-model="field.mediumWidth" min="1" max="12" step="1"/>\
				<input class="width de-large" type="number" ng-model="field.largeWidth" min="1" max="12" step="1"/>\
				</div>\
				',
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	            //$element.attr('for', $scope.field.name);
	            $scope.$de = $de;

	            //var formName = $element.parents('form').attr('name');
	            //if (formName && $scope.$parent[formName]) {
	            //    $scope.deForm = $scope[formName] = $scope.$parent[formName];
	            //}

	            $scope.$watch('[field.visibilityCriteria, field.validationCriteria]', function (newVal) {
	                if (newVal[0] != undefined || newVal[1] != undefined)
	                    $scope.actions[2].type = 'default criteria-enabled';
	                else
	                    $scope.actions[2].type = 'default';
	            })

	            $scope.actions = [
					{ icon: function () { return ($scope.field.required) ? 'fa-check-circle-o' : 'fa-circle-o' }, label: 'Required', action: 'required', type: 'default' },
					{ icon: function () { return ($scope.field.readonly) ? 'fa-lock' : 'fa-unlock-alt' }, label: 'Readonly', action: 'readonly', type: 'default' },
					{ icon: 'fa-cog', label: 'Settings', action: 'settings', type: 'default' },
					{ icon: 'fa-trash', label: 'Remove', action: 'remove', type: 'default' },
	            ]

	            $scope.takeAction = function ($event, action) {
	                switch (action.action) {
	                    case 'required':
	                        $scope.field.required = !$scope.field.required;
	                        break;
	                    case 'readonly':
	                        $scope.field.readonly = !$scope.field.readonly;
	                        break;
	                    case 'settings':
	                        $scope.$parent.$parent.openSettingWizard($scope.fieldindex, 'field');
	                        break;
	                    case 'remove':
	                        $scope.$emit('remove-field', $scope.field);
	                        break;
	                }
	            }
	        }]
	    }
	}])
	.directive('deDateField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: '' + $deForm.requiredAddon + '<input id="{{field.name}}" type="text" ng-required="field.required" \
				ng-model="displayText" autocomplete="off" ng-blur="saveEditedRecord(record)" placeholder="{{field.overlay-label}}" class="form-control" />\
                <span ng-if="errorManager[field.name].invalid" style="left: 80%" popover-title="Validation Failed:: {{errorManager[field.name].name}}" popover-trigger="mouseenter" popover-placement="left" uib-popover="{{errorManager[field.name].errorMsg}}" class="error-span fa fa-exclamation-circle"></span>\
				<span ng-if="!inline" ng-click="switchToReadOnly()" title="click to save" class="input-group-addon"><span  class="glyphicon glyphicon-calendar"></span></span><span ng-if="inline" class="label">&nbsp;</span>',
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	            $scope.dateFormat = 'YYYY/MM/DD';

	            if ($attrs.format != undefined)
	                $scope.dateFormat = $attrs.format;
	            $scope.test = function () {
	                alert("on blure event");
	            }
	            $scope.$watch('record.' + $scope.field.name, function (newValue) {
	                var value = $de.getValue($scope.record, $scope.field.name);
	                if (value) {
	                    $scope.displayText = moment(value).format($scope.dateFormat);
	                    $scope.validateField();
	                }
	                else
	                    $scope.displayText = '';
	            })

	            $timeout(function () {
	                $($element).find('#' + $scope.field.name).datetimepicker({ format: $scope.dateFormat, widgetPositioning: { horizontal: 'left', vertical: 'bottom' } }).on('dp.change', function (event) {
	                    var value = $(event.currentTarget).val();
	                    if (value)
	                        $de.setValue($scope.record, $scope.field.name, moment(value, $scope.dateFormat).toDate());
	                    else
	                        $de.setValue($scope.record, $scope.field.name, '');
	                    $scope.switchToReadOnly();
	                    $scope.$apply();
	                });
	            }, 20);
	        }]
	    }
	}])
	.directive('deDatetimeField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: '' + $deForm.requiredAddon + '<input id="{{field.name}}" type="text" ng-required="field.required" \
				ng-model="displayText" placeholder="{{field.label}}" class="form-control" />\
				<span ng-if="!inline" ng-click="switchToReadOnly()" class="input-group-addon"><span class="glyphicon glyphicon-time"></span></span><span ng-if="inline" class="overlay-label">&nbsp;</span>',
	        controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile) {
	            $scope.dateTimeFormat = 'YYYY/MM/DD hh:mm A';

	            if ($attrs.format != undefined)
	                $scope.dateTimeFormat = $attrs.format;

	            $scope.$watch('record.' + $scope.field.name, function () {
	                var value = $de.getValue($scope.record, $scope.field.name);
	                if (value)
	                    $scope.displayText = moment(value).format($scope.dateTimeFormat);
	                else
	                    $scope.displayText = '';
	            })

	            $timeout(function () {
	                $($element).find('#' + $scope.field.name).datetimepicker({
	                    format: $scope.dateTimeFormat, widgetPositioning: { horizontal: 'left', vertical: 'bottom' }
	                }).on('dp.change', function (event) {
	                    var value = $(event.currentTarget).val();
	                    if (value)
	                        $de.setValue($scope.record, $scope.field.name, moment(value, $scope.dateTimeFormat).toDate());
	                    else
	                        $de.setValue($scope.record, $scope.field.name, '');
	                    $scope.$apply();
	                });
	            }, 20);
	        }]
	    }
	}])
	.directive('deAutoCompleteField', ['$deForm', function ($deForm) {
	    return {
	        restrict: designerExpertForm.restrict,
	        template: '\
		<div class="input-group">' + $deForm.requiredAddon + '\
			<input type="text" data-toggle="dropdown" ng-click="onclick($event)" ng-model="name" \
			ng-model-options="{ debounce: 500 }" ng-blur="saveMode ? callSaveEdit(record) : 0" ng-keydown="onKeyDown($event)"\
			placeholder="{{field.label}}" class="form-control" />\
			<div class="dropdown-menu"><table class="table table-striped table-responsive"><thead ng-show="((!lookupRecords || !lookupRecords.length) && !lookupError) || searchOn">\
		<tr><td><img ng-if="searchOn" style="height: 20px;padding-right: 5px;" ng-src="/application_css/images/loading.gif" class="imgsearch"/><span ng-if="searchOn">Searching...</span><span ng-if="!searchOn"><i class="glyphicon glyphicon-exclamation-sign" aria-hidden="true"/> No records found</span></td></tr></thead>\
		<thead ng-show="lookupError"><tr><td><div class="alert alert-danger" role="alert">\
		<span class="glyphicon glyphicon-exclamation-sign" aria-hidden="true"></span>\
		<span class="sr-only">Error:</span>{{lookupError}}</div></td></tr></thead>\
		<thead ng-show="lookupRecords && lookupRecords.length && !searchOn"><tr><th ng-repeat="recordField in lookupFields">{{recordField.label}}</th></tr></thead>\
		<tr ng-repeat="record in lookupRecords | filter:name" ng-click="rowSelected(record)" id="{{$de.getValue(record, lookupIdField)}}" \
		ng-class="{info: $parent.selected == $index}"\
		ng-mouseover="$parent.selected = $index">\
		<td ng-repeat="recordField in lookupFields" class="lookup-records" style="cursor: hand;">{{(record.Label)?record.Label+" ("+record.Name+")":record.name}}</td></tr>\
		</table></div>\
		<span ng-if="!inline" ng-click="delete()" class="input-group-addon" aria-haspopup="true" aria-expanded="false"><span class="glyphicon glyphicon-trash"></span></span>\
		<span ng-if="!inline && !noLabel && designMode" ng-click="switchToReadOnly();manageSearchSettings();" class="input-group-addon" aria-haspopup="true" aria-expanded="false"><span class="glyphicon glyphicon-cog" title="Criteria"></span></span><span ng-if="inline" class="overlay-label">&nbsp;{{name}}</span>\
		</div>',
            controller: ['$scope', '$attrs', '$element', '$interpolate', '$de', '$deForm', '$timeout', '$compile', '$filter', '$engine', '$rootScope', function ($scope, $attrs, $element, $interpolate, $de, $deForm, $timeout, $compile, $filter, $engine, $rootScope) {
	            var fetchRecords = function (keyword, field, onsuccess, onerror) {
	                if (window.fromPlatform) {
	                    if (field.criteria.length > 2)
	                        var criteria = $interpolate(field.criteria)($scope);
	                    else
	                        var criteria = field.criteria;
                        //$engine.fetchRecordsWithCount(keyword, field.ReferenceObjectName, field.searchLimit, field.thresholdLimit, criteria, function (error) {
                        $engine.fetchRecordsWithCount(keyword, angular.copy(field), criteria, function (error) {
	                        if (error.success) {
	                            records = (error.data.Data) ? error.data.Data : error.data.data;
	                            totalCount = (error.data.TotalRecords) ? error.data.TotalRecords : error.data.totalCount
	                            onsuccess({ totalCount: error.data.TotalRecords, idField: 'id', nameField: field.nameField.split('.')[1], fields: [{ label: 'Name', type: 'text', name: 'name' }], records: records });
	                        }
	                        else {
	                            if (error.data.Code == 'PermissionDeniedOnObject')
	                                error.ErrorMessage = 'You do not have ' + error.data.ErrorMessage + ' permission on ' + keyword + ' Object.';
	                            utills.showError(error.data.ErrorMessage);
	                        }
	                    });
	                }
	                else {
	                    var records = [];
                        for (var iIndex = 1; iIndex <= 100; ++iIndex)
                            records.push({ Id: 'Organization-' + iIndex, Name: 'Organization-' + iIndex, Label: 'Organization-' + iIndex });
	                    if (keyword == 'error')
	                        onerror('Could not reach the server');
	                    else
	                        onsuccess({
	                            totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records

	                        }, function (error) { onerror('Could not reach the server'); });
	                }
	            }

	            $scope.designerUrl = window.designerUrl;
	            //flag = 0 when search input field is undefiened
	            var flag = 0;
	            //Watch Object that is set to auto complete field.
	            //This object is set in from clause of select query
                $scope.$watch('record.' + $scope.field.name, function (newValue, oldValue) {                  
	                if (!newValue)
	                    $scope.name = '';
	                else {
	                    if (newValue.Label)
	                        $scope.name = newValue.Label;
	                    else if ($de.getValue($scope.record, $scope.field.nameField))
	                        $scope.name = $de.getValue($scope.record, $scope.field.nameField);
	                }
	            })
	            //modal dailog box to add limit,threshold and criteria
	            $scope.manageSearchSettings = function () {
	                $deForm.manageLookupSettingDialog(angular.copy($scope.field), $scope.saveFieldDetails);
	            }

	            $scope.saveFieldDetails = function (field, callback) {
	                $scope.field = field;
	                $scope.$emit("SaveFieldCriteria", $scope.fieldindex.slice(0, $scope.fieldindex.indexOf('_')), $scope.fieldindex.slice($scope.fieldindex.indexOf('_') + 1, $scope.fieldindex.length), field);
	                callback();
	            }

	            //when delete button is clicked, clears input field and set record to empty
	            $scope.delete = function () {
                    $scope.name = '';
                    //if (window.platform != 'cella')
                        $de.setValue($scope.record, $scope.field.name, ''); 
                    if ($scope.field.reference_name.includes("__"))
                        $de.setValue($scope.record, $scope.field.reference_name, null);
	            }

	            $scope.callSaveEdit = function (record) {
	                setTimeout(function () {
	                    if ($scope.saveMode == "bulk")
	                        $scope.saveEditedRecord(record);
	                }, 500)
	            }

	            $scope.onclick = function ($event) {
                    if ($scope.field.readonly) {
                        $event.preventDefault();
                        $event.stopPropagation();
                    } else                                                                  //added this condition Bcoz dropdown was not opening on Click
                        if (!$element.find('.input-group').hasClass('open'))
                            $element.find('.input-group').addClass('open');
	            }

	            //to do
	            function textHighlighter(word, lstElement) {
	                var rgxp = new RegExp(word, 'g');
	                var repl = '<span class="text-higlighted">' + word + '</span>';
	                angular.forEach(lstElement, function (elem) {
	                    elem.innerHTML = elem.innerHTML.replace(rgxp, repl);
	                })
	            }

	            //Actions to be taken on keyboard keys
	            $scope.onKeyDown = function ($event) {
	                switch ($event.keyCode) {
	                    case 40://Key Down
	                        if (isNaN($scope.selected))
	                            $scope.selected = 0;
	                        else if ($scope.lookupRecords) {
	                            if ($scope.selected < ($scope.lookupRecords.length - 1))
	                                ++$scope.selected;
	                        }
	                        break;
	                    case 38://Key Up
	                        if (isNaN($scope.selected))
	                            $scope.selected = 0;
	                        else if ($scope.lookupRecords) {
	                            if ($scope.selected > 0)
	                                --$scope.selected;
	                        }
	                        break;
	                    case 27: //Kye Escape
	                        $scope.name = $de.getValue($scope.record, $scope.field.nameField);
	                        break;
	                    case 9: //Key Tab
	                    case 13: //Key Enter
	                        if ($element.find('.input-group').hasClass('open')) {
	                            var records = $filter('filter')($scope.lookupRecords, $scope.name);
	                            if (records)
	                                $scope.rowSelected(records[$scope.selected]);
	                        }
	                        $event.preventDefault();
	                        $event.stopPropagation();
	                        break;
	                }

	                if ($event.keyCode == 40 || $event.keyCode == 38) {
	                    var position = $element.find('table tr:nth-child(' + $scope.selected + ')').position();
	                    if (position) {
	                        var elementTop = position.top;
	                        var scrollTop = $element.find('.dropdown-menu').scrollTop();
	                        var scrollTo = elementTop + scrollTop;
	                        $element.find('.dropdown-menu').scrollTop(scrollTo);
	                    }
	                }

	                switch ($event.keyCode) {
	                    case 9: //Key Tab
	                    case 13: //Key Enter
	                    case 27: //Key Escape
	                    case 46: //Key Delete
	                        $element.find('.input-group').removeClass('open');
	                        break;
	                    default:
	                        $element.find('.input-group').addClass('open');
	                }
	            }

	            //set sets result to scope. contains record, id, name and field
	            $scope.manageSearchResult = function (word, result) {
	                $scope.lookupFields = result.fields;
	                $scope.lookupRecords = result.records;
	                $scope.lookupIdField = result.idField;
	                $scope.lookupNameField = result.nameField;
	                if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	            }

	            //show error
	            $scope.manageError = function (error) {
	                $de.showError(error);
	                if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	            }

	            $scope.searchOn = false;
	            $scope.stopServerSearch = false;

	            //user input field watch
	            $scope.$watch('name', function (newValue, oldValue) {
                    if ($scope.doNotGetLookupRecords && newValue != oldValue) {
                        //this function is in delayout directive to remove ralatedlist from account detaile view
                        $rootScope.removeRelatedlist(newValue);
	                    delete $scope.doNotGetLookupRecords;
	                    return;
	                }

	                if (newValue == undefined || newValue.length <= 0) {
	                    //if name field is empty('') after delete or on page load
	                    if (newValue != oldValue) {
                            $scope.field['keyword'] = null;
                            if (window.platform != 'cella')
	                            $de.setValue($scope.record, $scope.field.name, ''); 
	                        //$de.setValue($scope.record, $scope.field.nameField, '');
	                        $scope.stopSearchOnServer = false;
	                        $scope.manageSearchResult(newValue, $scope.defaultSearchRecords);
	                    }
	                }

	                $scope.searchOn = true;
	                //indexOf checks for wheather oldValue contains newValue
	                if (newValue != oldValue && oldValue != undefined && oldValue.indexOf(newValue) == -1) {
	                    if ($scope.stopSearchOnServer && newValue!="") {
	                        fetchRecords(newValue, $scope.field, function (result) {
	                            $scope.stopSearchOnServer = result.totalCount <= 100;
	                            $scope.manageSearchResult(newValue, result);
	                            if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                            $scope.searchOn = false;
	                        }, function () {
	                            $scope.searchOn = false;
	                            $scope.manageError(error);
	                        });
	                    } else
	                        $scope.searchOn = false;
	                } else
	                    $scope.searchOn = false;
	            })

	            $scope.rowSelected = function (record) {
	                $scope.doNotGetLookupRecords = true;
	                var id = $de.getValue(record, $scope.lookupIdField);
	                var name = $de.getValue(record, $scope.lookupNameField);

	                if ($scope.field.referenceByName)
	                    $de.setValue($scope.record, $scope.field.name, name);
	                else {
	                    $de.setValue($scope.record, $scope.field.name, id);
                        if ($scope.field.reference_name.includes("__")) //this condition added by sandip for cella
                            $scope.record[$scope.field.reference_name] = record.Label ? { Name: name, Id: id, Label: record.Label } : { name: name, id: id };                        
	                }

	                $scope.name = record.Label ? record.Label : name;

	                if ($scope.onchange)
                        $scope.onchange(record);
                    else if ($scope.saveMode != "bulk" && $scope.saveMode != undefined )
	                    $scope.switchToReadOnly();
	                $scope.field['keyword'] = record.Label ? { name: name, id: id, label: record.Label } : { name: name, id: id };
	                if ($scope.saveMode != undefined)
	                    $scope.saveEditedRecord($scope.record);
	            }

	            //fetch records when input field is undefined or empty
	            function getDropDownRecords() {
	                $scope.searchOn = true;
	                fetchRecords(($scope.name == undefined) ? $scope.name = "" : $scope.name, $scope.field, function (result) {
	                    $scope.stopSearchOnServer = result.totalCount <= 100;
	                    $scope.defaultSearchRecords = result;
	                    $scope.manageSearchResult($scope.name, result);
	                    if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                    $scope.searchOn = false;
	                }, function () {
	                    $scope.searchOn = false;
	                    $scope.manageError(error);
	                });
	            };

	            $scope.getDropDownRecords = function () {
	                if ($scope.name == undefined || $scope.name.length <= 0) {
	                    flag = 1;
	                    getDropDownRecords();
	                }
	            }();
	        }]
	    }
	}])
	.directive('deOverlay', ['$deForm', function ($deForm) {
	    return {
	        template: '&nbsp;<span class="overlay-label">{{layout.relatedlists.label}}</span><input ng-model="ngModel" placeholder="{{$attrs.placeholder}}" />',
	        scope: {
	            ngModel: '=deOverlay',
	        },
	        controller: ['$scope', '$de', '$attrs', '$element', function ($scope, $de, $attrs, $element) {
	            $element.addClass('de-overlay');
	            $scope.$attrs = $attrs;
	        }]
	    }
	}])