var designerExpertTable = {
	restrict: 'A',
}

$.skylo({
	state: 'info',
	inchSpeed: 200,
	initialBurst: 5,
	flat: false
});
angular.module('deServices', ['ngAnimate', 'toaster', 'ngSanitize'])
	.factory('$de', ['$filter', '$rootScope', '$compile', 'toaster', '$sce', '$interpolate', function ($filter, $rootScope, $compile, toaster, $sce, $interpolate) {
		//First thing first, let's add toaster container if not already added so errors can be displayed in single toaster in entire application.
		setTimeout(function () {
			if (!jQuery("#toaster-container").length) {
				jQuery('body').prepend('<div id="toaster-container"><toaster-container></toaster-container></div>');
				$compile(jQuery("#toaster-container").contents())($rootScope);
			}
		}, 300);
		if (!window.templatesFolder) {
		    window.templatesFolder = 'application_js/templates/';
		    window.designerUrl = 'http://designer.expert/';
		}
		var $de = {
			progressInterval: undefined,
			templatesFolder: window.templatesFolder,
			lookupNameField: 'Name',
			getDisplayText: function (record, field, blankValue) {
			    var scope = { record: record };
				var value = $de.getValue(record, field.name);
				var text = value;
				switch (field.type) {
					case 'currency': text = $filter('currency')(value, field.currency, 2); break;
					case 'date': text = $filter('date')(value, 'yyyy-MM-dd'); break;
					case 'datetime': text = $filter('date')(value, 'yyyy-MM-dd hh:mm a'); break;
					case 'decimal': text = $filter('number')(value, field.decimal); break;
				    case 'lookup': text = $de.getValue(record, field.referenceByName ? (angular.isObject(record[field.name]) ? field.nameField : field.name) : field.nameField); break;
					case 'checkbox': text = (value) ? 'true' : 'false'; break;
					case 'richtext': text = $sce.trustAsHtml(value); break;
                    case 'password': text = '*******'; break;
                    case 'tags': 
                        if (field.save_as == 'array')
                            text = $de.getValue(record, field.name) == null ? "" : $de.getValue(record, field.name).join();
                        else
                            text = $de.getValue(record, field.name);
                        break;
				}
				if (blankValue && !text)
				    return blankValue;
				if (field.template) {
				    if (field.type != 'CheckBox' || field.type != 'Date' || field.type != 'DateTime')
			            var val = $interpolate(field.template)(scope)
			            return val;
				}

				return angular.isObject(text) ? text.value : text;
			},
			showSuccess: function (message, title, bodyType) {
				toaster.pop('success', title, message, 5000, bodyType);
			},
			showError: function (message, title, bodyType) {
			    toaster.pop('error', title, message, 5000, bodyType);
			},
			showWarning: function (message, title, bodyType) {
				toaster.pop('warning', title, message, 5000, bodyType);
			},
			showInfo: function (message, title, bodyType) {
				toaster.pop('info', title, message, 5000, bodyType);
			},
			showProgress: function () {
				$.skylo('start');
				var percentage = 50;
				clearInterval(this.progressInterval);
				this.progressInterval = setInterval(function () {
					$.skylo('set', percentage);
					percentage = percentage + ((100 - percentage) / 3);
				}, 2000)

			},
			hideProgress: function () {
				clearInterval(this.progressInterval);
				$.skylo('set', 100);
				$.skylo('end');
			},
			getValue: function (record, fieldName) {
				var value;
				if (record && fieldName) {
					if (fieldName.indexOf('.') > 0) {
						var names = fieldName.split('.');
						angular.forEach(names, function (name, index) {
							if (record != undefined) {
								if (index == (names.length - 1)) {
								    value = record[name];
								    if(!value)
								        value = record[name.toLowerCase()]
								}
								else {
									record = record[name];
								}
							}
						})
					}
					else {
					    value = record[fieldName];
					    if (!value)
					        value = record[fieldName.toLowerCase()]
					}
				}
				return value;
			},
			setValue: function (record, fieldName, value) {
				if (record && fieldName) {
					if (fieldName.indexOf('.') > 0) {
						var names = fieldName.split('.');
						angular.forEach(names, function (name, index) {
							if (index == (names.length - 1)) {
								record[name] = value;
							}
							else {
								if (record[name] == undefined)
									record[name] = {};
								record = record[name];
							}
						})
					}
					else
						record[fieldName] = value;
					return value;
				}
			},
			initValue: function (record, fieldName, defaultValue) {
				var value = $de.getValue(record, fieldName);
				if (value == undefined)
					$de.setValue(record, fieldName, (defaultValue != undefined) ? defaultValue : null);

			},
			initUIControl: function ($element, $scope, $attrs) {
				$scope.readEditMode = false;
				$scope.readMode = false;
				$scope.readonlyMode = false;
				$scope.designMode = false;

				switch ($scope.editMode) {
					case 'design': $scope.designMode = true; break;
					case 'read-only': $scope.readonlyMode = true; break;
					case 'read-edit': $scope.readEditMode = $scope.readMode = true; break;
				}

				if ($scope.designMode)
					$element.addClass('design-mode');
				else
					$element.removeClass('design-mode');

				$scope.inline = false;
				$scope.overlay = false;
				$scope.noLabel = false;

				switch ($scope.displayMode) {
					case 'inline': $scope.inline = true; break;
					case 'no-label': $scope.noLabel = true; break;
				}

				if ($scope.inline) $element.addClass('inline-edit'); else $element.removeClass('inline-edit');
			},
			remove: function (array, item) {
				var found = array.indexOf(item);
				if (found >= 0)
					array.splice(found, 1);
			},
			add: function (array, item) {
				var found = array.indexOf(item);
				if (found < 0)
					array.push(item);
			},
			getUniqueId: function () {
				return 'id_' + new Date().getTime();
			},
			iterations: function (count) {
				var list = [];
				for (var iIndex = 1; iIndex <= count; ++iIndex) list.push(iIndex);
				return list;
			},
			getSampleRecords: function (fields, count) {
				count = !count ? 1 : count;
				var pastPeriod = 365 * 24 * 60 * 60 * 1000; //Past 1 week
				var records = [];
				for (var iIndex = 0; iIndex < count; ++iIndex) {
					var record = {};
					angular.forEach(fields, function (field) {
						switch (field.type) {
							case 'datetime': value = moment().startOf('day').subtract(Math.ceil(Math.random() * 30), 'days').add(Math.ceil(Math.random() * 60), 'seconds').add(Math.ceil(Math.random() * 24), 'hours').toDate(); break;
							case 'date': value = moment().startOf('day').subtract(Math.ceil(Math.random() * 30), 'days').toDate(); break;
							case 'currency': value = Math.ceil(Math.random() * 10000000); break;
							case 'number': value = Math.ceil(Math.random() * 10000000); break;
							case 'email': value = 'customer-' + Math.ceil(Math.random() * count) + '@designer.expert'; break;
							case 'checkbox': value = Math.ceil(Math.random() * 100) % 2 == 0; break;
							case 'icon': value = 'fa-ellipsis-h'; break;
							case 'richtext':
								var label = field.label + ' ' + iIndex;
								value = label + '<ul>';
								var index = 0;
								do {
									value += '<li>' + label + '</li>';
									++index;
								}
								while (index < 100);
								value += '</ul>';
								break;
							case 'textarea':
								value = field.label + ' ' + iIndex;
								do {
									value += ' ' + value;
								}
								while (value.length < 255);
								break;
							case 'picklist':
								if (!field.controlledBy) {
									value = demo.data.countries[Math.ceil(Math.random() * (demo.data.countries.length - 1))];
								} else {
									var country = eval('record.' + field.controlledBy);
									if (country && demo.data.states[country]) {
										var states = demo.data.states[country];
										value = states[Math.ceil(Math.random() * (states.length - 1))];
									}
								}
								break;
							case 'lookup': {
								$de.setValue(record, field.name, 1);
								$de.setValue(record, (field.nameField) ? field.nameField : $de.lookupNameField, field.label + ' ' + iIndex);
							}
							default: value = field.label + ' ' + iIndex;
						}
						$de.setValue(record, field.name, value);
					})
					records.push(record);
				}
				return count == 1 ? records[0] : records;
			},
			standardfields: {
				label: {
					type: 'text',
					max: 120,
					label: 'Label',
					name: 'label',
				},
				name: {
					type: 'text',
					max: 120,
					label: 'Name',
					name: 'name',
				}
			},
			patterns: [
                        { name: 'Email', expression: "^[a-z]+[a-z0-9._]+@[a-z]+\.[a-z.]{2,5}$", errorMessage: 'Invalid email' },
	                    { name: 'Number', expression: "\\d+", errorMessage: 'Invalid number' }
			],
			getValidationPatterns: function () {
				return this.patterns;
			},
			//Generic search function that searches through array of object against given property of object for key.
			search: function (arrObject, property, keyToSearch) {
				var found = -1;
				angular.forEach(arrObject, function (obj, index) {
				    if (obj[property] == keyToSearch)
				    {
				        found=index
				        return index;
				    }
				});
				return found;
			},
			addPattern: function (pattern) {
				var found = this.search($de.patterns, 'name', pattern.name)
				if (found == -1) {
					$de.patterns.push(pattern);
					return true;
				}
				return false; //Pattern already exist
			},
			getLookupObjectFields: function (objectName) {

			    alert("getLookupObjectFields" + objectName)
		
			}
		};
		return $de;
	}])

var demo = { data: {} };
//demo.data.countries = ['United States', 'India', 'United Kingdom', 'Srilanka', 'Brazil'];
demo.data.countries = [{ value: 'India' }, { value: 'Brazil' }, { value: 'United States' }, { value: 'Srilanka' } , { value: 'Brazil' }]
demo.data.states = {
	'United States': ['California', 'New York', 'LA', 'Chicago'],
	'India': ['Maharashtra', 'Gujrat', 'Oddisa', 'J&K', 'Rajasthan'],
	'United Kingdom': ['Great Britain', 'Ireland', 'Scottland'],
	'Srilanka': ['Kolambo', 'Gale'],
	'Brazil': ['Brazilia', 'Reo De Jenerio'],
};

demo.data.fields = [
			{
				label: 'First Name',
				name: 'FirstName',
				type: 'text',
				required: true,
				max: 80,
			}, {
				label: 'Last Name',
				name: 'LastName',
				type: 'text',
				required: false,
				max: 80,
			}, {
				label: 'Email',
				name: 'Email',
				type: 'email',
				required: false,
				max: 80,
			}, {
				label: 'Password',
				name: 'Password',
				type: 'password',
				//required: true,
				max: 80,
			}, {
				label: 'Number',
				name: 'Number',
				type: 'number',
				precision: 18,
				scale: 2
			}, {
				label: 'Annual Revenue',
				name: 'AnnualRevenue',
				type: 'currency',
				required: false,
				currency: '$',
			}, {
				label: 'Organization',
				name: 'Account.Name',
				type: 'lookup',
				required: false,
				nameField: 'Account.Name',
				criteria: "",
				searchLimit: 10,
				thresholdLimit: 70,
				ReferenceObjectName: "Account",
				getAllFields: function (keyword, onsuccess, onerror) {
					var records = angular.copy(demo.data.lookupObjFields["Account"]);
					if (keyword == 'error')
						onerror('Could not reach the server');
					else
						onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });//[{ Id: 1, Name: 'Enzigma Software Pvt. Ltd.' }, { Id: 2, Name: 'Enzigma Solutions Pvt. Ltd.' }, { Id: 3, Name: 'Enzigma LLC' }] });
				}
			}, {
				label: 'Date of Birth',
				name: 'DoB',
				type: 'date',
				required: false,
			}, {
				label: 'Time Stamp',
				name: 'TimeStamp',
				type: 'datetime',
				required: false,
			}, {
				label: 'Country',
				name: 'Country',
				type: 'picklist',
				required: false,
				values: demo.data.countries,
			}, {
				label: 'State',
				name: 'State',
				type: 'picklist',
				required: false,
				controlledBy: 'Country',
				values: demo.data.states,
			}, {
				label: 'Phone',
				name: 'Phone',
				type: 'phone',
				required: false,
			}, {
				label: 'Is Active?',
				name: 'active',
				type: 'checkbox',
				required: false,
			}, {
				label: 'Description',
				name: 'Description',
				type: 'textarea',
				required: false,
				max: 500,
			}, {
				label: 'Body',
				name: 'Body',
				type: 'richtext',
				required: false,
				max: 500,
			}, {
				label: 'Function',
				name: 'Function',
				type: 'code',
				codeType: 'javascript',
				required: false,
				max: 500,
			}, {
				label: 'Icon',
				name: 'Icon',
				type: 'icon',
				required: false,
			}, {
				label: 'Labels',
				name: 'Labels',
                type: 'tags',
                save_as: 'string' ,
				required: false,
				getrecords: function (keyword, field, currentPage, pageSize, onsuccess, onerror) {
					var records = [];
					for (var iIndex = 1; iIndex <= 100; ++iIndex)
						records.push({ value: 'Tag - ' + iIndex, label: 'Label - ' + iIndex });
					if (keyword == 'error')
						onerror('Could not reach the server');
					else
						onsuccess({ idField: 'value', nameField: 'label', records: records, fields: [{ label: 'Tag', type: 'text', name: 'label'}], totalCount: records.length });//[{ Id: 1, Name: 'Enzigma Software Pvt. Ltd.' }, { Id: 2, Name: 'Enzigma Solutions Pvt. Ltd.' }, { Id: 3, Name: 'Enzigma LLC' }] });
				}
			},
];

demo.data.takeAction = function ($event, action, data, oncomplete) {
	console.log(action);
	console.log(data);
	setTimeout(function () {
		var success = true;
		var message = '';
		if (data && data.type) {
			switch (data.type) {
				case 'single-record': {
					if (data.record.FirstName && data.record.LastName) {
						var temp = data.record.FirstName;
						data.record.FirstName = data.record.LastName;
						data.record.LastName = temp;
						data.record.Account.Id = 1;
						data.record.Account.Name = 'Enzigma Software Pvt. Ltd. - 2';
					}
					else {
						success = false;
						message = 'For this sample action  you must provide FirstName and LastName';
					}
				}
					break;
				case 'multi-record': {
					if (/^preview/.test(action.action)) {
						success = false;
						message = 'Preview is not allowed for multiple records';
					}
					else {
						angular.forEach(data.records, function (record) {
							if (record.FirstName && record.LastName) {
								var temp = record.FirstName;
								record.FirstName = record.LastName;
								record.LastName = temp;
							}
							else {
								success = false;
								message = 'For this sample action  you must provide FirstName and LastName';
							}
						})
					}
				}
					break;
			}
		}
		else {
			success = false;
			message = 'No data or data.type provided in the action call.';
		}
		oncomplete(success, message);
	}, 50)
};


demo.data.actions = [
			{
				icon: 'fa-floppy-o',
				label: 'Save',
				action: 'save',
				type: 'primary',
				disableOnInvalidForm: true,
				onclick: demo.data.takeAction,
			},
			{
				icon: 'fa-ban',
				action: 'cancel',
				type: 'default',
				label: 'Cancel',
				onclick: demo.data.takeAction,
			},
			{
				customicon: '<input type="checkbox" ng-model="action.checked" ng-click="$event.stopPropagation();" />',
				action: 'custom',
				style: { color: '#ff0000' },
				type: 'default',
				customlabel: '<font ng-style="action.style">Color</font><input type="color" ng-model="action.style.color" ng-click="$event.stopPropagation();" />',
				onclick: demo.data.takeAction,
			},
			{
				icon: 'fa-eye',
				action: 'preview',
				type: 'info',
				label: 'Preview',
				onclick: function ($event, action, data, oncompelete) {
					action.icon = (action.icon == 'fa-eye') ? 'fa-eye-slash' : 'fa-eye';
					demo.data.takeAction($event, action, data, oncompelete)
				},
				actions: [
					{
						icon: 'fa-ban',
						action: 'cancel-preview',
						label: 'Cancel',
						onclick: demo.data.takeAction,
					},
					{
						icon: 'fa-eye',
						action: 'preview',
						label: 'Preview',
						onclick: demo.data.takeAction,
						actions: [
							{
								icon: 'fa-eye',
								action: 'preview-pdf',
								label: 'PDF', onclick: demo.data.takeAction, actions: [
								{ action: 'preview-pdf-1', icon: 'fa-file-pdf-o', label: 'PDF 1', onclick: demo.data.takeAction },
								{ action: 'preview-pdf-2', icon: 'fa-file-pdf-o', label: 'PDF 2', onclick: demo.data.takeAction },
								{ action: 'preview-pdf-3', icon: 'fa-file-pdf-o', label: 'PDF 3', onclick: demo.data.takeAction },
								{ action: 'preview-pdf-4', icon: 'fa-file-pdf-o', label: 'PDF 4', onclick: demo.data.takeAction },
								]
							},
							{ action: 'preview-csv', icon: 'fa-file-excel-o', disabled: true, label: 'CSV', onclick: demo.data.takeAction },
							{ action: 'preview-text', icon: 'fa-file-text-o', label: 'Text', onclick: demo.data.takeAction },
						]
					}
				]
			}
];


demo.data.relatedObjectsMap = {
    'DemoObject': {

        Object1: [
		{
		    label: 'Name',
		    name: 'Name',
		    type: 'text',
		    required: true,
		    max: 80,
		}, {
		    label: 'First Name',
		    name: 'FirstName',
		    type: 'text',
		    required: true,
		    max: 80,
		}, {
		    label: 'Last Name',
		    name: 'LastName',
		    type: 'text',
		    required: true,
		    max: 80,
		}, {
		    label: 'Email',
		    name: 'Email',
		    type: 'email',
		    required: true,
		    max: 80,
		}, {
		    label: 'Password',
		    name: 'Password',
		    type: 'password',
		    required: true,
		    max: 80,
		}, {
		    label: 'Annual Revenue',
		    name: 'AnnualRevenue',
		    type: 'currency',
		    required: true,
		    currency: '$',
		}, {
		    label: 'Organization',
		    ReferenceObjectName: 'Account',
		    criteria: '',
		    max: 18,
		    searchLimit: 10,
		    thresholdLimit: 70,
		    name: 'Account',
		    type: 'lookup',
		    required: true,
		    nameField: 'Account.Name'
		    
		}, {
		    label: 'Date of Birth',
		    name: 'DoB',
		    type: 'date',
		    required: true,
		}, {
		    label: 'Time Stamp',
		    name: 'TimeStamp',
		    type: 'datetime',
		    required: true,
		}, {
		    label: 'Country',
		    name: 'Country',
		    type: 'picklist',
		    required: true,
		    values: demo.data.countries,
		}],
        Object2: [
		{
		    label: 'Name',
		    name: 'Name',
		    type: 'text',
		    required: true,
		    max: 80,
		}, {
		    label: 'First Name',
		    name: 'FirstName',
		    type: 'text',
		    required: true,
		    max: 80,
		}, {
		    label: 'Last Name',
		    name: 'LastName',
		    type: 'text',
		    required: true,
		    max: 80,
		}, {
		    label: 'Email',
		    name: 'Email',
		    type: 'email',
		    required: true,
		    max: 80,
		}, {
		    label: 'Password',
		    name: 'Password',
		    type: 'password',
		    required: true,
		    max: 80,
		}, {
		    label: 'Annual Revenue',
		    name: 'AnnualRevenue',
		    type: 'currency',
		    required: true,
		    currency: '$',
		}, {
		    label: 'Organization',
		    name: 'Account',
		    type: 'lookup',
		    required: true,
		    nameField: 'Account.Name',
		    ReferenceObjectName: 'RecordType',
		    criteria: '',
		    searchLimit: 10,
		    thresholdLimit: 70,
		    max: 18
		    
		}, {
		    label: 'Date of Birth',
		    name: 'DoB',
		    type: 'date',
		    required: true,
		}, {
		    label: 'Time Stamp',
		    name: 'TimeStamp',
		    type: 'datetime',
		    required: true,
		}, {
		    label: 'Country',
		    name: 'Country',
		    type: 'picklist',
		    required: true,
		    values: demo.data.countries,
		}, {
		    label: 'State',
		    name: 'State',
		    type: 'picklist',
		    required: true,
		    controlledBy: 'Country',
		    values: demo.data.states,
		}, {
		    label: 'Phone',
		    name: 'Phone',
		    type: 'phone',
		    required: true,
		}, {
		    label: 'Is Active?',
		    name: 'active',
		    type: 'checkbox',
		    required: true,
		}, {
		    label: 'Description',
		    name: 'Description',
		    type: 'textarea',
		    required: true,
		    max: 500,
		}, {
		    label: 'Body',
		    name: 'Body',
		    type: 'richtext',
		    required: true,
		    max: 500,
		}, {
		    label: 'Function',
		    name: 'Function',
		    type: 'code',
		    codeType: 'javascript',
		    required: true,
		    max: 500,
		}, {
		    label: 'Icon',
		    name: 'Icon',
		    type: 'icon',
		    required: true,
		}, {
		    label: 'Labels',
		    name: 'Labels',
		    type: 'tags',
		    required: true
		}],
        Object3: [
		{
		    label: 'Name',
		    name: 'Name',
		    type: 'text',
		    required: true,
		    max: 80,
		}, {
		    label: 'First Name',
		    name: 'FirstName',
		    type: 'text',
		    required: true,
		    max: 80,
		}, {
		    label: 'Last Name',
		    name: 'LastName',
		    type: 'text',
		    required: true,
		    max: 80,
		}, {
		    label: 'Email',
		    name: 'Email',
		    type: 'email',
		    required: true,
		    max: 80,
		}, {
		    label: 'Password',
		    name: 'Password',
		    type: 'password',
		    required: true,
		    max: 80,
		}, {
		    label: 'Annual Revenue',
		    name: 'AnnualRevenue',
		    type: 'currency',
		    required: true,
		    currency: '$',
		}, {
		    label: 'Organization',
		    name: 'Account',
		    type: 'lookup',
		    required: true,
		    nameField: 'Account.Name',
		    ReferenceObjectName: 'RecordType',
		    criteria: '',
		    searchLimit: 10,
		    thresholdLimit: 70,
		    max: 18
		}, {
		    label: 'Date of Birth',
		    name: 'DoB',
		    type: 'date',
		    required: true,
		}, {
		    label: 'Time Stamp',
		    name: 'TimeStamp',
		    type: 'datetime',
		    required: true,
		}, {
		    label: 'Country',
		    name: 'Country',
		    type: 'picklist',
		    required: true,
		    values: demo.data.countries,
		}]
    }
}

demo.data.relatedObjects = [
    { 
      Label: 'Account',
      Name : 'Account',
      ObjectName : {
          IsRecordTypeEnable : false,
          Name : 'Object1',
          ObjType : 'ObjectDef',
      },
      OnParentDelete : 'DoNothing',
      RecordAccess : 'A',
    },
    {
        Label: 'Account',
        Name: 'Account',
        ObjectName: {
            IsRecordTypeEnable: false,
            Name: 'Object2',
            ObjType: 'ObjectDef',
        },
        OnParentDelete: 'DoNothing',
        RecordAccess: 'A',
    },
    {
        Label: 'Account',
        Name: 'Account',
        ObjectName: {
            IsRecordTypeEnable: false,
            Name: 'Object3',
            ObjType: 'ObjectDef',
        },
        OnParentDelete: 'DoNothing',
        RecordAccess: 'A',
    }
]

demo.data.lookupObjFields = {
	Account: [
	{
		label: 'Name',
		name: 'Name',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'First Name',
		name: 'FirstName',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'Last Name',
		name: 'LastName',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'Email',
		name: 'Email',
		type: 'email',
		required: true,
		max: 80,
	}, {
		label: 'Password',
		name: 'Password',
		type: 'password',
		required: true,
		max: 80,
	}, {
		label: 'Annual Revenue',
		name: 'AnnualRevenue',
		type: 'currency',
		required: true,
		currency: '$',
	}, {
		label: 'CustomObj',
		name: 'CustomObj.Id',
		type: 'lookup',
		required: true,
		nameField: 'CustomObj.Name',
		getAllFields: function (keyword, onsuccess, onerror) {
			var records = angular.copy(demo.data.lookupObjFields["CustomObj"]);
			if (keyword == 'error')
				onerror('Could not reach the server');
			else
				onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });//[{ Id: 1, Name: 'Enzigma Software Pvt. Ltd.' }, { Id: 2, Name: 'Enzigma Solutions Pvt. Ltd.' }, { Id: 3, Name: 'Enzigma LLC' }] });
		},
		getrecords: function (keyword, field, currentPage, pageSize, onsuccess, onerror) {
			var records = [];
			for (var iIndex = 1; iIndex <= 100; ++iIndex)
				records.push({ Id: iIndex, Name: 'Enzigma Software Pvt. Ltd. - ' + iIndex });
			if (keyword == 'error')
				onerror('Could not reach the server');
			else
				onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });//[{ Id: 1, Name: 'Enzigma Software Pvt. Ltd.' }, { Id: 2, Name: 'Enzigma Solutions Pvt. Ltd.' }, { Id: 3, Name: 'Enzigma LLC' }] });
		}
	}, {
		label: 'Date of Birth',
		name: 'DoB',
		type: 'date',
		required: true,
	}, {
		label: 'Time Stamp',
		name: 'TimeStamp',
		type: 'datetime',
		required: true,
	}, {
		label: 'Country',
		name: 'Country',
		type: 'picklist',
		required: true,
		values: demo.data.countries,
	}],
	Contact: [
	{
		label: 'Name',
		name: 'Name',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'First Name',
		name: 'FirstName',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'Last Name',
		name: 'LastName',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'Email',
		name: 'Email',
		type: 'email',
		required: true,
		max: 80,
	}, {
		label: 'Password',
		name: 'Password',
		type: 'password',
		required: true,
		max: 80,
	}, {
		label: 'Annual Revenue',
		name: 'AnnualRevenue',
		type: 'currency',
		required: true,
		currency: '$',
	}, {
		label: 'Account',
		name: 'Account.Name',
		type: 'lookup',
		required: true,
		nameField: 'Account.Name',
		getAllFields: function (keyword, onsuccess, onerror) {
			var records = angular.copy(demo.data.lookupObjFields["Account"]);
			if (keyword == 'error')
				onerror('Could not reach the server');
			else
				onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });//[{ Id: 1, Name: 'Enzigma Software Pvt. Ltd.' }, { Id: 2, Name: 'Enzigma Solutions Pvt. Ltd.' }, { Id: 3, Name: 'Enzigma LLC' }] });
		},
		getrecords: function (keyword, field, currentPage, pageSize, onsuccess, onerror) {
			var records = [];
			for (var iIndex = 1; iIndex <= 100; ++iIndex)
				records.push({ Id: iIndex, Name: 'Enzigma Software Pvt. Ltd. - ' + iIndex });
			if (keyword == 'error')
				onerror('Could not reach the server');
			else
				onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });//[{ Id: 1, Name: 'Enzigma Software Pvt. Ltd.' }, { Id: 2, Name: 'Enzigma Solutions Pvt. Ltd.' }, { Id: 3, Name: 'Enzigma LLC' }] });
		}
	}, {
		label: 'Date of Birth',
		name: 'DoB',
		type: 'date',
		required: true,
	}, {
		label: 'Time Stamp',
		name: 'TimeStamp',
		type: 'datetime',
		required: true,
	}, {
		label: 'Country',
		name: 'Country',
		type: 'picklist',
		required: true,
		values: demo.data.countries,
	}, {
		label: 'State',
		name: 'State',
		type: 'picklist',
		required: true,
		controlledBy: 'Country',
		values: demo.data.states,
	}, {
		label: 'Phone',
		name: 'Phone',
		type: 'phone',
		required: true,
	}, {
		label: 'Is Active?',
		name: 'active',
		type: 'checkbox',
		required: true,
	}, {
		label: 'Description',
		name: 'Description',
		type: 'textarea',
		required: true,
		max: 500,
	}, {
		label: 'Body',
		name: 'Body',
		type: 'richtext',
		required: true,
		max: 500,
	}, {
		label: 'Function',
		name: 'Function',
		type: 'code',
		codeType: 'javascript',
		required: true,
		max: 500,
	}, {
		label: 'Icon',
		name: 'Icon',
		type: 'icon',
		required: true,
	}, {
		label: 'Labels',
		name: 'Labels',
		type: 'tags',
		required: true,
		getrecords: function (keyword, field, currentPage, pageSize, onsuccess, onerror) {
			var records = [];
			for (var iIndex = 1; iIndex <= 100; ++iIndex)
				records.push({ value: 'Tag - ' + iIndex, label: 'Label - ' + iIndex });
			if (keyword == 'error')
				onerror('Could not reach the server');
			else
				onsuccess({ idField: 'value', nameField: 'label', records: records, fields: [{ label: 'Tag', type: 'text', name: 'label' }], totalCount: records.length });//[{ Id: 1, Name: 'Enzigma Software Pvt. Ltd.' }, { Id: 2, Name: 'Enzigma Solutions Pvt. Ltd.' }, { Id: 3, Name: 'Enzigma LLC' }] });
		}
	}],
	CustomObj: [
	{
		label: 'Name',
		name: 'Name',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'First Name',
		name: 'FirstName',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'Last Name',
		name: 'LastName',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'Email',
		name: 'Email',
		type: 'email',
		required: true,
		max: 80,
	}, {
		label: 'Password',
		name: 'Password',
		type: 'password',
		required: true,
		max: 80,
	}, {
		label: 'Annual Revenue',
		name: 'AnnualRevenue',
		type: 'currency',
		required: true,
		currency: '$',
	}, {
		label: 'Opportunity',
		name: 'Opportunity.Id',
		type: 'lookup',
		required: true,
		nameField: 'Opportunity.Name',
		getAllFields: function (keyword, onsuccess, onerror) {
			var records = angular.copy(demo.data.lookupObjFields["Opportunity"]);
			if (keyword == 'error')
				onerror('Could not reach the server');
			else
				onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });//[{ Id: 1, Name: 'Enzigma Software Pvt. Ltd.' }, { Id: 2, Name: 'Enzigma Solutions Pvt. Ltd.' }, { Id: 3, Name: 'Enzigma LLC' }] });
		},
		getrecords: function (keyword, field, currentPage, pageSize, onsuccess, onerror) {
			var records = [];
			for (var iIndex = 1; iIndex <= 100; ++iIndex)
				records.push({ Id: iIndex, Name: 'Enzigma Software Pvt. Ltd. - ' + iIndex });
			if (keyword == 'error')
				onerror('Could not reach the server');
			else
				onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });//[{ Id: 1, Name: 'Enzigma Software Pvt. Ltd.' }, { Id: 2, Name: 'Enzigma Solutions Pvt. Ltd.' }, { Id: 3, Name: 'Enzigma LLC' }] });
		}
	}, {
		label: 'Date of Birth',
		name: 'DoB',
		type: 'date',
		required: true,
	}, {
		label: 'Time Stamp',
		name: 'TimeStamp',
		type: 'datetime',
		required: true,
	}, {
		label: 'Country',
		name: 'Country',
		type: 'picklist',
		required: true,
		values: demo.data.countries,
	}],
	Opportunity: [
	{
		label: 'Name',
		name: 'Name',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'First Name',
		name: 'FirstName',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'Last Name',
		name: 'LastName',
		type: 'text',
		required: true,
		max: 80,
	}, {
		label: 'Email',
		name: 'Email',
		type: 'email',
		required: true,
		max: 80,
	}, {
		label: 'Password',
		name: 'Password',
		type: 'password',
		required: true,
		max: 80,
	}, {
		label: 'Annual Revenue',
		name: 'AnnualRevenue',
		type: 'currency',
		required: true,
		currency: '$',
	}, {
		label: 'Account',
		name: 'Account.Name',
		type: 'lookup',
		required: true,
		nameField: 'Account.Name',
		getAllFields: function (keyword, onsuccess, onerror) {
			var records = angular.copy(demo.data.lookupObjFields["Account"]);
			if (keyword == 'error')
				onerror('Could not reach the server');
			else
				onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });//[{ Id: 1, Name: 'Enzigma Software Pvt. Ltd.' }, { Id: 2, Name: 'Enzigma Solutions Pvt. Ltd.' }, { Id: 3, Name: 'Enzigma LLC' }] });
		},
		getrecords: function (keyword, field, currentPage, pageSize, onsuccess, onerror) {
			var records = [];
			for (var iIndex = 1; iIndex <= 100; ++iIndex)
				records.push({ Id: iIndex, Name: 'Enzigma Software Pvt. Ltd. - ' + iIndex });
			if (keyword == 'error')
				onerror('Could not reach the server');
			else
				onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });//[{ Id: 1, Name: 'Enzigma Software Pvt. Ltd.' }, { Id: 2, Name: 'Enzigma Solutions Pvt. Ltd.' }, { Id: 3, Name: 'Enzigma LLC' }] });
		}
	}, {
		label: 'Date of Birth',
		name: 'DoB',
		type: 'date',
		required: true,
	}, {
		label: 'Time Stamp',
		name: 'TimeStamp',
		type: 'datetime',
		required: true,
	}, {
		label: 'Country',
		name: 'Country',
		type: 'picklist',
		required: true,
		values: demo.data.countries,
	}]
}