var designerExpertTable = {
    restrict: 'A',
}

angular.module('deTable', ['deServices', 'deActions', 'ngAnimate', 'toaster', 'ng-sortable', 'UIEngine'])
	.factory('deTableService', ['$rootScope', '$filter', '$compile', function ($rootScope, $filter, $compile) {
	    var deTableService = {
	        bindField: function ($scope, $element, defaultValue) {
	            deTableService.initValue($scope.record, $scope.field.name, defaultValue);
	            var formName = $element.parents('form').attr('name');
	            if (formName && $scope.$parent[formName]) {
	                $scope.deForm = $scope[formName] = $scope.$parent[formName];
	            }

	            $scope.$watch('field.readonly', function (newValue) {
	                var input = $element.find('input');
	                switch ($scope.field.type) {
	                    case 'picklist': input = $element.find('select'); break;
	                    case 'lookup': input = $element.find('input,button'); break;
	                }
	                if (newValue)
	                    input.attr('readonly', '');
	                else
	                    input.removeAttr('readonly');
	            })
	            return function (newValue) {
	                if (arguments.length)
	                    return deTableService.setValue($scope.record, $scope.field.name, newValue);
	                else
	                    return deTableService.getValue($scope.record, $scope.field.name);
	            }
	        },
	        manageDisplayType: function (field, callback) {
	            var fieldScope = $rootScope.$new();
	            fieldScope.component = {
	                field: field,
	                save: function (field) {
	                    callback(field, function () {
	                        fieldScope.component.removeTemplate();
	                    })
	                },
	                removeTemplate: function () {
	                    $('#manage-display-id').fadeOut(300);
	                    $('.modal-backdrop').fadeOut(300);
	                    setTimeout(function () {
	                        fieldTemplate.remove();
	                        $('.modal-backdrop').remove();
	                    }, 500)
	                    $('body').removeClass('modal-open');
	                    $('body').removeAttr('style');
	                    fieldScope.$destroy();
	                }
	            };
	            var fieldTemplate = '';
	            fieldTemplate = '<div id="manage-display-id" class="modal fade" tabindex="-1" role="dialog">\
											<div class="modal-backdrop fade in" style="height: 100%; width: 100%;"></div>\
											<div class="modal-dialog" style="z-index: 9999;width:50%">\
												<div class="modal-content">\
													<div class="modal-header">\
														<button type="button" class="close" ng-click="component.removeTemplate()"><h4 aria-hidden="true"><i class="fa fa-times-circle"></i></span></h4></button>\
														<h4 class="modal-title">Field : {{component.field.label}}</h4>\
													</div>\
													<div class="modal-body container-fluid container-border">\
														<manage-display-type/>\
													</div>\
												</div>\
											</div>\
										</div>';
	            fieldTemplate = $compile(fieldTemplate)(fieldScope);
	            $('body').append(fieldTemplate);
	            $('#manage-display-id').modal('show');
	        }
	    };
	    return deTableService;
	}])
	.directive('deRelatedlist', function ($window) {
	    return {
	        restrict: designerExpertForm.restrict,
	        //Add link function for multitable feture on resize cacluate no of table to display.
	        link: function (scope, element, attrs) {
	            if (scope.options.multiTable) {
	                angular.element($window).bind('resize', function () {
	                    if ($(this).width() != scope.parentWidth) {
	                        scope.multiTableCal();
	                        scope.tableList();
	                        console.log('this is compile')
	                        if (!scope.$$phase && !scope.$root.$$phase) scope.$apply();
	                    }
	                });
	            }
	        },
	        //templateUrl: 'application_js/templates/relatedlist.htm',
	        scope: {
	            options: '=?deRelatedlist',
	            getdata: '&',
	            getfields: '&',
	            getfield: '&',
	            editMode: '=',
	            actions: '=',
	            multirecordActions: '=',
	            noPaging: '=',
	            inlineInsert: '=',
	            isRefresh: '=',
	            getCurrentData: '='
	        },
	        controller: ['$scope', '$attrs', '$element', '$de', 'deTableService', '$timeout', '$compile', '$filter', '$templateRequest', 'toaster', '$UIEngine', '$engine', '$deLayout', '$interpolate', '$rootScope', function ($scope, $attrs, $element, $de, deTableService, $timeout, $compile, $filter, $templateRequest, toaster, $UIEngine, $engine, $deLayout, $interpolate, $rootScope) {
	            $scope.sortableRows = false;
	            $scope.counter = 0;
	            $scope.localRecords = [];
	            $scope.options['search'] = "";
	            var modeMap = { "read-only": "read-only", "instant": "read-edit", "record": "read-only", "bulk": "read-edit" }           
	            if ($scope.options.saveMode)
	                $scope.tableMode = modeMap[$scope.options.saveMode];
	            else
	                $scope.tableMode = "read-only";

	            $scope.searchFun = function (keyword) {
	                $scope.options.currentPage = 0;
	                $scope.refreshData();
	            }

	            //Code for cross symbol when any search char is entered
	            function tog(v) { return v ? 'addClass' : 'removeClass'; }

	            $(document).on('input', '.clearable', function () {
	                $(this)[tog(this.value)]('x');
	                if (this.value == '') {
	                    $scope.options.search = this.value;
	                    $scope.searchFun();
	                }
	            }).on('mousemove', '.x', function (e) {
	                $(this)[tog(this.offsetWidth - 18 < e.clientX - this.getBoundingClientRect().left)]('onX');
	            }).on('touchstart click', '.onX', function (ev) {
	                ev.preventDefault();
	                $(this).removeClass('x onX').val('').change();
	                $scope.options.search = this.value;
	                $scope.searchFun();
	            });
	            $scope.showBulkAction = false;
	            $scope.deTableService = deTableService;
	            $scope.$de = $de;
	            $scope.$de.initUIControl($element, $scope, $attrs);
	            if ($scope.options.pageSizes)
	                $scope.pageSizes = $scope.options.pageSizes
	            else
	                $scope.pageSizes = [5, 10, 20, 50, 100];
	            $scope.dynamicPopover = {
	                templateUrl: $de.templatesFolder + 'dynamic-popover.htm'
	            }
	            $scope.capitalize = function (str) {
	                return str[0].toUpperCase() + str.slice(1);
	            }
	            $scope.attrs = $attrs;
	            $scope.name = (!$attrs.name) ? 'form_' + Math.ceil(Math.random() * 1000) : $attrs.name;
	            $scope.attrs.class = ($scope.attrs.class == undefined) ? '' : $scope.attrs.class;
	            $scope.attrs.class = ((!(/de-form*/.test($attrs.class))) ? 'de-form' : '') + $attrs.class;
	            $scope.result = { totalCount: 0, currentPage: $scope.options.currentPage, pageSize: $scope.options.pageSize };

	            $scope.sortableFields = { group: { name: 'fields', pull: true, put: false } };
	            $scope.sortableColumns = {
	                group: { name: 'fields', pull: true, put: true },
	                draggable: 'th.field-header',
	                baseIndex: 3,
	                onAdd: function (evt) {
	                    $scope.initField(evt.model);
	                },
	            };
	            //This code is for arrange rows of table by drag and drop
	            //$scope.sortableRows = {
	            //    group: { name: 'records', pull: true, put: true },
	            //    draggable: 'tr.tableRow',
	            //    onAdd: function (evt) {
	            //        $scope.initField(evt.model);
	            //    },
	            //    onMove: function (evt) {
	            //    }
	            //}
	            $scope.objEditMode = [];
	            $scope.oldRecords = [];
	            $scope.editedRecords = [];

	            $scope.highlightedColor = { success: "success-color-code", error: "error-color-code", warning: "warning-color-code", info: "info-color-code" };

	            // method to get css dynamically dynamically
	            $scope.getCssClass = function (record) {
	                if (record.isHighlighted !== 'undefined' && record.isHighlighted == true)
	                    return $scope.highlightedColor[record.recordStatus];
	                else
	                    return "";
	            };
	          
                //This method is to create new record at the top row with highlighted
	            $scope.refreshFromLocal = function (recordToBeHighlighted) {
	                $scope.options.isHighlighted = true;
	                $scope.showBulkAction = false;
	                if (typeof $scope.localRecords.pageSize !== 'undefined') {
	                    $scope.options.pageSize = $scope.localRecords.pageSize;
	                    $scope.options.currentPage = "0";
	                }
	                else 
	                    $scope.options.currentPage = "0";
	                $scope.getdata({
	                    options: $scope.options,
	                    onsuccess: function (result) {
	                        if($scope.counter > 0)
	                            result = $scope.localRecords;
	                        $scope.result = result;
	                        for(var index = 0; index < $scope.result.records.length;index++)
	                        {
	                            if (recordToBeHighlighted.ID == $scope.result.records[index].ID)
	                            {
	                                $scope.result.records.splice(index, 1);
	                                result.totalCount--;
	                            }
	                        }
	                        $scope.result.records.unshift(recordToBeHighlighted);
	                        $scope.objEditMode[$scope.objEditMode.length] = "read-only";
	                        $scope.options.mobileTitle = ($scope.options.mobileTitle) ? $scope.options.mobileTitle : '{{record.' + result.fieldDefs[0].name + '}}';
	                        result.totalCount++;
	                        if (!$scope.noPaging) {
	                            $scope.totalPages = Math.ceil(parseInt(result.totalCount) / parseInt(result.pageSize));
	                            $scope.pages = [];
	                            for (var iIndex = 1; iIndex <= $scope.totalPages; ++iIndex) $scope.pages.push(iIndex);
	                            $scope.options.currentPage = result.currentPage + '';
	                            $scope.options.pageSize = result.records.length + '';
	                        }
	                        //Order by and Sorting mappings
	                        $scope.sortFieldsOrder = [];
	                        $scope.sortFieldsMap = {};
	                        if (result.orderBy) {
	                            var orderByFields = result.orderBy.split(',');
	                            angular.forEach(orderByFields, function (orderByField) {
	                                var orderByParts = orderByField.trim().split(/\s+/);
	                                if (orderByParts && orderByParts.length > 0) {
	                                    var order = (orderByParts.length > 1 && orderByParts[1] && orderByParts[1] == 'desc') ? 'desc' : 'asc';
	                                    $scope.sortFieldsOrder.push(orderByParts[0]);
	                                    $scope.sortFieldsMap[orderByParts[0]] = order;
	                                }
	                            })
	                        }
	                        $scope.initFields();
	                        $scope.selAll = false;
	                        if ($scope.options.multiTable) {
	                            $scope.multiTableCal();
	                        }
	                        if (!$scope.$$phase && !$scope.$root.$$phase)
	                            $scope.$apply();

	                        if ($scope.counter == 0)
	                        {
	                            $scope.localRecords = result;
	                            $scope.counter++;
	                        }
	                    },
	                    onerror: function (error) {
	                        $scope.error = error;
	                        if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                    }
	                });
	              
	            };

	            $scope.$on('refreshFromLocal', function (event, record) {
	                $scope.refreshFromLocal(record);
	            });

	            //Save old record befor edit record in table
	            $scope.backupOldRecord = function (index, record) {
	                if (!$scope.oldRecords.hasOwnProperty(index))
	                    $scope.oldRecords[index] = angular.copy(record);
	            }

	            //Methods for record level edit action switch table row in edit mode or read-only mode
	            $scope.switchToEdit = function (index) {
	                $scope.oldRecords[index] = angular.copy($scope.result.records[index]);
	                $scope.objEditMode[index] = "edit";
	            };
	            $scope.switchToReadOnly = function (index) {
	                $scope.objEditMode[index] = "read-only";
	            };
	            //This method is to create new record and add ne row to table 
	            $scope.addRecord = function () {
	                $scope.newRecord = {};
	                $scope.newRecord["ObjType"] = $scope.options.object;
	                var keys = Object.keys(angular.copy($scope.result.records[0]))
	                angular.forEach(keys, function (key) {
	                    $scope.newRecord[key] = null;
	                });
	                $scope.result.records.unshift($scope.newRecord);
	                $scope.objEditMode[$scope.result.records.length - 1] = "read-only";
	                setTimeout(function () {
	                    $scope.objEditMode[0] = "edit";
	                    if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                }, 500)

	                if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	            };

	            //This method is to delete record from table and database
	            $scope.deleteRecord = function (index) {
	                if ($scope.options.object == "FieldDef") {
	                    $scope.result.records[index].ObjectName = { Name: $scope.$parent.strObject };
	                }
	                $engine.delete(angular.copy($scope.result.records[index]), true, function (error) {
	                    if (error.success) {
	                        $de.showSuccess("Record Deleted Successfully", "Success");
	                    }
	                    else
	                        $de.showError((error.data.Data) ? error.data.Data[0].ErrorMessage : error.data.ErrorMessage, (error.data.Data) ? error.data.Data[0].Code : error.data.Code);
	                });
	                $scope.result.records.splice(index, 1);
	            };

	            //This method is to Save edited record from table to DB
	            $scope.saveRecord = function (index) {
	                $scope.showBulkAction = false;
	                var records;
	                if (index != undefined)
	                    records = angular.copy($scope.result.records[index])
	                else {
	                    if ($scope.editedRecords.length == 1)
	                        records = angular.copy($scope.editedRecords[0]);
	                    else
	                        records = angular.copy($scope.editedRecords);
	                }
	                $engine.upsert(records, true, function (error) {
	                    if (error.success) 
	                        $de.showSuccess("Record saved successfully", "Success");	                    
	                    else
	                        $de.showError((error.data.Data) ? error.data.Data[0].ErrorMessage : error.data.ErrorMessage, (error.data.Data) ? error.data.Data[0].Code : error.data.Code);
	                    $scope.refreshData();
	                });
	                $scope.oldRecords = [];
	                $scope.editedRecords = [];
	            };

	            //This method is to revert changes after edit before save to DB
	            $scope.cancelRecord = function (index) {
	                $scope.showBulkAction = false;
	                if (index != undefined) {
	                    $scope.result.records[index] = angular.copy($scope.oldRecords[index]);
	                    $scope.objEditMode[index] = "read-only";
	                }
	                else {
	                    angular.forEach($scope.oldRecords, function (record, key) {
	                        $scope.result.records[key] = record;
	                    });
	                }
	                $scope.oldRecords = [];
	                $scope.editedRecords = [];
	            };

	            //This method to get record that are edited and changed for save edited record in DB
	            $scope.$on('editRecord', function (event, record, switchToReadOnly) {
	                var index = $scope.result.records.indexOf(record)
	                if (!angular.equals($scope.oldRecords[index], angular.copy(record))) {
	                    $scope.showBulkAction = true;
	                    if ($scope.options.saveMode == "instant") {
	                        $scope.saveRecord(index);
	                    }
	                    var push = false;
	                    if ($scope.editedRecords.length <= 0)
	                        $scope.editedRecords.push(record);
	                    else {
	                        angular.forEach($scope.editedRecords, function (val, key) {
	                            if (val.Id == record.Id) {
	                                push = true;
	                                $scope.editedRecords[key] = record;
	                            }
	                        });
	                        if (!push)
	                            $scope.editedRecords.push(record)
	                    }
	                }//if record edited	      
	                else {
	                    $scope.oldRecords.splice(index, 1);
	                    if ($scope.editedRecords.length == 0 || $scope.oldRecords.length == 0)
	                        $scope.showBulkAction = false;
	                    switchToReadOnly();
	                }
	            });

	            $scope.editCallback = function (saveMode, callback, multitableOption) {
	                $scope.options.saveMode = saveMode;
	                $scope.options.multiTable = multitableOption;
	                callback();
	            }

	            var inlineEditOption = { option: [{ key: "Read-Only", value: "read-only" }, { key: "Instant Edit", value: "instant" }, { key: "Record Edit", value: "record" }, { key: "Bulk Edit", value: "bulk" }], header: "Table Inline Edit" };

	            $scope.tableEditSetting = function () {
	                inlineEditOption.selected = ($scope.options.saveMode) ? $scope.options.saveMode : "read-only";
	                var multiTableOption = ($scope.options.multiTable) ? $scope.options.multiTable : false;
	                $deLayout.actionbarSetting(inlineEditOption, $scope.editCallback, multiTableOption);
	            }
	            if ($scope.noPaging) {
	                $scope.options.pageSize = -1;
	                $scope.options.currentPage = 0;
	            }
	            if ($scope.designMode) {
	                $scope.getfields({
	                    objname: $scope.options.object,
	                    onsuccess: function (result) {
	                        $scope.fields = result.fields;
	                        if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                    },
	                    onerror: function (error) {
	                        toaster.pop('error', 'Relatedlist', error);
	                        if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                    }
	                });
	            }

	            $scope.addField = function ($event) {
	                if ($scope.options.object && $scope.fieldName) {
	                    angular.forEach($scope.fieldName, function (field) {
	                        $scope.getfield({
	                            objname: $scope.options.object,
	                            name: field,
	                            onsuccess: function (result) {
	                                $scope.options.fields += ',' + field;
	                                $scope.options.fieldDefs[result.field.name] = result.field;
	                                $scope.refreshData();
	                            },
	                            onerror: function (error) {
	                                toaster.pop('error', 'Relatedlist Message', error);
	                                if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                            }
	                        });
	                    });
	                }
	            }

	            $scope.initField = function (field) {
	                var fieldName = field.name;
	                if (!$scope.options.fieldDefs[fieldName])
	                    $scope.options.fieldDefs[fieldName] = field;
	                //else if (!$scope.options.fieldDefs[fieldName].label) {
	                //    $scope.options.fieldDefs[fieldName].label = field.label;
	                //    $scope.options.fieldDefs[fieldName].linkdetails = field.linkdetails;
	                //}
	                //else if (field.type == "lookup" && !$scope.options.fieldDefs[fieldName].linkdetails)
	                //    $scope.options.fieldDefs[fieldName].linkdetails = field.linkdetails;

	            }

	            $scope.initFields = function () {
	                if (!$scope.options.fieldDefs) {
	                    $scope.options.fieldDefs = {}
	                    delete $scope.result.fieldDefs.ObjType;
	                    $scope.initField(angular.copy($scope.result.fieldDefs[0]));
	                }
	                else {
	                    delete $scope.options.fieldDefs.ObjType;
	                    $scope.options.fieldDefs = $scope.options.fieldDefs;
	                }
	                angular.forEach($scope.result.fieldDefs, function (field) {
	                    $scope.initField(field);
	                    if ($scope.designMode)
	                        for (var iIndex = 0; iIndex < $scope.fields.length; iIndex++) {
	                            if (field.name == $scope.fields[iIndex].name) {
	                                $scope.fields.splice(iIndex, 1);
	                                break;
	                            }
	                        }
	                });
	            }

	            $scope.refreshData = function () {
	                if (typeof $scope.localRecords.pageSize !== 'undefined') {
	                    $scope.options.pageSize = $scope.localRecords.pageSize;
	                    $scope.localRecords = [];
	                }
	                $scope.counter = 0;
	                $scope.showBulkAction = false;
	                $scope.getdata({
	                    options: $scope.options,
	                    onsuccess: function (result) {
	                        $scope.result = result;
	                        $scope.options.mobileTitle = ($scope.options.mobileTitle) ? $scope.options.mobileTitle : '{{record.' + result.fieldDefs[0].name + '}}';

	                        if (!$scope.noPaging) {
	                            $scope.totalPages = Math.ceil(parseInt(result.totalCount) / parseInt(result.pageSize));
	                            $scope.pages = [];
	                            for (var iIndex = 1; iIndex <= $scope.totalPages; ++iIndex) $scope.pages.push(iIndex);
	                            $scope.options.currentPage = result.currentPage + '';
	                            $scope.options.pageSize = result.pageSize + '';
	                        }
	                        //Order by and Sorting mappings
	                        $scope.sortFieldsOrder = [];
	                        $scope.sortFieldsMap = {};
	                        if (result.orderBy) {
	                            var orderByFields = result.orderBy.split(',');
	                            angular.forEach(orderByFields, function (orderByField) {
	                                var orderByParts = orderByField.trim().split(/\s+/);
	                                if (orderByParts && orderByParts.length > 0) {
	                                    var order = (orderByParts.length > 1 && orderByParts[1] && orderByParts[1] == 'desc') ? 'desc' : 'asc';
	                                    $scope.sortFieldsOrder.push(orderByParts[0]);
	                                    $scope.sortFieldsMap[orderByParts[0]] = order;
	                                }
	                            })
	                        }
	                        $scope.initFields();
	                        $scope.selAll = false;
	                        if ($scope.options.multiTable) {
	                            $scope.multiTableCal();
	                        }
	                        if (!$scope.$$phase && !$scope.$root.$$phase)
	                            $scope.$apply();
	                    },
	                    onerror: function (error) {
	                        $scope.error = error;
	                        if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                    }
	                });
	            }
	            $scope.refreshData();

	            $scope.$on('relatedlist-refresh', function () {
	                $scope.refreshData();
	            });

	            $scope.$watch('isRefresh', function (newValue) {
	                if (newValue != undefined)
	                    $scope.refreshData();
	            })

	            $scope.changePage = function (newPage) {
	                newPage = parseInt(newPage);
	                if (newPage >= 0 && newPage < $scope.totalPages) {
	                    $scope.options.currentPage = newPage;
	                    $scope.refreshData();
	                }
	            }

	            $scope.deleteColumn = function ($event, field) {
	                $de.remove($scope.result.fieldDefs, field);
	                $de.add($scope.fields, field);
	                if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	            }

	            $scope.$watchCollection('result.fieldDefs', function (newVal, oldVal) {
	                if ($scope.result.fieldDefs && $scope.result.fieldDefs.length) {
	                    var fieldDefs = {};
	                    var queryFields= new Array();
	                    angular.forEach($scope.result.fieldDefs, function (field) {
	                        if (!$scope.options.fieldDefs[field.name]) {
	                            fieldDefs[field.name] = angular.copy(field);
	                        }
	                        else
	                            fieldDefs[field.name] = angular.copy(field);
	                        if (field.type == "lookup")
	                            $de.add(queryFields, field.nameField);
                            else
	                        $de.add(queryFields, field.name);
	                    })
	                    $scope.options.fields = queryFields.join(',');
	                    $scope.options.fieldDefs = fieldDefs;
	                    $scope.options.fields = $scope.options.fields.replace(/,$/, '');

	                    if ($scope.options.multiTable)
	                        $scope.multiTableList = $scope.result;
	                }
	            })

	            $scope.changeFieldLabel = function (field) {
	                $scope.options.fieldDefs[field.name] = field;
	            }
	            $scope.addPage = function (pageCount) {
	                if (pageCount == 0) {
	                    delete $scope.options.cToken;
	                    $scope.options.currentPage = 0;
	                }
	                $scope.changePage(parseInt($scope.options.currentPage) + pageCount);
	            }
	            $scope.baseUrl =
	            $scope.redirectLink = function (record, field) {
	                $scope.baseUrl = $engine.baseUrl;
	                $scope.record = record;
	                var url;
	                var text = $de.getValue(record, field.name);
	                if (field.type == 'lookup')
	                    text = $de.getValue(record, field.referenceByName ? (angular.isObject(record[field.name]) ? field.nameField : field.name) : field.nameField);
	                if (!text)
	                    url = '#';
	                else
	                     url = $interpolate(field.linkdetails.url)($scope);
	                //var target = field.linkdetails['target'] ? field.linkdetails['target'] : '_self';
	                return url;
	            }

	            $scope.saveCallback = function (field, callback) {
	                if (field.fields) {
	                    field.fields = field.fields.replace(/,$/, '');
	                    var fieldsToQuery = field.fields.split(',');
	                    for (iIndex = 0; iIndex < fieldsToQuery.length; iIndex++) {
	                        var flag = true;
	                        angular.forEach($scope.options.fields.split(','), function (key) {
	                            if (fieldsToQuery[iIndex].toLowerCase() == key.toLowerCase())
	                                flag = false;
	                        })
	                        if (flag)
	                            $scope.getfield({
	                                name: fieldsToQuery[iIndex],
	                                onsuccess: function (result) {
	                                    $scope.options.fields += ',' + result.field.name;
	                                    callback();

	                                },
	                                onerror: function (error) {
	                                    toaster.pop('error', fieldsToQuery[iIndex] + ' field not found ', error);
	                                    if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	                                }
	                            })
	                        else
	                            callback();
	                    }
	                }
	                else
	                    callback();
	                $scope.options.fieldDefs[fieldName] = field;

	            }

	            var fieldName;
	            $scope.manageDisplayType = function (fieldIndex) {
	                fieldName = $scope.result.fieldDefs[fieldIndex].name;
	                deTableService.manageDisplayType(angular.copy($scope.options.fieldDefs[fieldName]), $scope.saveCallback)
	            }

	            $scope.callbackResponse = function (success, message) {
	                if (!success)
	                    toaster.pop('error', 'Relatedlist', message ? message : 'Success');
	                else {
	                    toaster.pop('success', 'Success', message = message ? message : '');
                        //$scope.isRefresh = !$scope.isRefresh;
                        $scope.$broadcast('relatedlist-refresh');
	                }
	               if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
	            }
	            $scope.singleRecord = "singleRecord";
	            $scope.multiRecords = "multiRecords";
	            $scope.takeSingleRecordAction = function (action, $event, record) {
	                if (action) {
	                    if (action.customFunction && typeof action.customFunction == 'string')
	                        eval('var execute = ' + action.customFunction + '(record,$scope.$parent, $scope.callbackResponse)');
	                    else if (action.onclick)
	                        action.onclick($event, action, { type: 'single-record', records: record }, $scope.callbackResponse);
	                }
	            }

	            $scope.takeMultiRecordAction = function (action, $event) {
	                if (action) {
	                    var selectedRecords = $filter('filter')($scope.result.records, { $selected: true });
	                    if (selectedRecords.length > 0 || action.name == "Create" || !action.isStandardAction) {
	                        if (action.customFunction && typeof action.customFunction == 'string')
	                            eval('var execute = ' + action.customFunction + '(selectedRecords,$scope.$parent, $scope.callbackResponse)');
	                        else if (action.onclick)
	                            action.onclick($event, action, { type: 'multi-record', records: selectedRecords }, $scope.callbackResponse);
	                    } else
	                        $scope.callbackResponse(false, 'No record selected.');
	                }
	            }

	            $scope.selectAll = function ($event, value) {
	                if ($scope.options.multiTable)
	                    angular.forEach(value, function (record) {
	                        $event.currentTarget.checked ? record.$selected = true : delete record.$selected;

	                    })
	                else
	                    angular.forEach($scope.result.records, function (record) {
	                        $event.currentTarget.checked ? record.$selected = true : delete record.$selected;
	                    })
	            }
	            $scope.selectSingle = function (index, value) {
	                if (!value){
	                    $scope.selAll = $scope.selAll ? !$scope.selAll : $scope.selAll;
	                    delete $scope.result.records[index].$selected;
	                }	                    
	                else if (!$scope.selAll) {
	                    var deSelectAll = true;
	                    for (var i = 0; i < $scope.result.records.length; ++i) {
	                        if (!$scope.result.records[i].$selected ) {
	                            deSelectAll = false;
	                        }
	                    }
	                    $scope.selAll = deSelectAll;
	                }	                
	            }

	            $scope.sortFieldsOrder = [];
	            $scope.sortFieldsMap = {};
	            $scope.sort = function ($event, field) {
	                if (!$event.ctrlKey) {
	                    var existing = $scope.sortFieldsMap[field.name];
	                    $scope.sortFieldsOrder = [];
	                    $scope.sortFieldsMap = {};
	                    if (existing) {
	                        $scope.sortFieldsMap[field.name] = existing;
	                        $scope.sortFieldsOrder.push(field.name);
	                    }
	                }

	                if ($scope.sortFieldsMap[field.name]) {
	                    $scope.sortFieldsMap[field.name] = (($scope.sortFieldsMap[field.name] == 'asc') ? 'desc' : 'asc');
	                }
	                else {
	                    $scope.sortFieldsMap[field.name] = 'asc';
	                    $scope.sortFieldsOrder.push(field.name);
	                }

	                $scope.options.orderBy = '';
	                angular.forEach($scope.sortFieldsOrder, function (field) {
	                    $scope.options.orderBy += field + ' ' + $scope.sortFieldsMap[field] + ',';
	                })
	                $scope.options.orderBy = $scope.options.orderBy.replace(/,$/, '');
	                $scope.refreshData();
	            }


	            //Code for multiple tables
	                $scope.tableList = function () {
	                    var recordsPerList = Math.ceil($scope.result.records.length / $scope.tableCount);
	                    var tableCountCheck = Math.ceil($scope.result.records.length / recordsPerList);
	                    if (tableCountCheck < $scope.tableCount) {
	                        $scope.tableCount = tableCountCheck;
	                        $scope.colNo = Math.floor(12 / $scope.tableCount);
	                    }	                    
	                    $scope.tables = {};
	                    for (var i = 0, index = 0; i < $scope.tableCount; i++) {
	                        $scope.tables['Table_List_' + i] = $scope.result.records.slice(index, (index + recordsPerList));
	                        index = index + recordsPerList;
	                    }
	                    if ($scope.colNo != $scope.oldColNo)
	                        $scope.showMultiTable = false;
	                    $scope.showMultiTable = true;
	                }
	                $scope.multiTableCal = function () {
	                    $scope.parentWidth = $element.width();
	                    var fieldCount = $scope.result.fieldDefs.length;
	                    $scope.tableWidth = (fieldCount * 150)
	                    //if ($scope.options.saveMode == "record")
	                        $scope.tableWidth +=80;
	                    $scope.tableCount = Math.floor(($scope.parentWidth - 20) / $scope.tableWidth);
	                    if ($scope.tableCount == 0)
	                        $scope.tableCount = 1;
	                    else if ($scope.tableCount > $scope.result.records.length)
	                        $scope.tableCount = $scope.result.records.length;
	                    $scope.oldColNo = $scope.colNo;
	                    $scope.colNo = Math.floor(12 / $scope.tableCount);
	                }	                
	            

	            $scope.$watch('multiTableList', function () {
	                if ($scope.result.records && $scope.tableList) {
	                    $scope.tableList();
	                }
	            })

	            //Code for multiple tables
	            if ($scope.options.multiTable && !$scope.designMode)
	                var templateUrl = window.templatesFolder + 'multi-table.htm';
	            else
	                var templateUrl = window.templatesFolder + 'relatedlist' + (($scope.designMode) ? '-design' : '') + '.htm';

	            $templateRequest(templateUrl).then(function (template) {
	                template = template.replace('{!mobileTitle}', $scope.options.mobileTitle);
	                $compile($element.html(template).contents())($scope);
	            }, function () {
	                // An error has occurred
	            });
	        }]
	    }
	})
	.directive('manageDisplayType', function () {
	    return {
	        templateUrl: window.templatesFolder + 'manage-field-display.htm',
	        controller: ['$scope', function ($scope) {


	            $scope.save = function (field) {
	                if (!field.template)
	                    delete field.template;
	                if (field.displayType == 'text')
	                    delete field.linkdetails;
	                $scope.component.save(field);
	            }
	        }]
	    }
	})
    .directive('deConfirmButton', function ($document, $parse) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                deConfirmAction: '&deConfirmButton',
                placementCallback: '&'
            },
            link: function (scope, element, attrs) {
                var buttonId = Math.floor(Math.random() * 10000000000),
                    message = attrs.message || "Are you sure?",
                    yep = attrs.yes || "Yes",
                    nope = attrs.no || "No",
                    title = attrs.title || "Confirm",
                    classes = attrs.classes || "",
                    placement = attrs.placement || "bottom";

                attrs.buttonId = buttonId;

                var html = "<div id=\"button-" + buttonId + "\" class=\"" + classes + "\">" +
                                "<p class=\"confirmbutton-msg\">" + message + "</p>" +
                                "<div class=\"row\"><button class=\"confirmbutton-yes col-sm-5 col-md-5 btn btn-sm btn-danger \" style=\"margin:5px \">" + yep + " <i class='glyphicon glyphicon-ok'></i></button>" +
                                "<button class=\"confirmbutton-no col-sm-5 col-md-5 btn btn-sm pull-right\" style=\"margin:5px \">" + nope + "<i class='glyphicon glyphicon-remove'></button></div>" +
                            "</div>";

                element.popover({
                    content: html,
                    html: true,
                    trigger: "manual",
                    title: title,
                    placement: (angular.isDefined(attrs.placementCallback) ? scope.placementCallback() : placement)
                });

                element.bind('click', function (e) {
                    var dontBubble = true;
                    e.stopPropagation();

                    element.popover('show');

                    var pop = $("#button-" + buttonId);

                    pop.closest(".popover").click(function (e) {
                        if (dontBubble) {
                            e.stopPropagation();
                        }
                    });

                    pop.find('.confirmbutton-yes').click(function (e) {
                        dontBubble = false;
                        scope.$apply(scope.deConfirmAction);
                    });

                    pop.find('.confirmbutton-no').click(function (e) {
                        dontBubble = false;
                        $document.off('click.confirmbutton.' + buttonId);
                        element.popover('hide');
                    });

                    $document.on('click.confirmbutton.' + buttonId, ":not(.popover, .popover *)", function () {
                        $document.off('click.confirmbutton.' + buttonId);
                        element.popover('hide');
                    });
                });
            },
            template: '<button class="btn btn-danger btn-sm" ><span class="glyphicon glyphicon-trash"></span></button>',
        }

    })