﻿var Platform = {};
Platform.PlatformApiUrl = null;
Platform.ApiVersion = null;
Platform.ApiConroller = null;
var responseToResult = function (response, isSuccess) {
    var result = {};
    if (isSuccess)
        result = Result.successWithData(response.data);
    else
        result = Result.failWithErrorMessage(response.statusText);

    result.status = response.status;
    result["response"] = response;
    result["headers"] = response.headers;
    result["config"] = response.config
    return result;
};

var modulePlatform = angular.module('platform', []);
modulePlatform.factory('platform', ['$http', function ($http) {
    return {       
        get: function (url, successFn, errorFn) {
            $http.get(url)
            .then(function success(response) {
                successFn(responseToResult(response, true));
            }, function error(response) {
                errorFn(responseToResult(response));
            });
        },
        post: function (url, data, successFn, errorFn) {
            $http.post(url, data)
            .then(function success(response) {
                successFn(responseToResult(response, true));
            }, function error(response) {
                errorFn(responseToResult(response));
            });
        },
        delete: function (record, successFn, errorFn) {
            this.post(Platform.PlatformApiUrl + '/api/' + Platform.ApiVersion + '/' + Platform.ApiConroller, {
                action: "Delete", Data: record
            }, successFn, errorFn);
        },
        erase: function (record, successFn, errorFn) {
            this.post(Platform.PlatformApiUrl + '/api/' + Platform.ApiVersion + '/'+ Platform.ApiConroller, {
                action: "Erase", Data: record
            }, successFn, errorFn);
        },
        create: function (records, bAllOrNone, successFn, errorFn) {
            this.post(Platform.PlatformApiUrl + '/api/' + Platform.ApiVersion + '/' + Platform.ApiConroller, {
                action: "Create", Data: records, Parameters: { AllOrNone: (bAllOrNone) ? true : false }
            }, successFn, errorFn);
        },
        update: function (records, bAllOrNone, successFn, errorFn) {
            this.post(Platform.PlatformApiUrl + '/api/' + Platform.ApiVersion + '/' + Platform.ApiConroller, {
                action: "Update", Data: records, Parameters: { AllOrNone: (bAllOrNone) ? true : false }
            }, successFn, errorFn);
        },
        upsert: function (records, bAllOrNone, successFn, errorFn) {
            this.post(Platform.PlatformApiUrl + '/api/' + Platform.ApiVersion + '/' + Platform.ApiConroller, {
                action: "Upsert", Data: records, Parameters: { AllOrNone: (bAllOrNone) ? true : false }
            }, successFn, errorFn);
        },
        getField: function (strObjectName, strFieldName, successFn, errorFn) {
            this.get(Platform.PlatformApiUrl + '/api/' + Platform.ApiVersion + '/' + Platform.ApiConroller + '?action=getfielddef&object=' + strObjectName + '&field=' + strFieldName, successFn, errorFn);
        },
        getFields: function (strObjectName, successFn, errorFn) {
            this.get(Platform.PlatformApiUrl + '/api/' + Platform.ApiVersion + '/' + Platform.ApiConroller + '?action=getfielddef&object=' + strObjectName, successFn, errorFn);
        },
        getObject: function (strObjectName, successFn, options) {
            this.get(Platform.PlatformApiUrl + '/api/' + Platform.ApiVersion + '/' + Platform.ApiConroller + '?action=getobjectdef&object=' + strObjectName, successFn, errorFn);
        },
        query: function (query, successFn, options) {
            this.get(Platform.PlatformApiUrl + '/api/' + Platform.ApiVersion + '/' + Platform.ApiConroller + '?query=' + query, successFn, options);
        },
        login: function (event, formId, successFn, errorFn, options) {
            var form = $(event.currentTarget).parent('form');
            if (form.length == 0) {
                form = $("#" + formId);
            }
            $.ajax(form.attr("action"), {
                data: form.serialize(),
                type: form.attr("method"),
                success: function (data, status, xhr) {
                    if (data.Success) {
                        successFn(Result.successWithData(data));
                    }
                    else
                        errorFn(Result.failWithErrorMessage(data.ErrorMessage));
                },
                error: function (xhr, status, error) {
                    errorFn(Result.failWithErrorMessage('[' + status + ']' + error));
                },
            });
        },
    };
}])