﻿//var strBaseURL = "http://192.168.192.152/sforce/services20/multipart/";
var enzigma = enzigma || {};
enzigma.business = enzigma.business || {};
enzigma.business.restClient = {
    getXMLHttpRequest: function () {
        if (window.XMLHttpRequest) {
            return new XMLHttpRequest();
        }
        else {
            try {
                return new ActiveXObject("MSXML2.XMLHTTP.3.0");
            }
            catch (ex) {
                return null;
            }
        }
    },
    uploadPartToAmazon: function (result, fileIndex, blob, callbackInstance, callbackfunction) {
        // call amazon initmultipart 
        var method = "PUT";
        var strBucketName = result.Bucket, strUniqueFileName = result.FileName, dthttpDate = result.HttpDate;

        var urlwitBucket = enzigma.business.amazonstorage.getBucketwithFileUrl(strBucketName, strUniqueFileName);
        urlwitBucket += "partNumber=" + result.PartNumber + "&uploadId=" + result.UploadId;
        var xhr = new XMLHttpRequest();
        debugger;
        xhr.open(method, urlwitBucket, true);
        xhr.setRequestHeader("x-amz-date", dthttpDate);
        xhr.setRequestHeader("Authorization", result.Sign);
        xhr.setRequestHeader("Action", "UploadPart");
        xhr.upload.addEventListener('progress', function (e) {
            var percent = parseInt(e.loaded / e.total * 100);
            callbackInstance.thread.partPercent = percent;
            enzigma.business.progressbar.update(callbackInstance.thread.uploader, callbackInstance.thread.threadNumber, callbackInstance.thread.lastPartUploadedThreadIndex, callbackInstance.thread.parts.length, percent);
        }, false);
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4) {
                if (xhr.status == 200) {
                    var header = xhr.getResponseHeader("ETag");
                    if (callbackfunction) {
                        if (typeof (callbackfunction) === 'function' && header) {
                            callbackfunction.call(callbackInstance, header);
                        }
                    }
                } else if (xhr.status == 400) {
                    enzigma.business.progressbar.setStatus(xhr.responseText, callbackInstance.thread.uploader);
                }

            }
            /* else
            window.debug("xhr state ->" + xhr.readyState);*/
        }
        xhr.send(blob);

    },
    completeAmazonMultipart: function (result, xmlrequest, callbackInstance, callbackfunction) {
        // call amazon completedmultipart upload 
        var method = "POST";
        //window.debug(xmlrequest);
        var strBucketName = result.Bucket, strUniqueFileName = result.FileName, dthttpDate = result.HttpDate;
        var urlwitBucket = enzigma.business.amazonstorage.getBucketwithFileUrl(strBucketName, strUniqueFileName);
        urlwitBucket += "uploadId=" + result.UploadId;
        var xhr = new XMLHttpRequest();
        debugger;
        xhr.open(method, urlwitBucket, true);
        xhr.setRequestHeader("x-amz-date", dthttpDate);
        xhr.setRequestHeader("Authorization", result.Sign);
        xhr.setRequestHeader("Action", "CompleteMultipartUpload");

        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4) {
                if (xhr.status == 200) {
                    if (typeof (callbackfunction) === 'function') {
                        callbackfunction.call(callbackInstance, xhr.responseText);
                    }
                }
                else if (xhr.status == 400) {
                    enzigma.business.progressbar.setStatus(xhr.responseText, callbackInstance);

                }
            }
            /* else
            window.debug("xhr state ->" + xhr.readyState);*/
        }
        xhr.send(xmlrequest);
    },
    signatureRequest: function (uploadData, fileIndex, signRequest, sfUrl, SessionId, callbackInstance, callbackfunction, strSFAttachId, baseUrl) {
        //callbackInstance.baseUrl;
        var strUrlpath = baseUrl + "services20/multipart/signature";
        var jsonString = JSON.stringify(signRequest);

        try {
            jQuery.ajax(strUrlpath, {
                type: "POST",
                contentType: 'application/json',
                headers: { 'x-sfsessionid': SessionId, 'x-sfurl': sfUrl },
                data: jsonString,
                crossDomain: true,
                success: function (result, textStatus, xmlReq) {
                    if (typeof result == "string")
                        result = jQuery.parseJSON(result);
                    if (result.Success) {
                        if (typeof (callbackfunction) === 'function') {

                            if (result.IsForCompleting)
                                enzigma.business.restClient.completeAmazonMultipart(result, uploadData, callbackInstance, callbackfunction);
                            else
                                enzigma.business.restClient.uploadPartToAmazon(result, fileIndex, uploadData, callbackInstance, callbackfunction);
                        }
                    }
                    else {
                        enzigma.business.progressbar.setStatus(result.Message, { SFAttachId: strSFAttachId });
                        //alert(result.Message);
                    }
                },
                dataType: "json"
            }
	    ).error(function (error) {
	        enzigma.business.progressbar.setStatus(error.responseText, { SFAttachId: strSFAttachId });

	    });
        } catch (error) {
            enzigma.business.progressbar.setStatus(error, { SFAttachId: strSFAttachId });
        }
    },
    initPartUpload: function (fileRequest, sfUrl, SessionId, callbackInstance, callbackfunction) {

        var strUrlpath = callbackInstance.baseUrl + "services20/multipart/initpartupload";
        var jsonString = JSON.stringify(fileRequest);
        try {
            jQuery.ajax(strUrlpath, {
                type: "POST",
                contentType: 'application/json',
                headers: { 'x-sfsessionid': SessionId, 'x-sfurl': sfUrl },
                data: jsonString,
                crossDomain: true,
                success: function (result, textStatus, xmlReq) {
                    if (result.Success) {
                        if (typeof (callbackfunction) === 'function') {
                            if (typeof result == "string")
                                result = jQuery.parseJSON(result);
                            // setValueAndId(callbackInstance, result);
                            callbackfunction.call(callbackInstance, result);
                        }
                    }
                    else {
                        enzigma.business.progressbar.setStatus(result.Message, callbackInstance);
                    }
                },
                dataType: "json"
            }
	    ).error(function (error) {
	        var strresponseText = error.responseText;
	        if (!strresponseText)
	            strresponseText = "Error !";
	        enzigma.business.progressbar.setStatus(strresponseText, callbackInstance);
	    });
        }
	catch (error) {
	    enzigma.business.progressbar.setStatus(error, callbackInstance);
        }
    },
    uploadPart: function (blob, sfUrl, fileIndex, SessionId, callbackInstance, callback) {
        //callbackInstance.thread.uploader.baseUrl;
        var strUrlpath = callbackInstance.thread.uploader.baseUrl + "services20/multipart/uploadfilepart?PartSize=";
        strUrlpath += callbackInstance.thread.uploader.partSize + "&FileName=" + callbackInstance.thread.uploader.ServerFileName + "&Guid=" + callbackInstance.thread.uploader.UploadId + "&PartNumber=" + callbackInstance.PartNumber;
        strUrlpath += "&Folder=" + callbackInstance.thread.uploader.Folder + "&ServerUploadId=" + callbackInstance.thread.uploader.ServerUploadID;
        var method = "POST";
        var xhr = new XMLHttpRequest();
        xhr.open(method, strUrlpath, true);
        xhr.setRequestHeader('Content-Type', 'application/octet-stream');
        xhr.setRequestHeader('x-sfsessionid', SessionId);
        xhr.setRequestHeader('x-sfurl', sfUrl);
        xhr.upload.addEventListener('progress', function (e) {
            var percent = parseInt(e.loaded / e.total * 100);
            callbackInstance.thread.partPercent = percent;
            enzigma.business.progressbar.update(callbackInstance.thread.uploader, callbackInstance.thread.threadNumber, callbackInstance.thread.lastPartUploadedThreadIndex, callbackInstance.thread.parts.length, percent);
        }, false);
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4) {
                if (xhr.status == 200) {
                    var result;
                    if ($.browser.mozilla)
                        result = $.xml2json(xhr.responseText);
                    else
                        result = eval('(' + xhr.responseText + ')');
                    if (result.Success) {
                        if (typeof (callback) === 'function') {
                            callback.call(callbackInstance, result);
                        }
                    }
                    else {
                        enzigma.business.progressbar.setStatus(result.Message, callbackInstance.thread.uploader);
                    }
                }
            }
        }
        xhr.send(blob);
    },
    completeMultipartUplod: function (completeResponse, sfUrl, SessionId, callbackInstance, callback) {

        var strUrlpath = callbackInstance.baseUrl + "services20/multipart/completeupload";
        var jsonString = JSON.stringify(completeResponse);
        jQuery.ajax(strUrlpath, {
            type: "POST",
            contentType: 'application/json',
            headers: { 'x-sfsessionid': SessionId, 'x-sfurl': sfUrl },
            data: jsonString,
            success: function (result, textStatus, xmlReq) {
                if (result.Success) {
                    localDB.remove('files', callbackInstance.strKey);
                    if (typeof (callback) === 'function') {
                        if (typeof result == "string")
                            result = jQuery.parseJSON(result);
                        callback(result);
                    }
                }
                enzigma.business.progressbar.remove("filesProgressBar", callbackInstance, result);
            },
            dataType: "json"
        }
	        ).error(function (error) {
	            var strresponseText = error.responseText;
	            if (!strresponseText)
	                strresponseText = "Error !";
	            enzigma.business.progressbar.setStatus(strresponseText, callbackInstance);
	        });

    },
    deleteAttachment: function (baseUrl, deleteRequest, sfUrl, SessionId, callback) {
        var strUrlPath = baseUrl + "services20/multipart/deleteattachment";
        var jsonString = JSON.stringify(deleteRequest);

        try {
            jQuery.ajax(strUrlPath, {
                type: 'POST',
                contentType: 'application/json; charset=utf-8',
                headers: { 'x-sfsessionid': SessionId, 'x-sfurl': sfUrl },
                data: jsonString,
                crossDomain: true,
                success: function (result, textStatus, xmlRequest) {
                    if (result) {
                        if (typeof (callback) === 'function') {
                            if (typeof result == "string")
                                result = jQuery.parseJSON(result);
                            callback(result);
                        }
                    }
                }
            }).error(function (error) {
                var strresponseText = error.responseText;
                if (!strresponseText)
                    strresponseText = "Error !";
                enzigma.business.progressbar.setStatus(strresponseText, { SFAttachId: deleteRequest.AttachId });
            });
        }
        catch (error) {
            enzigma.business.progressbar.setStatus(error, { SFAttachId: deleteRequest.AttachId });
        }
    },
    downloadAttachment: function (baseUrl, downlaodRequest, sfUrl, SessionId, callback) {
        var strUrlPath = baseUrl + "services20/multipart/downloadattachment";
        var jsonString = JSON.stringify(downlaodRequest);
        // window.debug(jsonString);
        try {
            jQuery.ajax(strUrlPath, {
                type: 'POST',
                contentType: 'application/json; charset=utf-8',
                headers: { 'x-sfsessionid': SessionId, 'x-sfurl': sfUrl },
                data: jsonString,
                crossDomain: true,
                success: function (result, textStatus, xmlRequest) {
                    if (result) {
                        if (callback) {
                            if (typeof (callback) === 'function') {
                                if (typeof result == "string")
                                    result = jQuery.parseJSON(result);
                                callback(result);
                            }
                        }
                    }
                }
            }).error(function (error) {
                var strresponseText = error.responseText;
                if (!strresponseText)
                    strresponseText = "Error !";
                enzigma.business.progressbar.setStatus(strresponseText, { SFAttachId: downlaodRequest.SFAttachId });
            });
        } catch (error) {
            enzigma.business.progressbar.setStatus(error, { SFAttachId: downlaodRequest.SFAttachId });
        }
    },
    validateservice: function (baseUrl, callback) {
        var strUrlPath = baseUrl + "services20/multipart/validateservice";
        try {
            jQuery.ajax(strUrlPath, {
                type: 'POST',
                contentType: 'application/json; charset=utf-8',
                crossDomain: true,
                success: function (result, textStatus, xmlRequest) {
                    if (result) {
                        if (typeof (callback) === 'function') {
                            if (typeof result == "string")
                                result = jQuery.parseJSON(result);
                            callback(result);
                        }
                    }
                }
            }).error(function (error) {
                var strresponseText = error.responseText;
                if (!strresponseText)
                    strresponseText = "Error !";
                callback(strresponseText);
            });
        }
        catch (error) {
            callback(error);
        }
    },
    checkDuplicate: function (fileRequest, sfUrl, SessionId, callbackInstance, callbackfunction) {
        var strUrlpath = callbackInstance.baseUrl + "services20/multipart/checkduplicate";
        var jsonString = JSON.stringify(fileRequest);
        try {
            jQuery.ajax(strUrlpath, {
                type: "POST",
                contentType: 'application/json',
                headers: { 'x-sfsessionid': SessionId, 'x-sfurl': sfUrl },
                data: jsonString,
                crossDomain: true,
                success: function (result, textStatus, xmlReq) {
                    if (result.Success) {
                        if (typeof (callbackfunction) === 'function') {
                            if (typeof result == "string")
                                result = jQuery.parseJSON(result);
                            if (result.IsExist)
                                enzigma.business.progressbar.setStatus(result.Message, callbackInstance);
                            else
                                callbackfunction.call(callbackInstance);
                        }
                    }
                    else {
                        enzigma.business.progressbar.setStatus(result.Message, callbackInstance);
                    }
                },
                dataType: "json"
            }
	    ).error(function (error) {
	        var strresponseText = error.responseText;
	        if (!strresponseText)
	            strresponseText = "Error !";
	        enzigma.business.progressbar.setStatus(strresponseText, callbackInstance);
	    });
        }
        catch (error) {
            enzigma.business.progressbar.setStatus(error, callbackInstance);
        }
    }
};
