﻿function File(readFile, onchunkread, onstart, onreadcomplete, onerror) {
    this.file = readFile;
    this.buffersize;// = 6*1024*1024; // 5*1024*1024 = 5242880
    this.start = 0;
    this.stop = 0;
    this.upto = 0;
    this.currentThread = 1;
    this.startcallback = onstart;
    this.chunkreadcallback = onchunkread;
    this.completecallback = onreadcomplete;
    this.errorcallback = onerror;
    this.cancelled = false;
    this.startTime = (new Date()).getTime();
    this.numberOfThread=0;
    this.prePartNumber = 0;
    this.abortRead = function () {
        this.cancelled = true;
    };
    this.remainsTime = function () {
        var currentTime = (new Date()).getTime();
        if (this.startTime) {
            var duration = (currentTime - startTime) / 1000;
            var totalTime = (duration / this.stop) * this.file.size;
            var remainsTime = totalTime - duration;
            if (remainsTime > 60)
                remainsTime = (remainsTime / 60);
              return remainsTime.toFixed(2);
          
        }
    };
    this.uploadingSpeed = function () {
        var currentTime = (new Date()).getTime();
        var oneMB = 1024 * 1024;
        if (this.startTime) {
            var duration = (currentTime - startTime) / 1000;
            var speedBps = (this.stop / duration).toFixed(2);
            if (speedBps > oneMB)
               return (speedBps / (oneMB)).toFixed(2) + ' MBps';
            else
                return (speedBps / 1024).toFixed(2) + ' KBps';
        }
    },
    this.fileSize = function () {
        var oneMB = 1024 * 1024;
        if (this.file) {
            var fileSize = 0;
            if (this.file.size > 1024 * 1024)
                fileSize = (Math.round(this.file.size * 100 / (oneMB)) / 100).toString() + 'MB';
            else
                fileSize = (Math.round(this.file.size * 100 / 1024) / 100).toString() + 'KB';
            return fileSize;
        }
    };
    this.totalPart = function () {
        if (this.file) {
            var totPartNumber = this.file.size / this.buffersize;
            if (totPartNumber) 
               totPartNumber = Math.ceil(totPartNumber);
            return totPartNumber;
        }
    };
    this.onerror = function () {
        this.stop = this.start;
        this.start = this.start - this.buffersize;
        this.cancelled = true;
    };
    this.resume = function () {
        this.cancelled = false;
        this.readNextChunk();
    };
   
    this.oncomplete = function (blob) {
        var fiveMB = 5 * 1024 * 1024;
        var threadPartSize = Math.ceil(this.file.size / this.numberOfThread);
        var threadTotalPart = Math.ceil(threadPartSize / this.buffersize);
        var remainsSize = this.upto - this.stop;
        var lastPartSize = Math.ceil(threadPartSize % this.buffersize);
        var percent = Math.round((this.stop / this.upto) * 100);
        //var percent = Math.round((this.stop / this.file.size) * 100);
        this.prePartNumber++;
        if ((this.upto - this.stop) < (fiveMB + this.buffersize) && this.currentThread != this.numberOfThread)
            this.buffersize += fiveMB;

        window.debug(this.prePartNumber);
        window.debug("Part Size -->>" + this.buffersize);
        //partNumber = Math.ceil(this.stop / this.buffersize);
        this.chunkreadcallback(this, this.prePartNumber, this.buffersize, percent, blob);
        
    };

    this.onloadstart = function (evt) {
        if (this.onstart)
            this.onstart(this, evt);
    };
    this.errorHandler = function (evt) {
        if (this.errorcallback)
            this.errorcallback(this, evt);
        else {
            try {
                switch (evt.target.error.code) {
                    case evt.target.error.NOT_FOUND_ERR:
                        alert('File Not Found!');
                        break;
                    case evt.target.error.NOT_READABLE_ERR:
                        alert('File is not readable');
                        break;
                    case evt.target.error.ABORT_ERR:
                        break; // noop
                    default:
                        alert('An error occurred reading this file.');
                };
            }
            catch (error) {
                window.debug(error);
            }
        }
    };

    this.updateProgress = function (evt) {
    };

    this.bind = function (func) {
        var obj = this;
        /*if (typeof (func) === 'function') {
            func.call(obj);
        }*/
        
        return function () {
            func.apply(obj, arguments);
        }
    };
    this.reader = new FileReader();
    this.reader.onerror = this.bind(this.errorHandler);
    this.reader.onprogress = this.bind(this.updateProgress);
    this.reader.onloadstart = this.bind(this.onloadstart);
    this.reader.onload = this.bind(this.oncomplete);

    this.readNextChunk = function (args) {
        // alert(args.Percentage);
        this.startTime = (new Date()).getTime();
        if (this.cancelled) {
            if (this.completecallback)
                this.completecallback(this);
            return;
        }
        if (this.stop < this.upto) {
            if (this.upto > this.stop + this.buffersize) {
                this.start = this.stop;
                this.stop = this.stop + this.buffersize;
            }
            else {
                this.start = this.stop;
                this.stop = this.upto;
            }
            var blob;
            debugger;
            if (this.file.slice) {
                blob = this.file.slice(this.start, this.stop);
            } else if (this.file.mozSlice) {
                blob = this.file.mozSlice(this.start, this.stop);
            }
            this.oncomplete(blob);
            //this.reader.readAsBinaryString(blob);
            //this.reader.readAsArrayBuffer(blob);
            //this.reader.readAsDataURL(blob);
            //this.reader.readAsText(blob);
        }
        else if (this.completecallback)
            this.completecallback(this);
    };
}